package nc.bs.arap.gathering.bgtask;

import java.util.Map;

import nc.bs.arap.bill.bgtask.AbstractNC63F4F5ToNCCF2F3;
import nc.bs.arap.gathering.bgtask.process.NC63F4ToNCCF2MakeBillProcess;
import nc.bs.pub.pa.PreAlertObject;
import nc.bs.pub.pa.PreAlertReturnType;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.log.arap.bill.WYNCCARAPLogger;
import nc.vo.pub.BusinessException;

/**
 * @Description: ̨ȡNC633ת[F4-Cxx-2 ڲλתˣշ]->NCCտ[F2-Cxx-01 տת]
 * 
 * @author л ̹԰ҵNCC
 * @date 2020-11-23
 * @version with NCC V2005
 */
@SuppressWarnings({"deprecation"})
public class PullNC63F4ToNCCF2TaskPlugin extends AbstractNC63F4F5ToNCCF2F3 implements IBackgroundWorkPlugin {
	
	@Override
	public PreAlertObject executeTask(BgWorkingContext context) throws BusinessException {
		String returnObj = "";
		Map<String,Integer> map = null;
		try {
			map = super.execute(new NC63F4ToNCCF2MakeBillProcess(), context);
		} catch (Exception e) {
			e.printStackTrace();
			WYNCCARAPLogger.log("PullNC63F4ToNCCF2TaskPlugin", "̨ȡNC63תNCCտ(ת)", e, "");
			returnObj = "쳣"+ e.getMessage();
		}
		returnObj = super.returnResultMsg(map,returnObj);
		PreAlertObject retObj = new PreAlertObject();
		retObj.setReturnType(PreAlertReturnType.RETURNMESSAGE);
		retObj.setMsgTitle("̨ȡNC63תNCCտ(ת)");
		retObj.setReturnObj(returnObj);
		context.setLogStr(returnObj);
		return retObj;
	}
	
}