package nc.bs.arap.util;

import nc.util.mmf.framework.base.MMValueConvert;
import nc.vo.arap.receivable.AggReceivableBillVO;
import nc.vo.arap.receivable.ReceivableBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public class RecSAPBillOperCheck{
	public static void checkBill(String eventtype,AggReceivableBillVO billVO) throws BusinessException{
		/**
		 * eventype:
		 * 1019ǰ
		 * 1005ɾǰ
		 * 1003޸ǰ
		 * 1021ǰ
		 */
		ReceivableBillVO headVo=billVO.getHeadVO();
		boolean issendsap=MMValueConvert.toUFBoolean(headVo.getDef7()).booleanValue();
		boolean issapconfirm=MMValueConvert.toUFBoolean(headVo.getDef8()).booleanValue();
		if("1019".equals(eventtype) && issendsap) {
			ExceptionUtils.wrappBusinessException("ãݵ桿ɹSAPӦˣӦύݺԶͨ˹ ");
		}
		if("1005".equals(eventtype) && issendsap) {
			ExceptionUtils.wrappBusinessException("ãݵ桿ɹSAPӦɾݴ棬Ƶݴ桿");
		}
		if("1003".equals(eventtype) && issendsap) {
			ExceptionUtils.wrappBusinessException("ãݵ桿ɹSAPӦ޸ģݴ棬Ƶݴ桿");
		}
		if("1021".equals(eventtype) && issapconfirm) {
			ExceptionUtils.wrappBusinessException("SAPϵͳЭͬȷϣȡ");
		}
	}
}
