package nc.pubitf.payablebill.yx;

import nc.bgy.erm.constants.EstateTypeConstant;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.impl.am.db.processor.CountProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.pubitf.payablebill.yx.IImagePubService;
import nc.vo.pub.BusinessException;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
/**
 * Ӱɼӿ
 * @author ll
 * @date 2021-05-27
 *
 */
public class ImageCommonUtil {
	
	private static IImagePubService iImagePubService = null;
	
	/**
	 * Ƶѯû
	 * @param cuserid
	 * @return
	 */
	public static String getUserCode(String cuserid) {
		String sql = new StringBuilder("select user_code")
				.append(" from sm_user a")
				.append(" where a.cuserid = '"+ cuserid +"'").toString();
		String result = "";
		try {
			result = (String) getDao().executeQuery(sql, new ColumnProcessor());
		} catch (DAOException e) {
			ExceptionUtils.wrappBusinessException("Ƶѯûʧ,ϵѹ!");
		}
		return result;
	}
	
	/**
	 * Ƶѯû
	 * @param cuserid
	 * @return
	 */
	public static String getUserName(String cuserid) {
		String sql = new StringBuilder("select user_name")
				.append(" from sm_user a")
				.append(" where a.cuserid = '"+ cuserid +"'").toString();
		String result = "";
		try {
			result = (String) getDao().executeQuery(sql, new ColumnProcessor());
		} catch (DAOException e) {
			ExceptionUtils.wrappBusinessException("Ƶѯûʧ,ϵѹ!");
		}
		return result;
	}
	
	/**
	 * ݲ֯ѯ˰ʶ
	 * @param pk_org ֯
	 * @return
	 */
	public static String getTaxPayerCode(String pk_org) {
		String sql = new StringBuilder("select taxpayercode")
				.append(" from org_financeorg ")
				.append(" where islastversion='Y' and pk_financeorg = '"+ pk_org +"'").toString();
		String result = "";
		try {
			result = (String) getDao().executeQuery(sql, new ColumnProcessor());
		} catch (DAOException e) {
			ExceptionUtils.wrappBusinessException("ݲ֯ѯ˰ʶʧ,ϵѹ!");
		}
		return result;
	}
	
	/**
	 * ֯ѯ˹˾
	 * @param pk_org ֯
	 * @return
	 */
	public static String getCorporationName(String pk_org) {
		String sql = new StringBuilder("select def19")
				.append(" from org_orgs_v a")
				.append(" where a.pk_org = '"+ pk_org +"'").toString();
		String result = "";
		try {
			result = (String) getDao().executeQuery(sql, new ColumnProcessor());
		} catch (DAOException e) {
			ExceptionUtils.wrappBusinessException("֯ѯ˹˾ʧ,ϵѹ!");
		}
		return result;
	}
	
	/**
	 * Ӱϵͳ״̬
	 * @param djlxbm 
	 * @param billid 
	 * @param status Ҫµ״̬
	 * @throws BusinessException
	 */
	public static void updateImageStatus(String djlxbm, String billid, String status) throws BusinessException {
		if((djlxbm.equals(EstateTypeConstant.WY_YGFYBXD)
				|| djlxbm.equals(EstateTypeConstant.WY_XEBXD)
				|| djlxbm.equals(EstateTypeConstant.WY_DWGWBXD)
				|| djlxbm.equals(EstateTypeConstant.WY_CLFBXD)) 
				&& isSendImage(billid)) {
			getiImagePubService().updateImageStatus(billid, status);
		}
		
	}
	
	/**
	 * ǷϴӰ
	 * @param billid
	 * @return
	 */
	public static boolean isSendImage(String billid){
		String sql = new StringBuilder("SELECT COUNT(*)")
				.append("  FROM IMG_TM_LOG")
				.append(" WHERE BILLID = '"+ billid +"'")
				.append(" AND TM_STATUS = 'S'")
				.append(" AND APICODE = 'IMAGE-NCC-ERM'").toString();
		try {
			Integer count = (Integer) getDao().executeQuery(sql, new CountProcessor());
			if(count != null && count > 0){
				return true;
			}
		} catch (DAOException e) {
			ExceptionUtils.wrappBusinessException("ѯǷϴӰϵͳʧ,ϵѹ!");
		}
		return false;
	}
	
	private static IImagePubService getiImagePubService() {
		if(null == iImagePubService) {
			iImagePubService = NCLocator.getInstance().lookup(IImagePubService.class);
		}
		return iImagePubService;
	}
	
	private static BaseDAO getDao() {
		return new BaseDAO();
	}
}
