package nc.vo.baseapp.image;

import nc.vo.pub.SuperVO;

public class ImageInvoiceHVO extends SuperVO{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * ͷ
	 */
	private String pk_invoice_h;
	
	/**
	 * ӰID
	 */
	private String imageId;

	/**
	 * ӰURL
	 */
	private String imageUrl;

	/**
	 * ƱID
	 */
	private String invoiceId;

	/**
	 * Ʊ
	 * 		s-ֵ˰ר÷Ʊ
	 * 		c-ֵ˰ͨƱ
	 * 		ce-ֵ˰ͨƱ
	 * 		cb-ֵ˰ͨƱ()
	 * 		ct-ֵ˰ͨƱ(ͨз)
	 * 		j-ͳһ۷Ʊ
	 * 		v-ͳһ۷Ʊ
	 * 		cj-ֵ˰ͨƱ(Ʊ)
	 * 		ju-ֵ˰ͨƱ(Ʊ)
	 * 		se-ֵ˰ר÷Ʊ
	 */
	private String invoiceType;

	/**
	 * ʶ
	 * 		ƱǷʶ 0 1
	 */
	private String isAdd;

	/**
	 * ޸ıʶ
	 * 		ƱǷ޸ıʶ 0 1
	 */
	private String isChange;

	/**
	 * ɨʱ(ʱ)
	 */
	private String scanTime;

	/**
	 * ɨid
	 */
	private String scanUserId;

	/**
	 * ɨ
	 */
	private String scanUserName;

	/**
	 * Ʊcode
	 * 		ֵ˰Ʊ: ticketInvoice
	 * 		Ʊ: ticketTrain
	 * 		⳵Ʊ: ticketTaxi
	 * 		Ʊ: ticketQuota
	 * 		ͨûƱ: ticketMachine
	 * 		ɻƱ: ticketPlane
	 * 		·ѷƱ: ticketToll
	 * 		ֳƱ: ticketUsedCar
	 * 		/Ʊ:ticketBus
	 * 		嵥:ticketSalesList
	 * 		:ticketAttachment
	 */
	private String ticketCode;
	
	// ֵ˰ƱֶΣticketInvoice
	/**
	 * ˰
	 */
	public String amountWithTax;
	
	/**
	 * ˰
	 */
	public String amountWithoutTax;
	
	/**
	 * տ
	 */
	private String cashierName;

	/**
	 * ϸ֤
	 */
	private String certificationNo;

	/**
	 * ˰ֱ
	 */
	private String chargeTaxAuthorityCode;

	/**
	 * ˰
	 */
	private String chargeTaxAuthorityName;

	/**
	 * У
	 */
	private String checkCode;

	/**
	 * 
	 */
	private String checkerName;

	/**
	 * 汸ע
	 */
	private String checkRemark;

	/**
	 * ̼쵥
	 */
	private String commodityInspectionNo;

	/**
	 * 
	 */
	private String dqCode;

	/**
	 * 
	 */
	private String dqName;

	/**
	 * 
	 */
	private String engineNo;

	/**
	 * ڱ
	 */
	private String importCertificateNo;

	/**
	 * Ʊ
	 */
	private String invoiceCode;

	/**
	 * Ʊ
	 */
	private String invoiceNo;

	/**
	 * Ʊ
	 * 		1-Ʊ2-ֿ
	 */
	private String invoiceSheet;

	/**
	 * Ʊ״̬
	 * 		(0-Ĭ 1- 2- 3- 4-ֺ 7-쳣 8-ʧ 9-ɾ)
	 */
	private String invoiceStatus;

	/**
	 * Ʊ
	 */
	private String invoicerName;

	/**
	 * Ƿ
	 * 		˰ִƱ0  1 
	 */
	private String isReplace;

	/**
	 * 
	 */
	private String machineCode;

	/**
	 * 
	 */
	private String maxCapacity;

	/**
	 * Ʊ
	 * 		yyyyMMdd
	 */
	private String paperDrewDate;

	/**
	 * ӰID
	 * 		ƱΪfj-ʱӰID
	 */
	private String parentImageId;

	/**
	 * 
	 */
	private String productionArea;

	/**
	 * ַ绰
	 */
	private String purchaserAddrTel;

	/**
	 * Ϣ
	 */
	private String purchaserBankNameAccount;

	/**
	 * 
	 */
	private String purchaserName;

	/**
	 * ˰
	 */
	private String purchaserTaxNo;

	/**
	 * Ʊע
	 */
	private String remark;

	/**
	 * ַ绰
	 */
	private String sellerAddrTel;

	/**
	 * Ϣ
	 */
	private String sellerBankNameAccount;

	/**
	 * 
	 */
	private String sellerName;

	/**
	 * ˰
	 */
	private String sellerTaxNo;

	/**
	 * ƱļURL
	 */
	private String sourceFileUrl;

	/**
	 * ⷢƱ
	 * 		ԵӷƱ0-Ĭ 1-ͨз 2-Ʒ 3
	 */
	private String specialInvoiceFlag;

	/**
	 * ˰
	 */
	private String taxAmount;

	/**
	 * ˰
	 */
	private String taxPaidProof;

	/**
	 * ˰
	 * 		ڻ˰ʵ
	 */
	private String taxRate;

	/**
	 * λ
	 */
	private String tonnage;

	/**
	 * Ʒ
	 */
	private String vehicleBrand;

	/**
	 * 
	 */
	private String vehicleNo;

	/**
	 * 
	 */
	private String vehicleType;

	/**
	 * ƱԤϢ
	 */
	private String warningInfo;
	
	// ƱֶΣticketTrain
	/**
	 * ƾ֤
	 */
	private String certificateNo;
	
	/**
	 * Ŀվ
	 */
	private String endStation;

	/**
	 * 
	 */
	private String name;

	/**
	 * ά
	 */
	private String qrcode;

	/**
	 * λ
	 */
	private String seat;

	/**
	 * λ
	 */
	private String seatType;

	/**
	 * 
	 * 		ʱ
	 */
	private String startDate;

	/**
	 * վ
	 */
	private String startStation;

	/**
	 * ʱ
	 */
	private String startTime;

	/**
	 * 
	 */
	private String trains;
//	public String amountWithTax;
//	private String invoiceNo;

	// ⳵ֶΣticketTaxi
	/**
	 * ³ʱ
	 */
	private String getOffTime;
	
	/**
	 * ϳʱ
	 */
	private String getOnTime;

	/**
	 * 
	 */
	private String mileage;
//	private String name;

	/**
	 * Ʊڵ
	 */
	private String place;
//	private String startDate;
//	private String amountWithTax;
//	private String invoiceCode;
//	private String invoiceNo;
	
	// ƱֶΣticketQuota
//	private String invoiceNo;
//	private String invoiceCode;
//	private String amountWithTax;
	
	// ɻƱֶΣticketPlane
	/**
	 * ۵λ
	 */
	private String agentCode;

	/**
	 * 񺽷չ
	 */
	private String caacDevelopmentFund;
//	private String checkCode;

	/**
	 * 
	 */
	private String dateOfIssue;

	/**
	 * ӿ͵
	 */
	private String eTicketNo;

	/**
	 * ǩע
	 */
	private String endorsements;

	/**
	 * Ʊ
	 */
	private String fare;

	/**
	 * ȼ͸ӷ
	 */
	private String fuelSurcharge;

	/**
	 * ֤
	 */
	private String idNo;

	/**
	 * ʾϢ
	 */
	private String information;

	/**
	 * շ
	 */
	private String insurance;

	/**
	 * λ
	 */
	private String issuedBy;

	/**
	 * ˿
	 */
	private String nameOfPassenger;

	/**
	 * ӡˢ
	 */
	private String serialNo;

	/**
	 * ˰
	 */
	private String tax;

	/**
	 * ܽ
	 */
	private String total;
	
	// ֶΣticketBus
	/**
	 * ˵λ
	 */
	private String carrier;
//	private String endStation;
//	private String name;
//	private String seat;
//	private String startDate;
//	private String startStation;
//	private String startTime;
//	private String trains;
//	private String purchaserName;
//	private String purchaserTaxNo;
//	private String invoiceNo;
//	private String invoiceCode;
//	private String amountWithTax;
	
	// ·ֶ
	/**
	 * 
	 */
	private String entrancePlace;

	/**
	 * 
	 */
	private String exitplace;

	/**
	 * ʽ
	 */
	private String payment;
//	private String startDate;

	/**
	 * ˳ʱ
	 */
	private String time;

	/**
	 * 
	 */
	private String tollLimit;

	/**
	 * 
	 */
	private String vehiclesType;

	/**
	 * 
	 */
	private String vehiclesWeight;
//	private String invoiceNo;
//	private String invoiceCode;
//	private String amountWithTax;

	// ֳƱֶ
	/**
	 * ߵַ
	 */
	private String auctioneersAddress;

	/**
	 * Ϣ
	 */
	private String auctioneersBankInfo;

	/**
	 * 
	 */
	private String auctioneersName;

	/**
	 * ˰
	 */
	private String auctioneersTaxNo;

	/**
	 * ߵ绰
	 */
	private String auctioneersTel;

	/**
	 * ƺ
	 */
	private String carNumber;

	/**
	 * 
	 */
	private String dpName;
//	private String dqCode;
//	private String machineCode;

	/**
	 * ע
	 */
	private String registrationNo;

	/**
	 * ֳгַ
	 */
	private String usedCarMarketAddress;

	/**
	 * ֳгϢ
	 */
	private String usedCarMarketBankInfo;

	/**
	 * ֳг
	 */
	private String usedCarMarketName;

	/**
	 * ֳг˰
	 */
	private String usedCarMarketTaxNo;

	/**
	 * ֳг绰
	 */
	private String usedCarMarketTel;
//	private String vehicleBrand;
//	private String vehicleNo;

	/**
	 * ص
	 */
	private String vehiclePlaceName;
//	private String vehicleType;
//	private String purchaserName;

	/**
	 * ַ
	 */
	private String purchaserAddress;
//	private String purchaserTaxNo;

	/**
	 * 绰
	 */
	private String purchaserTel;
//	private String sellerName;

	/**
	 * ַ
	 */
	private String sellerAddress;

	/**
	 * 
	 */
	private String sellerBankName;

	/**
	 * ˻
	 */
	private String sellerBankAccount;

	/**
	 * 绰
	 */
	private String sellerTel;
//	private String amountWithTax;
//	private String invoiceNo;
//	private String invoiceCode;
//	private String paperDrewDate;
//	private String invoiceSheet;

	/**
	 * 
	 */
	private String cipherText;
	
	
	// ͨûƱֶ
	/**
	 * ҵ
	 */
	private String category;

	/**
	 * 緢Ʊ
	 */
	private String networkNo;
//	private String invoiceNo;
//	private String invoiceCode;
//	private String purchaserName;
//	private String purchaserTaxNo;

	/**
	 * 
	 */
	private String purchaserCode;
//	private String purchaserAddrTel;
//	private String purchaserAddress;
//	private String purchaserTel;

	/**
	 * ˺
	 */
	private String purchaserBankInfo;

	/**
	 * 
	 */
	private String purchaserBankName;

	/**
	 * ˺
	 */
	private String purchaserBankAccount;
//	private String sellerName;
//	private String sellerTaxNo;

	/**
	 * Ӧ̴
	 */
	private String sellerCode;
//	private String sellerAddrTel;
//	private String sellerAddress;
//	private String sellerTel;

	/**
	 * ˺
	 */
	private String sellerBankInfo;
//	private String sellerBankName;
//	private String sellerBankAccount;
//	private String paperDrewDate;
//	private String checkCode;
//	private String invoiceSheet;

	/**
	 * տ
	 */
	private String payee;

	/**
	 * 
	 */
	private String recheck;

	/**
	 * Ʊ
	 */
	private String drawer;
//	private String remark;

	/**
	 * Ʊ
	 */
	private String invoiceDate;
//	private String cipherText;
//	private String amountWithTax;
//	private String taxAmount;
//	private String amountWithoutTax;
//	private String machineCode;

	/**
	 * Ƿ嵥
	 */
	private String isSalesList;

	// ӰֶΣticketAttachment
//	private String parentImageId;
	
	// 嵥ֶΣticketSalesList
//	private String invoiceNo;
//	private String invoiceCode;
//	private String purchaserName;
//	private String sellerName;

	/**
	 * Сƽ
	 */
	private String subAmountWithoutTax;

	/**
	 * С˰
	 */
	private String subTaxAmount;
//	private String paperDrewDate;
	
	
	/**
	 * ʱ
	 */
	private String ts;
	
	/**
	 * ɾʶ
	 */
	private int dr = 0;
	
	/**
	 * Զ1
	 */
	private String def1;
	
	/**
	 * Զ2
	 */
	private String def2;
	
	/**
	 * Զ3
	 */
	private String def3;
	
	/**
	 * Զ4
	 */
	private String def4;
	
	/**
	 * Զ5
	 */
	private String def5;
	
	/**
	 * Զ6
	 */
	private String def6;
	
	/**
	 * Զ7
	 */
	private String def7;
	
	/**
	 * Զ8
	 */
	private String def8;
	
	/**
	 * Զ9
	 */
	private String def9;
	
	/**
	 * Զ10
	 */
	private String def10;

	public String getPk_invoice_h() {
		return pk_invoice_h;
	}

	public void setPk_invoice_h(String pk_invoice_h) {
		this.pk_invoice_h = pk_invoice_h;
	}

	public String getImageId() {
		return imageId;
	}

	public void setImageId(String imageId) {
		this.imageId = imageId;
	}

	public String getImageUrl() {
		return imageUrl;
	}

	public void setImageUrl(String imageUrl) {
		this.imageUrl = imageUrl;
	}

	public String getInvoiceId() {
		return invoiceId;
	}

	public void setInvoiceId(String invoiceId) {
		this.invoiceId = invoiceId;
	}

	public String getInvoiceType() {
		return invoiceType;
	}

	public void setInvoiceType(String invoiceType) {
		this.invoiceType = invoiceType;
	}

	public String getIsAdd() {
		return isAdd;
	}

	public void setIsAdd(String isAdd) {
		this.isAdd = isAdd;
	}

	public String getIsChange() {
		return isChange;
	}

	public void setIsChange(String isChange) {
		this.isChange = isChange;
	}

	public String getScanTime() {
		return scanTime;
	}

	public void setScanTime(String scanTime) {
		this.scanTime = scanTime;
	}

	public String getScanUserId() {
		return scanUserId;
	}

	public void setScanUserId(String scanUserId) {
		this.scanUserId = scanUserId;
	}

	public String getScanUserName() {
		return scanUserName;
	}

	public void setScanUserName(String scanUserName) {
		this.scanUserName = scanUserName;
	}

	public String getTicketCode() {
		return ticketCode;
	}

	public void setTicketCode(String ticketCode) {
		this.ticketCode = ticketCode;
	}

	public String getAmountWithTax() {
		return amountWithTax;
	}

	public void setAmountWithTax(String amountWithTax) {
		this.amountWithTax = amountWithTax;
	}

	public String getAmountWithoutTax() {
		return amountWithoutTax;
	}

	public void setAmountWithoutTax(String amountWithoutTax) {
		this.amountWithoutTax = amountWithoutTax;
	}

	public String getCashierName() {
		return cashierName;
	}

	public void setCashierName(String cashierName) {
		this.cashierName = cashierName;
	}

	public String getCertificationNo() {
		return certificationNo;
	}

	public void setCertificationNo(String certificationNo) {
		this.certificationNo = certificationNo;
	}

	public String getChargeTaxAuthorityCode() {
		return chargeTaxAuthorityCode;
	}

	public void setChargeTaxAuthorityCode(String chargeTaxAuthorityCode) {
		this.chargeTaxAuthorityCode = chargeTaxAuthorityCode;
	}

	public String getChargeTaxAuthorityName() {
		return chargeTaxAuthorityName;
	}

	public void setChargeTaxAuthorityName(String chargeTaxAuthorityName) {
		this.chargeTaxAuthorityName = chargeTaxAuthorityName;
	}

	public String getCheckCode() {
		return checkCode;
	}

	public void setCheckCode(String checkCode) {
		this.checkCode = checkCode;
	}

	public String getCheckerName() {
		return checkerName;
	}

	public void setCheckerName(String checkerName) {
		this.checkerName = checkerName;
	}

	public String getCheckRemark() {
		return checkRemark;
	}

	public void setCheckRemark(String checkRemark) {
		this.checkRemark = checkRemark;
	}

	public String getCommodityInspectionNo() {
		return commodityInspectionNo;
	}

	public void setCommodityInspectionNo(String commodityInspectionNo) {
		this.commodityInspectionNo = commodityInspectionNo;
	}

	public String getDqCode() {
		return dqCode;
	}

	public void setDqCode(String dqCode) {
		this.dqCode = dqCode;
	}

	public String getDqName() {
		return dqName;
	}

	public void setDqName(String dqName) {
		this.dqName = dqName;
	}

	public String getEngineNo() {
		return engineNo;
	}

	public void setEngineNo(String engineNo) {
		this.engineNo = engineNo;
	}

	public String getImportCertificateNo() {
		return importCertificateNo;
	}

	public void setImportCertificateNo(String importCertificateNo) {
		this.importCertificateNo = importCertificateNo;
	}

	public String getInvoiceCode() {
		return invoiceCode;
	}

	public void setInvoiceCode(String invoiceCode) {
		this.invoiceCode = invoiceCode;
	}

	public String getInvoiceNo() {
		return invoiceNo;
	}

	public void setInvoiceNo(String invoiceNo) {
		this.invoiceNo = invoiceNo;
	}

	public String getInvoiceSheet() {
		return invoiceSheet;
	}

	public void setInvoiceSheet(String invoiceSheet) {
		this.invoiceSheet = invoiceSheet;
	}

	public String getInvoiceStatus() {
		return invoiceStatus;
	}

	public void setInvoiceStatus(String invoiceStatus) {
		this.invoiceStatus = invoiceStatus;
	}

	public String getInvoicerName() {
		return invoicerName;
	}

	public void setInvoicerName(String invoicerName) {
		this.invoicerName = invoicerName;
	}

	public String getIsReplace() {
		return isReplace;
	}

	public void setIsReplace(String isReplace) {
		this.isReplace = isReplace;
	}

	public String getMachineCode() {
		return machineCode;
	}

	public void setMachineCode(String machineCode) {
		this.machineCode = machineCode;
	}

	public String getMaxCapacity() {
		return maxCapacity;
	}

	public void setMaxCapacity(String maxCapacity) {
		this.maxCapacity = maxCapacity;
	}

	public String getPaperDrewDate() {
		return paperDrewDate;
	}

	public void setPaperDrewDate(String paperDrewDate) {
		this.paperDrewDate = paperDrewDate;
	}

	public String getParentImageId() {
		return parentImageId;
	}

	public void setParentImageId(String parentImageId) {
		this.parentImageId = parentImageId;
	}

	public String getProductionArea() {
		return productionArea;
	}

	public void setProductionArea(String productionArea) {
		this.productionArea = productionArea;
	}

	public String getPurchaserAddrTel() {
		return purchaserAddrTel;
	}

	public void setPurchaserAddrTel(String purchaserAddrTel) {
		this.purchaserAddrTel = purchaserAddrTel;
	}

	public String getPurchaserBankNameAccount() {
		return purchaserBankNameAccount;
	}

	public void setPurchaserBankNameAccount(String purchaserBankNameAccount) {
		this.purchaserBankNameAccount = purchaserBankNameAccount;
	}

	public String getPurchaserName() {
		return purchaserName;
	}

	public void setPurchaserName(String purchaserName) {
		this.purchaserName = purchaserName;
	}

	public String getPurchaserTaxNo() {
		return purchaserTaxNo;
	}

	public void setPurchaserTaxNo(String purchaserTaxNo) {
		this.purchaserTaxNo = purchaserTaxNo;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public String getSellerAddrTel() {
		return sellerAddrTel;
	}

	public void setSellerAddrTel(String sellerAddrTel) {
		this.sellerAddrTel = sellerAddrTel;
	}

	public String getSellerBankNameAccount() {
		return sellerBankNameAccount;
	}

	public void setSellerBankNameAccount(String sellerBankNameAccount) {
		this.sellerBankNameAccount = sellerBankNameAccount;
	}

	public String getSellerName() {
		return sellerName;
	}

	public void setSellerName(String sellerName) {
		this.sellerName = sellerName;
	}

	public String getSellerTaxNo() {
		return sellerTaxNo;
	}

	public void setSellerTaxNo(String sellerTaxNo) {
		this.sellerTaxNo = sellerTaxNo;
	}

	public String getSourceFileUrl() {
		return sourceFileUrl;
	}

	public void setSourceFileUrl(String sourceFileUrl) {
		this.sourceFileUrl = sourceFileUrl;
	}

	public String getSpecialInvoiceFlag() {
		return specialInvoiceFlag;
	}

	public void setSpecialInvoiceFlag(String specialInvoiceFlag) {
		this.specialInvoiceFlag = specialInvoiceFlag;
	}

	public String getTaxAmount() {
		return taxAmount;
	}

	public void setTaxAmount(String taxAmount) {
		this.taxAmount = taxAmount;
	}

	public String getTaxPaidProof() {
		return taxPaidProof;
	}

	public void setTaxPaidProof(String taxPaidProof) {
		this.taxPaidProof = taxPaidProof;
	}

	public String getTaxRate() {
		return taxRate;
	}

	public void setTaxRate(String taxRate) {
		this.taxRate = taxRate;
	}

	public String getTonnage() {
		return tonnage;
	}

	public void setTonnage(String tonnage) {
		this.tonnage = tonnage;
	}

	public String getVehicleBrand() {
		return vehicleBrand;
	}

	public void setVehicleBrand(String vehicleBrand) {
		this.vehicleBrand = vehicleBrand;
	}

	public String getVehicleNo() {
		return vehicleNo;
	}

	public void setVehicleNo(String vehicleNo) {
		this.vehicleNo = vehicleNo;
	}

	public String getVehicleType() {
		return vehicleType;
	}

	public void setVehicleType(String vehicleType) {
		this.vehicleType = vehicleType;
	}

	public String getWarningInfo() {
		return warningInfo;
	}

	public void setWarningInfo(String warningInfo) {
		this.warningInfo = warningInfo;
	}

	public String getCertificateNo() {
		return certificateNo;
	}

	public void setCertificateNo(String certificateNo) {
		this.certificateNo = certificateNo;
	}

	public String getEndStation() {
		return endStation;
	}

	public void setEndStation(String endStation) {
		this.endStation = endStation;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getQrcode() {
		return qrcode;
	}

	public void setQrcode(String qrcode) {
		this.qrcode = qrcode;
	}

	public String getSeat() {
		return seat;
	}

	public void setSeat(String seat) {
		this.seat = seat;
	}

	public String getSeatType() {
		return seatType;
	}

	public void setSeatType(String seatType) {
		this.seatType = seatType;
	}

	public String getStartDate() {
		return startDate;
	}

	public void setStartDate(String startDate) {
		this.startDate = startDate;
	}

	public String getStartStation() {
		return startStation;
	}

	public void setStartStation(String startStation) {
		this.startStation = startStation;
	}

	public String getStartTime() {
		return startTime;
	}

	public void setStartTime(String startTime) {
		this.startTime = startTime;
	}

	public String getTrains() {
		return trains;
	}

	public void setTrains(String trains) {
		this.trains = trains;
	}

	public String getGetOffTime() {
		return getOffTime;
	}

	public void setGetOffTime(String getOffTime) {
		this.getOffTime = getOffTime;
	}

	public String getGetOnTime() {
		return getOnTime;
	}

	public void setGetOnTime(String getOnTime) {
		this.getOnTime = getOnTime;
	}

	public String getMileage() {
		return mileage;
	}

	public void setMileage(String mileage) {
		this.mileage = mileage;
	}

	public String getPlace() {
		return place;
	}

	public void setPlace(String place) {
		this.place = place;
	}

	public String getAgentCode() {
		return agentCode;
	}

	public void setAgentCode(String agentCode) {
		this.agentCode = agentCode;
	}

	public String getCaacDevelopmentFund() {
		return caacDevelopmentFund;
	}

	public void setCaacDevelopmentFund(String caacDevelopmentFund) {
		this.caacDevelopmentFund = caacDevelopmentFund;
	}

	public String getDateOfIssue() {
		return dateOfIssue;
	}

	public void setDateOfIssue(String dateOfIssue) {
		this.dateOfIssue = dateOfIssue;
	}

	public String geteTicketNo() {
		return eTicketNo;
	}

	public void seteTicketNo(String eTicketNo) {
		this.eTicketNo = eTicketNo;
	}

	public String getEndorsements() {
		return endorsements;
	}

	public void setEndorsements(String endorsements) {
		this.endorsements = endorsements;
	}

	public String getFare() {
		return fare;
	}

	public void setFare(String fare) {
		this.fare = fare;
	}

	public String getFuelSurcharge() {
		return fuelSurcharge;
	}

	public void setFuelSurcharge(String fuelSurcharge) {
		this.fuelSurcharge = fuelSurcharge;
	}

	public String getIdNo() {
		return idNo;
	}

	public void setIdNo(String idNo) {
		this.idNo = idNo;
	}

	public String getInformation() {
		return information;
	}

	public void setInformation(String information) {
		this.information = information;
	}

	public String getInsurance() {
		return insurance;
	}

	public void setInsurance(String insurance) {
		this.insurance = insurance;
	}

	public String getIssuedBy() {
		return issuedBy;
	}

	public void setIssuedBy(String issuedBy) {
		this.issuedBy = issuedBy;
	}

	public String getNameOfPassenger() {
		return nameOfPassenger;
	}

	public void setNameOfPassenger(String nameOfPassenger) {
		this.nameOfPassenger = nameOfPassenger;
	}

	public String getSerialNo() {
		return serialNo;
	}

	public void setSerialNo(String serialNo) {
		this.serialNo = serialNo;
	}

	public String getTax() {
		return tax;
	}

	public void setTax(String tax) {
		this.tax = tax;
	}

	public String getTotal() {
		return total;
	}

	public void setTotal(String total) {
		this.total = total;
	}

	public String getCarrier() {
		return carrier;
	}

	public void setCarrier(String carrier) {
		this.carrier = carrier;
	}

	public String getEntrancePlace() {
		return entrancePlace;
	}

	public void setEntrancePlace(String entrancePlace) {
		this.entrancePlace = entrancePlace;
	}

	public String getExitplace() {
		return exitplace;
	}

	public void setExitplace(String exitplace) {
		this.exitplace = exitplace;
	}

	public String getPayment() {
		return payment;
	}

	public void setPayment(String payment) {
		this.payment = payment;
	}

	public String getTime() {
		return time;
	}

	public void setTime(String time) {
		this.time = time;
	}

	public String getTollLimit() {
		return tollLimit;
	}

	public void setTollLimit(String tollLimit) {
		this.tollLimit = tollLimit;
	}

	public String getVehiclesType() {
		return vehiclesType;
	}

	public void setVehiclesType(String vehiclesType) {
		this.vehiclesType = vehiclesType;
	}

	public String getVehiclesWeight() {
		return vehiclesWeight;
	}

	public void setVehiclesWeight(String vehiclesWeight) {
		this.vehiclesWeight = vehiclesWeight;
	}

	public String getAuctioneersAddress() {
		return auctioneersAddress;
	}

	public void setAuctioneersAddress(String auctioneersAddress) {
		this.auctioneersAddress = auctioneersAddress;
	}

	public String getAuctioneersBankInfo() {
		return auctioneersBankInfo;
	}

	public void setAuctioneersBankInfo(String auctioneersBankInfo) {
		this.auctioneersBankInfo = auctioneersBankInfo;
	}

	public String getAuctioneersName() {
		return auctioneersName;
	}

	public void setAuctioneersName(String auctioneersName) {
		this.auctioneersName = auctioneersName;
	}

	public String getAuctioneersTaxNo() {
		return auctioneersTaxNo;
	}

	public void setAuctioneersTaxNo(String auctioneersTaxNo) {
		this.auctioneersTaxNo = auctioneersTaxNo;
	}

	public String getAuctioneersTel() {
		return auctioneersTel;
	}

	public void setAuctioneersTel(String auctioneersTel) {
		this.auctioneersTel = auctioneersTel;
	}

	public String getCarNumber() {
		return carNumber;
	}

	public void setCarNumber(String carNumber) {
		this.carNumber = carNumber;
	}

	public String getDpName() {
		return dpName;
	}

	public void setDpName(String dpName) {
		this.dpName = dpName;
	}

	public String getRegistrationNo() {
		return registrationNo;
	}

	public void setRegistrationNo(String registrationNo) {
		this.registrationNo = registrationNo;
	}

	public String getUsedCarMarketAddress() {
		return usedCarMarketAddress;
	}

	public void setUsedCarMarketAddress(String usedCarMarketAddress) {
		this.usedCarMarketAddress = usedCarMarketAddress;
	}

	public String getUsedCarMarketBankInfo() {
		return usedCarMarketBankInfo;
	}

	public void setUsedCarMarketBankInfo(String usedCarMarketBankInfo) {
		this.usedCarMarketBankInfo = usedCarMarketBankInfo;
	}

	public String getUsedCarMarketName() {
		return usedCarMarketName;
	}

	public void setUsedCarMarketName(String usedCarMarketName) {
		this.usedCarMarketName = usedCarMarketName;
	}

	public String getUsedCarMarketTaxNo() {
		return usedCarMarketTaxNo;
	}

	public void setUsedCarMarketTaxNo(String usedCarMarketTaxNo) {
		this.usedCarMarketTaxNo = usedCarMarketTaxNo;
	}

	public String getUsedCarMarketTel() {
		return usedCarMarketTel;
	}

	public void setUsedCarMarketTel(String usedCarMarketTel) {
		this.usedCarMarketTel = usedCarMarketTel;
	}

	public String getVehiclePlaceName() {
		return vehiclePlaceName;
	}

	public void setVehiclePlaceName(String vehiclePlaceName) {
		this.vehiclePlaceName = vehiclePlaceName;
	}

	public String getPurchaserAddress() {
		return purchaserAddress;
	}

	public void setPurchaserAddress(String purchaserAddress) {
		this.purchaserAddress = purchaserAddress;
	}

	public String getPurchaserTel() {
		return purchaserTel;
	}

	public void setPurchaserTel(String purchaserTel) {
		this.purchaserTel = purchaserTel;
	}

	public String getSellerAddress() {
		return sellerAddress;
	}

	public void setSellerAddress(String sellerAddress) {
		this.sellerAddress = sellerAddress;
	}

	public String getSellerBankName() {
		return sellerBankName;
	}

	public void setSellerBankName(String sellerBankName) {
		this.sellerBankName = sellerBankName;
	}

	public String getSellerBankAccount() {
		return sellerBankAccount;
	}

	public void setSellerBankAccount(String sellerBankAccount) {
		this.sellerBankAccount = sellerBankAccount;
	}

	public String getSellerTel() {
		return sellerTel;
	}

	public void setSellerTel(String sellerTel) {
		this.sellerTel = sellerTel;
	}

	public String getCipherText() {
		return cipherText;
	}

	public void setCipherText(String cipherText) {
		this.cipherText = cipherText;
	}

	public String getCategory() {
		return category;
	}

	public void setCategory(String category) {
		this.category = category;
	}

	public String getNetworkNo() {
		return networkNo;
	}

	public void setNetworkNo(String networkNo) {
		this.networkNo = networkNo;
	}

	public String getPurchaserCode() {
		return purchaserCode;
	}

	public void setPurchaserCode(String purchaserCode) {
		this.purchaserCode = purchaserCode;
	}

	public String getPurchaserBankInfo() {
		return purchaserBankInfo;
	}

	public void setPurchaserBankInfo(String purchaserBankInfo) {
		this.purchaserBankInfo = purchaserBankInfo;
	}

	public String getPurchaserBankName() {
		return purchaserBankName;
	}

	public void setPurchaserBankName(String purchaserBankName) {
		this.purchaserBankName = purchaserBankName;
	}

	public String getPurchaserBankAccount() {
		return purchaserBankAccount;
	}

	public void setPurchaserBankAccount(String purchaserBankAccount) {
		this.purchaserBankAccount = purchaserBankAccount;
	}

	public String getSellerCode() {
		return sellerCode;
	}

	public void setSellerCode(String sellerCode) {
		this.sellerCode = sellerCode;
	}

	public String getSellerBankInfo() {
		return sellerBankInfo;
	}

	public void setSellerBankInfo(String sellerBankInfo) {
		this.sellerBankInfo = sellerBankInfo;
	}

	public String getPayee() {
		return payee;
	}

	public void setPayee(String payee) {
		this.payee = payee;
	}

	public String getRecheck() {
		return recheck;
	}

	public void setRecheck(String recheck) {
		this.recheck = recheck;
	}

	public String getDrawer() {
		return drawer;
	}

	public void setDrawer(String drawer) {
		this.drawer = drawer;
	}

	public String getInvoiceDate() {
		return invoiceDate;
	}

	public void setInvoiceDate(String invoiceDate) {
		this.invoiceDate = invoiceDate;
	}

	public String getIsSalesList() {
		return isSalesList;
	}

	public void setIsSalesList(String isSalesList) {
		this.isSalesList = isSalesList;
	}

	public String getSubAmountWithoutTax() {
		return subAmountWithoutTax;
	}

	public void setSubAmountWithoutTax(String subAmountWithoutTax) {
		this.subAmountWithoutTax = subAmountWithoutTax;
	}

	public String getSubTaxAmount() {
		return subTaxAmount;
	}

	public void setSubTaxAmount(String subTaxAmount) {
		this.subTaxAmount = subTaxAmount;
	}

	public String getTs() {
		return ts;
	}

	public void setTs(String ts) {
		this.ts = ts;
	}

	public int getDr() {
		return dr;
	}

	public void setDr(int dr) {
		this.dr = dr;
	}

	public String getDef1() {
		return def1;
	}

	public void setDef1(String def1) {
		this.def1 = def1;
	}

	public String getDef2() {
		return def2;
	}

	public void setDef2(String def2) {
		this.def2 = def2;
	}

	public String getDef3() {
		return def3;
	}

	public void setDef3(String def3) {
		this.def3 = def3;
	}

	public String getDef4() {
		return def4;
	}

	public void setDef4(String def4) {
		this.def4 = def4;
	}

	public String getDef5() {
		return def5;
	}

	public void setDef5(String def5) {
		this.def5 = def5;
	}

	public String getDef6() {
		return def6;
	}

	public void setDef6(String def6) {
		this.def6 = def6;
	}

	public String getDef7() {
		return def7;
	}

	public void setDef7(String def7) {
		this.def7 = def7;
	}

	public String getDef8() {
		return def8;
	}

	public void setDef8(String def8) {
		this.def8 = def8;
	}

	public String getDef9() {
		return def9;
	}

	public void setDef9(String def9) {
		this.def9 = def9;
	}

	public String getDef10() {
		return def10;
	}

	public void setDef10(String def10) {
		this.def10 = def10;
	}
	
	@Override
	public String getPKFieldName() {
		return "pk_invoice_h";
	}

	@Override
	public String getTableName() {
		return "image_invoice_h";
	} 
	

}
