package nc.ba.cmp.listener;

import java.util.Map;

import nc.bs.businessevent.BdUpdateEvent;
import nc.bs.businessevent.BusinessEvent;
import nc.bs.businessevent.IBusinessEvent;
import nc.bs.businessevent.IBusinessListener;
import nc.bs.dao.BaseDAO;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.cmp.settlement.SettlementAggVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDateTime;
/**
 *  㵥󣬸Уǩ
 * @author xug
 *
 */
public class GXPubCheckListener implements IBusinessListener {
	public void doAction(IBusinessEvent event) throws BusinessException {
		
		String souid = event.getSourceID();
		String type = event.getEventType();
		AggregatedValueObject[] bills = getBills(event);

		if("11bc9226-f881-46bd-b3bf-38a70424ac8b".equals(souid)){ //
//			ӦչӦյտתF2-Cxx-01	
//			ʸҵ F3-Cxx-D41
//			ҵԴF3-Cxx-W01
//          ˿۸ҵ F3-Cxx-W04
			
//			տҵF2-Cxx-D51
//			ɹ F3-Cxx-D42
//			ӦӦתF3-Cxx-D01 
			
//			տתտתû<ǩ
//			ʸҵҵԴɹ û <ǩ
			
//			տ û <ǩ		
//			ʣĶн<ǩڵУ   
			if("CMPsettleAfter".equals(type)){//
				for (AggregatedValueObject aggregatedValueObject : bills) {
					SettlementAggVO aggvo = (SettlementAggVO) aggregatedValueObject;
					String jsid = aggvo.getParentVO().getPrimaryKey();
//					String billcode = (String) aggvo.getParentVO().getAttributeValue("billcode");
					
					String sql = "SELECT * from v_gx_jscherk where PK_SETTLEMENT = '"+jsid+"' ";
							
					BaseDAO dao = new BaseDAO();
					
					Map<String,String> mapdata = (Map<String,String>) dao.executeQuery(sql, new MapProcessor());
					
					if(mapdata != null && mapdata.size() > 0) {
						
						String pk_tradetype = mapdata.get("pk_tradetype");
						String sprq = mapdata.get("sprq");
						String qzrq = mapdata.get("signdate");
						String jsrq = mapdata.get("settledate");
						String str1=sprq.substring(5,7);
						String str2=qzrq.substring(5,7);
						//տתտת>ǩ  
						if("F2-Cxx-01".equals(pk_tradetype)) {
							if(new UFDateTime(sprq).compareTo(new UFDateTime(qzrq))>0) {
								throw new BusinessException("տתڡܴڡǩڡ!");
							}
						}
//						ʸҵҵԴɹ >ǩ   
						else if("F3-Cxx-D41".equals(pk_tradetype) || "F3-Cxx-W01".equals(pk_tradetype)) {
							if(new UFDateTime(sprq).compareTo(new UFDateTime(qzrq))>0) {
								if("F3-Cxx-D41".equals(pk_tradetype)) {
									throw new BusinessException("ʸҵ,ڡܴڡǩڡ!");
								}else if ("F3-Cxx-W01".equals(pk_tradetype)) {
									throw new BusinessException("ҵԴ,ڡܴڡǩڡ!");
								}
							}
						}
//                      ˿۸ҵ >   update by hef
						else if("F3-Cxx-W04".equals(pk_tradetype)) {
							if(!str1.equals(str2)) {
								throw new BusinessException("뵥ڲͬ£쳣лϽǵ½ڻȷ·ٲ");
							}
						}
//						տ >ǩ	
						else if("F2-Cxx-D51".equals(pk_tradetype)) {
							if(new UFDateTime(jsrq).compareTo(new UFDateTime(qzrq))>0) {
								throw new BusinessException("տ ,ڡܴڡǩڡ!");
							}
						}
//						ʣĶ  >ǩ	 У	 ɹ F3-Cxx-D42  >ǩ	
						else if("F3-Cxx-D42".equals(pk_tradetype)) {
							if(new UFDateTime(jsrq).compareTo(new UFDateTime(qzrq))>0) {
								throw new BusinessException("ɹ ,ڡܴڡǩڡ!");
							}
						}
//						ӦӦתF3-Cxx-D01  >ǩ	
						else if("F3-Cxx-D01".equals(pk_tradetype)) {
							if(new UFDateTime(jsrq).compareTo(new UFDateTime(qzrq))>0) {
								throw new BusinessException("ת ,ڡܴڡǩڡ!");
							}
						}
					}
				}
				
			}
			
			if("CMPsignAfter".equals(type)) {//ǩֺ
				for (AggregatedValueObject aggregatedValueObject : bills) {
					SettlementAggVO aggvo = (SettlementAggVO) aggregatedValueObject;
					String jsid = aggvo.getParentVO().getPrimaryKey();
//					String billcode = (String) aggvo.getParentVO().getAttributeValue("billcode");
					
					String sql = "SELECT * from v_gx_jscherk where PK_SETTLEMENT = '"+jsid+"' ";
							
					BaseDAO dao = new BaseDAO();
					
					Map<String,String> mapdata = (Map<String,String>) dao.executeQuery(sql, new MapProcessor());
					
					if(mapdata != null && mapdata.size() > 0) {
						
						String pk_tradetype = mapdata.get("pk_tradetype");
						String sprq = mapdata.get("sprq");
						String qzrq = mapdata.get("signdate");
						String jsrq = mapdata.get("settledate");
						
						//տתտת>ǩ  
						if("F2-Cxx-01".equals(pk_tradetype)) {
							if(new UFDateTime(sprq).compareTo(new UFDateTime(qzrq))>0) {
								throw new BusinessException("տתڡܴڡǩڡ!");
							}
						}
//						ʸҵҵԴɹ >ǩ   
						else if("F3-Cxx-D41".equals(pk_tradetype) || "F3-Cxx-W01".equals(pk_tradetype)) {
							if(new UFDateTime(sprq).compareTo(new UFDateTime(qzrq))>0) {
								if("F3-Cxx-D41".equals(pk_tradetype)) {
									throw new BusinessException("ʸҵ,ڡܴڡǩڡ!");
								}else if ("F3-Cxx-W01".equals(pk_tradetype)) {
									throw new BusinessException("ҵԴ,ڡܴڡǩڡ!");
								}
							}
						}
//						տ >ǩ	
						else if("F2-Cxx-D51".equals(pk_tradetype)) {
							if(new UFDateTime(jsrq).compareTo(new UFDateTime(qzrq))>0) {
								throw new BusinessException("տ ,ڡܴڡǩڡ!");
							}
						}
//						ʣĶ  >ǩ	 У	 ɹ F3-Cxx-D42  >ǩ	
						else if("F3-Cxx-D42".equals(pk_tradetype)) {
							if(new UFDateTime(jsrq).compareTo(new UFDateTime(qzrq))>0) {
								throw new BusinessException("ɹ ,ڡܴڡǩڡ!");
							}
						}
//						ӦӦתF3-Cxx-D01  >ǩ	
						else if("F3-Cxx-D01".equals(pk_tradetype)) {
							if(new UFDateTime(jsrq).compareTo(new UFDateTime(qzrq))>0) {
								throw new BusinessException("ת ,ڡܴڡǩڡ!");
							}
						}
					}
				}
			
			}
		}
	}
	
	
	
	private AggregatedValueObject[] getBills(IBusinessEvent event)
	{
	  Object object = null;
	  if ((event instanceof BusinessEvent)) {
	    BusinessEvent e = (BusinessEvent)event;
	    object = e.getObject();
	  } else if ((event instanceof BdUpdateEvent)) {
	    BdUpdateEvent e = (BdUpdateEvent)event;
	    object = e.getNewObject();
	  }
	  
	  AggregatedValueObject[] bills = null;
	  if (null != object) {
	    if (object.getClass().isArray()) {
	      bills = (AggregatedValueObject[])object;
	    } else {
	      bills = new AggregatedValueObject[1];
	      bills[0] = ((AggregatedValueObject)object);
	    }
	  }
	  return bills;
	}
}
