package nc.util.fa.httputil;

import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class MD5Utils {
	static final char hexDigits[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
	static final char hexDigitsLower[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e',
			'f' };

	/**
	 * ַ MD5 ֵ
	 * 
	 * @param plainText Ҫַܵ
	 * @return MD5ܺ32λ(Сдĸ+)ַ
	 */
	public static String MD5Lower(String plainText) {
		try {
			// MD5ժҪ㷨 MessageDigest 
			MessageDigest md = MessageDigest.getInstance("MD5");

			// ʹָֽڸժҪ
			md.update(plainText.getBytes());

			// digest()ȷmd5 hashֵֵΪ8λַΪmd5 hashֵ16λhexֵʵϾ8λַ
			// BigInteger8λַת16λhexֵַʾõַʽhashֵ1 ̶ֵ
			return new BigInteger(1, md.digest()).toString(16);
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * ַ MD5 
	 * 
	 * @param plainText Ҫַܵ
	 * @return MD5ܺ32λ(дĸ+)ַ
	 */
	public static String MD5Upper(String plainText) {
		try {
			// MD5ժҪ㷨 MessageDigest 
			MessageDigest md = MessageDigest.getInstance("MD5");

			// ʹָֽڸժҪ
			md.update(plainText.getBytes());

			// 
			byte[] mdResult = md.digest();
			// תʮƵַʽ
			int j = mdResult.length;
			char str[] = new char[j * 2];
			int k = 0;
			for (int i = 0; i < j; i++) {
				byte byte0 = mdResult[i];
				str[k++] = hexDigits[byte0 >>> 4 & 0xf];// ȡֽи 4 λת, >>> Ϊ߼ƣλһ
				str[k++] = hexDigits[byte0 & 0xf]; // ȡֽе 4 λת
			}
			return new String(str);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * ַ MD5 ֵ
	 * 
	 * @param plainText Ҫַܵ
	 * @param saltValue Ҫӵֵ
	 * @return MD5ܺ32λ(Сдĸ+)ַ
	 */
	public static String MD5Lower(String plainText, String saltValue) {
		try {
			// MD5ժҪ㷨 MessageDigest 
			MessageDigest md = MessageDigest.getInstance("MD5");

			// ʹָֽڸժҪ
			md.update(plainText.getBytes());
			md.update(saltValue.getBytes());

			// digest()ȷmd5 hashֵֵΪ8λַΪmd5 hashֵ16λhexֵʵϾ8λַ
			// BigInteger8λַת16λhexֵַʾõַʽhashֵ1 ̶ֵ
			return new BigInteger(1, md.digest()).toString(16);
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * ַ MD5 ֵ
	 * 
	 * @param plainText Ҫַܵ
	 * @param saltValue Ҫӵֵ
	 * @return MD5ܺ32λ(дĸ+)ַ
	 */
	public static String MD5Upper(String plainText, String saltValue) {
		try {
			// MD5ժҪ㷨 MessageDigest 
			MessageDigest md = MessageDigest.getInstance("MD5");

			// ʹָֽڸժҪ
			md.update(plainText.getBytes());
			md.update(saltValue.getBytes());

			// 
			byte[] mdResult = md.digest();
			// תʮƵַʽ
			int j = mdResult.length;
			char str[] = new char[j * 2];
			int k = 0;
			for (int i = 0; i < j; i++) {
				byte byte0 = mdResult[i];
				str[k++] = hexDigits[byte0 >>> 4 & 0xf];
				str[k++] = hexDigits[byte0 & 0xf];
			}
			return new String(str);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * MD5ܺ32λ(Сдĸ+)ַ ͬ MD5Lower() һ
	 */
	public final static String MD5(String plainText) {
		try {
			MessageDigest mdTemp = MessageDigest.getInstance("MD5");

			mdTemp.update(plainText.getBytes("UTF-8"));

			byte[] md = mdTemp.digest();
			int j = md.length;
			char str[] = new char[j * 2];
			int k = 0;
			for (int i = 0; i < j; i++) {
				byte byte0 = md[i];
				str[k++] = hexDigitsLower[byte0 >>> 4 & 0xf];
				str[k++] = hexDigitsLower[byte0 & 0xf];
			}
			return new String(str);
		} catch (Exception e) {
			return null;
		}
	}

	/**
	 * УMD5
	 * 
	 * @param text ҪУַ
	 * @param md5  md5ֵ
	 * @return У
	 */
	public static boolean valid(String text, String md5) {
		return md5.equals(MD5(text)) || md5.equals(MD5(text).toUpperCase());
	}


}
