package nc.bs.pu.wgpt.bp;

import javax.servlet.http.HttpServletRequest;

import nc.bcmanage.bs.IBusiCenterManageService;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.comn.NetStreamContext;
import nc.bs.framework.core.util.ObjectCreator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.impl.wgpt.process.WuYeWgptBusiImpl;
import nc.net.servlet.IReturnStatus;
import nc.pubitf.para.SysInitQuery;
import nc.util.uap.wgpt.WuYeWgptUtil;
import nc.vo.esb.ResultEsbVO;
import nc.vo.esb.ResultVO;
import nc.vo.pub.BusinessException;
import nccloud.framework.core.exception.ExceptionUtils;
import uap.json.JSONObject;

/**
 * @Description: 
 * 
 * @author л ̹԰-ҵ-ƽ̨ӿڡ
 * @date 2019-3-6
 * @version with NC V6.3
 */
@SuppressWarnings("restriction")
public class WuYeWgptBP {
	/**
	 * ƽ̨->NCɹ+ƻ
	 * @param jsonobj
	 * @return
	 */
	public String writeOrderInfo(final HttpServletRequest request) {
		try {
			initInvocationInfo();
			JSONObject jsonobj = WuYeWgptUtil.findPostJsonValue(request);// ȡPostֵ
			WuYeWgptBusiImpl wgptBusiImpl=(WuYeWgptBusiImpl) ObjectCreator.newInstance("nc.impl.wgpt.process.WuYeWgptBusiImpl");
			return wgptBusiImpl.writeOrderInfo(jsonobj);
//			return WuYeWgptUtil.getIWuYeWgptBusiService().writeOrderInfo(jsonobj);
		} catch (Exception e) {
			ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
			ResultVO result = new ResultVO();
			esb.setResultInfo(result);
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WuYeWgptUtil.getExceptionDetail(e));
			WuYeWgptUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
			String rsdata = com.alibaba.fastjson.JSONObject.toJSONString(esb);
			return rsdata;
		}
	}
	/**
	 * ƽ̨->NCرղɹ
	 * @param key
	 * @param billdata
	 * @return
	 */
	public String closeOrder(final HttpServletRequest request) {
		try {
			initInvocationInfo();
			JSONObject jsonobj = WuYeWgptUtil.findPostJsonValue(request);// ȡPostֵ
			return WuYeWgptUtil.getIWuYeWgptBusiService().closeOrder(jsonobj);
		} catch (Exception e) {
			ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
			ResultVO result = new ResultVO();
			esb.setResultInfo(result);
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WuYeWgptUtil.getExceptionDetail(e));
			WuYeWgptUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
			String rsdata = com.alibaba.fastjson.JSONObject.toJSONString(esb);
			return rsdata;
		}
	}
	/**
	 * ƽ̨->NC/޸ĲɹƱ
	 * @param key
	 * @param billdata
	 * @return
	 */
	public String writeInvoiceInfo(final HttpServletRequest request) {
		try {
			initInvocationInfo();
			JSONObject jsonobj = WuYeWgptUtil.findPostJsonValue(request);// ȡPostֵ
			return WuYeWgptUtil.getIWuYeWgptBusiService().writeInvoiceInfo(jsonobj);
		} catch (Exception e) {
			ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
			ResultVO result = new ResultVO();
			esb.setResultInfo(result);
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WuYeWgptUtil.getExceptionDetail(e));
			WuYeWgptUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
			String rsdata = com.alibaba.fastjson.JSONObject.toJSONString(esb);
			return rsdata;
		}
	}
	/**
	 * ƽ̨->NC¼ӵķɹƽ̨ѯ
	 * @author ҫ
	 * @time 2019-4-29
	 * @param request
	 * @return
	 */
	public String queryInventoryByCondition(HttpServletRequest request){
		try {
			initInvocationInfo();
			JSONObject jsonobj = WuYeWgptUtil.findPostJsonValue(request);// ȡPostֵ
			return WuYeWgptUtil.getIWuYeWgptBusiService().queryInventoryByCondition(jsonobj);
		} catch (Exception e) {
			ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
			ResultVO result = new ResultVO();
			esb.setResultInfo(result);
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WuYeWgptUtil.getExceptionDetail(e));
			WuYeWgptUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
			String rsdata = com.alibaba.fastjson.JSONObject.toJSONString(esb);
			return rsdata;
		}
	}
	
	/**ƽ̨->NC¼ӵķɹƽ̨Эͬɹ/˿
	 * @author ҫ
	 * @time 2019-7-15
	 * @param request
	 * @return
	 */
	public String writePurchaseinInfo(HttpServletRequest request){
		try {
			initInvocationInfo();
			JSONObject jsonobj = WuYeWgptUtil.findPostJsonValue(request);// ȡPostֵ
			return WuYeWgptUtil.getIWuYeWgptBusiService().writePurchaseinInfo(jsonobj);
		} catch (Exception e) {
			ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
			ResultVO result = new ResultVO();
			esb.setResultInfo(result);
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WuYeWgptUtil.getExceptionDetail(e));
			WuYeWgptUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
			String rsdata = com.alibaba.fastjson.JSONObject.toJSONString(esb);
			return rsdata;
		}
	}
	
	/**ƽ̨->NCĿѯӿ
	 * @author Ƽ
	 * @time 2020-11-05
	 * @param request
	 * @return
	 */
	public String queryProjectInfo(HttpServletRequest request){
		try {
			initInvocationInfo();
			JSONObject jsonobj = WuYeWgptUtil.findPostJsonValue(request);// ȡPostֵ
			return WuYeWgptUtil.getIWuYeWgptBusiService().queryProjectInfo(jsonobj);
		} catch (Exception e) {
			ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
			ResultVO result = new ResultVO();
			esb.setResultInfo(result);
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WuYeWgptUtil.getExceptionDetail(e));
			WuYeWgptUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
			String rsdata = com.alibaba.fastjson.JSONObject.toJSONString(esb);
			return rsdata;
		}
	}
	
	/**̲ʾӿڸ죬Ԥָ
	 * @author ҫ
	 * @date 20201014
	 * @param request
	 * @return
	 */
	public String writePaybillRedInfo(HttpServletRequest request) {
		try {
			initInvocationInfo();
			JSONObject jsonobj = WuYeWgptUtil.findPostJsonValue(request);// ȡPostֵ
			return WuYeWgptUtil.getIWuYeWgptBusiService().writePaybillRedInfo(jsonobj);
		} catch (Exception e) {
			ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
			ResultVO result = new ResultVO();
			esb.setResultInfo(result);
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WuYeWgptUtil.getExceptionDetail(e));
			WuYeWgptUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
			String rsdata = com.alibaba.fastjson.JSONObject.toJSONString(esb);
			return rsdata;
		}
	}
	
	private void initInvocationInfo(){
		try {
			IBusiCenterManageService busiCenterManageService=NCLocator.getInstance().lookup(IBusiCenterManageService.class);
			InvocationInfoProxy.getInstance().setUserDataSource(busiCenterManageService.getAvailableBusiCenterDsNames()[0]);
			InvocationInfoProxy.getInstance().setGroupId(SysInitQuery.getParaString("GLOBLE00000000000000", "GROUP"));
			InvocationInfoProxy.getInstance().setUserId(SysInitQuery.getParaString("GLOBLE00000000000000", "WYBCUSER"));
		} catch (BusinessException e) {
			ExceptionUtils.wrapBusinessException(e.getMessage());
		}
		ISecurityTokenCallback tc = NCLocator.getInstance().lookup(ISecurityTokenCallback.class);
		byte[] token = tc.token("__system".getBytes(), "NC".getBytes());
		NetStreamContext.setToken(token);
	}
	
}
