package nc.bs.pu.wgpt.process;

import java.util.List;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.impl.pubapp.env.BSContext;
import nc.itf.pu.m21.IOrderClose;
import nc.itf.pubapp.pub.smart.IBillQueryService;
import nc.itf.uap.pf.IPFWorkflowQry;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.net.servlet.IReturnStatus;
import nc.pubitf.arap.pay.IArapPayBillPubQueryService;
import nc.pubitf.arap.pay.IArapPayBillPubService;
import nc.util.mmf.framework.base.MMValueCheck;
import nc.util.uap.wgpt.WuYeWgptUtil;
import nc.vo.arap.pay.AggPayBillVO;
import nc.vo.esb.ResultEsbVO;
import nc.vo.esb.ResultVO;
import nc.vo.pu.m21.entity.OrderVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.wgpt.log.WuYeWgptLogVO;
import nccloud.commons.collections.CollectionUtils;

import uap.json.JSONObject;

/**
 * @Description: ƽ̨->NCرղɹ
 * 
 * @author л ̹԰-ҵ-ƽ̨ӿڡ
 * @date 2019-3-6
 * @version with NCC
 */
public class CloseOrderProcess {

	@SuppressWarnings("unchecked")
	public String closeOrder(JSONObject jsonobj) throws BusinessException {
		String rsdata = null;
		String nc_id = null;
		Object orderno = null;
		ResultEsbVO<ResultVO> esb = new ResultEsbVO<ResultVO>();
		ResultVO result = new ResultVO();
		com.alibaba.fastjson.JSONObject resultJsonObject=new com.alibaba.fastjson.JSONObject();
		resultJsonObject.put("state", "0");
		result.setResult(resultJsonObject);
		esb.setResultInfo(result);
		try {
			if (jsonobj == null || "".equals(jsonobj)) {// Postύֵ
				result.setCode(IReturnStatus.FAILING);// ʧ
				result.setMessage("PostύJsonʽֵ!");
				WuYeWgptUtil.createResultEsbVO(esb);
				esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_FAILING);
				esb.getEsbInfo().setReturnMsg("ʧ");
				esb.setResultInfo(result);
			} else {
				orderno = jsonobj.getJSONObject("requestInfo").get("orderno");
				BaseDAO baseDAO = new BaseDAO();
				String sql = "select pk_order from po_order where nvl(dr,0)=0 and vdef15='"+ orderno +"'";
				List<String> pkOrders = (List<String>) baseDAO.executeQuery(sql, new ColumnListProcessor());
				if (CollectionUtils.isEmpty(pkOrders)) {
					throw new BusinessException("ûиòɹ" + orderno + "");
				}
				if (pkOrders.size() > 1) {
					throw new BusinessException("NC" + pkOrders.size() + "Ŷ" + orderno + "");
				}
				nc_id = pkOrders.get(0);
				IBillQueryService billQuery = NCLocator.getInstance().lookup(IBillQueryService.class);
				OrderVO orderVO = billQuery.querySingleBillByPk(OrderVO.class, nc_id);
				orderVO.getHVO().setVdef31(UFBoolean.TRUE.toString());
				IOrderClose closeService = NCLocator.getInstance().lookup(IOrderClose.class);
				IPFWorkflowQry workflowQry=NCLocator.getInstance().lookup(IPFWorkflowQry.class);
				IArapPayBillPubQueryService payBillPubQueryService=NCLocator.getInstance().lookup(IArapPayBillPubQueryService.class);
				IArapPayBillPubService payBillPubService=NCLocator.getInstance().lookup(IArapPayBillPubService.class);
				AggPayBillVO[] aggPayBillVOs=payBillPubQueryService.queryVOsByWhere("pk_paybill in (select pi.pk_paybill from ap_payitem pi where pi.top_billid ='"+nc_id+"' and nvl(dr,0)=0)  and  money>0  and  nvl(dr,0)=0");
				InvocationInfoProxy.getInstance().setProperty("iswgptsend", "Y");
				BSContext.getInstance().setSession("iswgptsend", "Y");
				if(MMValueCheck.isEmpty(aggPayBillVOs)) {
					closeService.close(new OrderVO[] { orderVO }, 0, true);
					resultJsonObject.put("state","3");
					result.setCode(IReturnStatus.SUCCEED);// ɹ
					result.setMessage("ɹ" + orderno + "رճɹ");
				}else {
					boolean  isApproveFlowStartup=workflowQry.isApproveFlowStartup(aggPayBillVOs[0].getHeadVO().getPk_paybill(), aggPayBillVOs[0].getHeadVO().getPk_tradetype());
					//Ԥ״̬Ϊ̬ɾԤرն
					if(!isApproveFlowStartup && (aggPayBillVOs[0].getHeadVO().getBillstatus()==-1 || aggPayBillVOs[0].getHeadVO().getBillstatus()==-99)) {
						InvocationInfoProxy.getInstance().setProperty("iswgptsend", "Y");
						BSContext.getInstance().setSession("iswgptsend", "Y");
						
						payBillPubService.delete(aggPayBillVOs);
						orderVO = billQuery.querySingleBillByPk(OrderVO.class, nc_id);
						closeService.close(new OrderVO[] { orderVO }, 0, true);
						resultJsonObject.put("state","4");
						result.setCode(IReturnStatus.SUCCEED);// ɹ
						result.setMessage("ɹ" + orderno + "رճɹ");
					}else {
						int settleflag=ValueUtils.getInt(aggPayBillVOs[0].getHeadVO().getSettleflag(), 0);
						if(settleflag==1) {
							resultJsonObject.put("state","2");
							result.setCode(IReturnStatus.FAILING);// ɹ
							result.setMessage(""+orderno+"֧Ԥδرաȷյ˿󶩵Զر");
						}else {
							resultJsonObject.put("state","1");
							result.setCode(IReturnStatus.FAILING);// ɹ
							result.setMessage("öԤ"+aggPayBillVOs[0].getHeadVO().getBillno()+"ɵδ֧δرաɾԤ󶩵Զر");
						}
					}
				}
				orderVO.getHVO().setVdef31(UFBoolean.TRUE.toString());
				new BaseDAO().updateVO(orderVO.getHVO(), new String[] {"vdef31"});
				WuYeWgptUtil.createResultEsbVO(esb);
				result.setResult(resultJsonObject);
				esb.setResultInfo(result);
			}
		} catch (Exception e) {
			result.setCode(IReturnStatus.ERROR);// 쳣
			result.setError(WuYeWgptUtil.getExceptionDetail(e));
			result.setMessage(result.getError());
			WuYeWgptUtil.createResultEsbVO(esb);// ʼӦ
			esb.getEsbInfo().setReturnStatus(IReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);// Ӧ
		} finally {
			rsdata = com.alibaba.fastjson.JSONObject.toJSONString(esb);

			WuYeWgptLogVO logVO = new WuYeWgptLogVO();
			logVO.setNc_id(nc_id);
			logVO.setOther_id(orderno + "");
			logVO.setBillno("");
			logVO.setTranstypecode("21");
			logVO.setItfcode("WGPT-NC-002");
			logVO.setItfname("ƽ̨->NCرղɹ");
			logVO.setBilldata(jsonobj == null ? "" : jsonobj.toString());
			logVO.setRsdata(rsdata);
			logVO.setMsg(null);
			logVO.setIssuccess(IReturnStatus.SUCCEED.equals(result.getCode()) ? "Y" : "N");

			WuYeWgptUtil.getIWuYeWgptLogService().insertLog_RequiresNew(logVO);
		}
		return rsdata;
	}

}
