package ncc.vo.yypub.formulas;

import java.util.List;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.MapProcessor;
import nc.newinstall.util.StringUtil;
import nc.vo.pub.formulaset.IFormulaConstant;
import nc.vo.pub.formulaset.core.ParseException;
import nc.vo.pub.formulaset.function.NcInnerFunction;

public class ExecQuery extends NcInnerFunction {
	
	private IUAPQueryBS commonDAO;

	public IUAPQueryBS getCommonDAO() {
		if(commonDAO == null) {
			commonDAO = NCLocator.getInstance().lookup(IUAPQueryBS.class);
		}
		return commonDAO;
	}

	public ExecQuery() {
		numberOfParameters = 1;
		functionType = IFormulaConstant.FUN_CUSTOM;
		functionDesc = "execQuery(sql) SQLִвѯ,עsqlвʹá',ԡ#";
	}

	public Object function(List param) throws ParseException {
		if (param == null || param.size() != numberOfParameters) {
			throw new ParseException("󣺲!");
		}
		
		String sql = (String) param.get(0);
		
		if(!StringUtil.isEmpty(sql)) {
			sql = sql.replaceAll("==", "=");
			sql = sql.replaceAll("!=", "<>");
			sql = sql.replaceAll("#", "'");
			try {
				Map map = (Map) getCommonDAO().executeQuery(sql, new MapProcessor());
				if(map != null && map.size() > 0) {
					// ȡѯĬϵһֵ
					String key = (String) map.keySet().iterator().next();
					return map.get(key);
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return null;
	}
}
