/*
 * @(#)N_36K4_SAVEBASE.java 2012-3-9
 * Copyright 2010 UFIDA Software CO.LTD. All rights reserved.
 */
package nc.bs.pub.action;

import java.util.Hashtable;

import nc.bs.pub.compiler.AbstractCompiler2;
import nc.bs.sf.delivery.DeliveryBR;
import nc.bs.sf.delivery.DeliveryBankAccBookBR;
import nc.bs.sf.delivery.DeliveryInnerAccBookBR;
import nc.bs.sf.delivery.busilog.DeliveryEditBusiLog;
import nc.bs.sf.delivery.util.DeliveryUtil;
import nc.bs.sf.delivery.util.GXDeliveryEventDispatcher;
import nc.itf.sf.delivery.proxy.DeliveryServiceProxy;
import nc.pubitf.tmpub.util.SagasBizPubUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.compiler.PfParameterVO;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.pf.IPfRetCheckInfo;
import nc.vo.sf.allocate.AllocateVO;
import nc.vo.sf.delivery.AggDeliveryVO;
import nc.vo.sf.delivery.DeliveryBVO;
import nc.vo.sf.delivery.DeliveryEncryptVO;
import nc.vo.sf.delivery.DeliveryVO;
import nc.vo.sf.delivery.IDeliveryConst;
import nc.vo.sf.delivery.util.DeliveryPubUtil;
import nc.vo.sf.delivery.util.DeliveryVOUtil;
import nc.vo.tmpub.proxy.TMPubServiceProxy;
import nc.vo.tmpub.util.ArrayUtil;
import nc.vo.tmpub.util.DateUtil;
import nc.vo.uap.pf.PFBusinessException;
import nccloud.pubitf.sf.delivery.DeliverySagaInfoAdapter;

/**
 * ձ
 *
 * @author  chengfei
 * @version 1.0 2012-3-9
 * @since   NC6.1
 */
public class N_36K4_SAVEBASE extends AbstractCompiler2 {
	private final java.util.Hashtable m_methodReturnHas = new java.util.Hashtable();
	private Hashtable m_keyHas = null;

	/**
	 * N_36K4_SAVEBASE ע⡣
	 */
	public N_36K4_SAVEBASE() {
		super();
	}

	/*
	 * עƽ̨д ӿִ
	 */
	@Override
	public Object runComClass(PfParameterVO vo) throws BusinessException {
		try {
			super.m_tmpVo = vo;
			AggDeliveryVO aggvo = (AggDeliveryVO) this.getVo();
			// ύҪԼ״̬Ϊύ̬У
			DeliveryVO deliveryVO = (DeliveryVO) (aggvo).getParentVO();
			// begin tm yangjn ݶУ
			if(deliveryVO.getPk_delivery_h() != null){
				DeliverySagaInfoAdapter adapter = new DeliverySagaInfoAdapter();
				SagasBizPubUtil.checkFrozen(adapter, deliveryVO.getPk_delivery_h());
			}
			//end
			deliveryVO.setVbillstatus(IPfRetCheckInfo.NOSTATE);
			// õ״̬Ϊ
			deliveryVO
					.setBillstatus(IDeliveryConst.BILLSTATUS_WAITCOMMIT);
			//ӱֶ֯νиֵ   hanlua  2013-07-02
			DeliveryBVO[] deliveryBVOS = (aggvo).getItem();
			for(DeliveryBVO deliveryBVO :deliveryBVOS){
				deliveryBVO.setPk_org(deliveryVO.getPk_org());
				deliveryBVO.setPk_group(deliveryVO.getPk_group());
			}
			DeliveryBR br = new DeliveryBR();
			br.beforeSave(aggvo);
			if (aggvo.getParentVO().getStatus() != VOStatus.NEW) {
				//xug ޸ǰ
				GXDeliveryEventDispatcher.getInstantiation("74d29f86-4334-4fc9-a7d3-085cf5dd7845").fireEvent("1003",aggvo);
				DeliveryVOUtil.deleteEbankWrite(aggvo);
				new DeliveryInnerAccBookBR().deleteInnerAccRealBalance(aggvo);
				new DeliveryBankAccBookBR().deleteRecRealBankAcc(aggvo);
				// ʱȽ֤ǩ
				TMPubServiceProxy
						.getCaLogRecordService()
						.checkPerOperationCASignatureByVO(
								br.findDelivery(aggvo), DeliveryEncryptVO.class);

				// ǩ
				aggvo = br.addBillCaSignRecord(aggvo);
				DeliveryUtil.setBankCodeAndCheckSingleForEdit(aggvo);
				aggvo = new DeliveryBR().saveDelivery(aggvo);
				//¼޸ĵ־
				new DeliveryEditBusiLog().writeBusiLog(aggvo);
				//xug ޸ĺ
				GXDeliveryEventDispatcher.getInstantiation("74d29f86-4334-4fc9-a7d3-085cf5dd7845").fireEvent("1004",aggvo);
			} else {
				//xug ǰ
				GXDeliveryEventDispatcher.getInstantiation("74d29f86-4334-4fc9-a7d3-085cf5dd7845").fireEvent("1001",aggvo);
//				AllocatePubUtil.setBillDateTimeByBusiDate(aggAllocateVO,AllocateVO.ACCEPTDATE, new String[] { AllocateVO.DBILLTIME,AllocateVO.CREATIONTIME });
				String[] vls = new String[] { AllocateVO.DBILLTIME,AllocateVO.CREATIONTIME };
				if (!ArrayUtil.isNull(vls)) {
					UFDateTime currentTime = DateUtil.getCurrTime();
					for (String timeField : vls) {
						aggvo.getHead().setAttributeValue(timeField, currentTime);
					}
				}
				aggvo = DeliveryServiceProxy.getDeliveryManageService()
						.addAggDeliveryVO(aggvo);
				//xug 
				GXDeliveryEventDispatcher.getInstantiation("74d29f86-4334-4fc9-a7d3-085cf5dd7845").fireEvent("1002",aggvo);
			}
			// ҵҪڲ˻
			new DeliveryInnerAccBookBR().writeInnerRealBalance(aggvo);
			// ҵҪԤռ˺ʵʱ
			new DeliveryBankAccBookBR().writeRecBankAccRealBalance(aggvo, true);
			// ǳҵҪԤռλʵʱ
			// new DeliveryBankAccBookBR().writePayBankAccRealBalance(aggvo,
			// true);

			// ####ű뺬зֵ,DLGPNLзֵ####
			return aggvo;
		} catch (Exception ex) {
			if (ex instanceof BusinessException)
				throw (BusinessException) ex;
			else
				throw new PFBusinessException(ex.getMessage(), ex);
		}
	}

	/*
	 * עƽ̨дԭʼű
	 */
	@Override
	public String getCodeRemark() {
		return nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("3632delivery_0","03632delivery-0115")/*@res "	//####ű뺬зֵ,DLGPNLзֵ####\n	Object retObj=null;\n"*/;
	}

	/*
	 * עýűHAS
	 */
	private void setParameter(String key, Object val) {
		if (m_keyHas == null) {
			m_keyHas = new Hashtable();
		}
		if (val != null) {
			m_keyHas.put(key, val);
		}
	}

}