package ncc.bd.rest.impl;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.UUID;

import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.logging.Logger;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.vo.bd.asslinenum.AssLineNumVO;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pubapp.AppContext;
import ncc.net.servlet.NccEsbJsonServletUtil;
import ncc.net.servlet.status.WyReturnStatus;
import ncc.pub.wy.constant.WyConstants;
import ncc.vo.bd.asslinenum.AssLineNumLogVO;
import ncc.vo.esb.WyEsbInfoVO;
import ncc.vo.esb.WyQueryInfoVO;
import ncc.vo.esb.WyResultEsbVO;
import ncc.vo.esb.result.WyResultVO;
import nccloud.commons.lang.StringUtils;
import uap.json.JSONObject;
/**   
 * @ClassName:  MdgTmReceiveAsslinenumBS   
 * @Description:MDGNCCк  /޸/ɾ  
 * ¼־̨bd_asslinenum_log ӦVOAssLineNumLogVO
 * @author: Ƽ
 * @date:  20201203
 *   
 */
public class MdgToNccAsslinenumServelet extends NccEsbJsonServletUtil{

	public void execFunction(HttpServletRequest request,
			HttpServletResponse response) {
		
		
		JSONObject jsonobj = null;
		
		try{
			jsonobj=findPostJsonValue(request);//ȡPostֵ
			if(jsonobj==null || "".equals(jsonobj)){//Postύֵ
				WyResultVO result=new WyResultVO();
				result.setCode(WyReturnStatus.FAILING);//ʧ
				result.setMessage("PostύJsonʽֵ!");
				WyResultEsbVO<WyResultVO> esb=new WyResultEsbVO<WyResultVO>();
				createResultEsbVO(esb);
				esb.getEsbInfo().setReturnStatus(WyReturnStatus.ESB_FAILING);
				esb.getEsbInfo().setReturnMsg("ʧ");
				esb.setResultInfo(result);
				sendResponse(response,esb);
			}else{
				/** begin ϵͳBGY **/
				try{
					initInvocationInfo();
				}catch(Exception e){
					throw e;
				}
				/** end ϵͳBGY **/
			}
		}catch(Exception e){
			WyResultVO result=new WyResultVO();
			result.setCode(WyReturnStatus.ERROR);//쳣
			result.setError(getExceptionDetail(e));
			WyResultEsbVO<WyResultVO> esb=new WyResultEsbVO<WyResultVO>();//Ӧ
			createResultEsbVO(esb);//ʼӦ
			esb.getEsbInfo().setReturnStatus(WyReturnStatus.ESB_ERROR);
			esb.getEsbInfo().setReturnMsg("쳣");
			esb.setResultInfo(result);//Ӧ
			sendResponse(response,esb);
		}
		

		WyResultEsbVO<WyResultVO> esb = new WyResultEsbVO<WyResultVO>();//Ӧ
		SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
		Calendar cal = Calendar.getInstance();
		String begindate = df.format(cal.getTime());
		String pcombinenum="";
		AssLineNumLogVO logVO = new AssLineNumLogVO();//ͬ־VO
		UFDateTime time = AppContext.getInstance().getServerTime();
		
		BaseDAO dao = new BaseDAO();
		
		try{
			
			JSONObject obj = jsonobj.getJSONObject("requestInfo");
			JSONObject header = obj.getJSONObject("Header");
			logVO = jsonToVO(header,logVO);
			
			pcombinenum = logVO.getPcombinenum();
			if(pcombinenum==null || pcombinenum.length()==0){
				throw new Exception("Ϣ벻Ϊ");
			}else if(pcombinenum.length()>12){
				throw new Exception("Ϣ볬12λNCC");
			}
			String pcombinename = logVO.getPcombinename();
			if(pcombinename==null || pcombinename.length()==0){
				throw new Exception("ϢƲΪ");
			}
			String countrycode = logVO.getCountrycode();//
			String address = logVO.getAddress(); //ϸַ
			String city	 = logVO.getCity();//
			String swiftcode = logVO.getSwiftcode();//SWIFT
			String tel_number = logVO.getTel_number();//е绰
			
			ArrayList<AssLineNumVO> list=null;
			list=(ArrayList<AssLineNumVO>) dao.executeQuery("select * from bd_asslinenum where code ='"+pcombinenum+"'", new BeanListProcessor(AssLineNumVO.class));
			String chkme = logVO.getChkme();
			if(chkme!=null && "X".equals(chkme)){
				if(list!=null && list.size()>0){
					dao.deleteVOArray(list.toArray(new AssLineNumVO[list.size()]));
					logVO.setIssuccess("Y");
					logVO.setMsg("MDGNCCӿɾɹ");
				}else{
					throw new Exception("NCCڸкűϢɾʧܣ"+pcombinenum);
				}
			}else{
				
				if(list!=null && list.size()>0){
					AssLineNumVO[] assLineNumVOs = list.toArray(new AssLineNumVO[list.size()]);
					for(AssLineNumVO vo : assLineNumVOs){
						String code = vo.getCode();
						if(pcombinenum.equals(code)){
							vo.setName(pcombinename);
							vo.setCity(city);
							vo.setTelePhone(tel_number);
							vo.setLocation(address);
							vo.setModifiedtime(time);
							vo.setModifier(WyConstants.NCCADMIN_CUSERID);
						}
					}
					int rest = dao.updateVOArray(assLineNumVOs);
					if(rest==1){
						logVO.setIssuccess("Y");
						logVO.setMsg("MDGNCӿڸ²ɹ");
					}
				}else{
					AssLineNumVO numVO = new AssLineNumVO();
					numVO.setCode(pcombinenum);
					numVO.setName(pcombinename);
					numVO.setCity(city);
					numVO.setTelePhone(tel_number);
					numVO.setLocation(address);
					numVO.setCreationtime(time);
					numVO.setCreator(WyConstants.NCCADMIN_CUSERID);
					numVO.setPk_group(WyConstants.GROUPID);
					numVO.setPk_org("");
					
					String rest = dao.insertVO(numVO);
					logVO.setIssuccess("Y");
					logVO.setMsg("MDGNCCӿڱɹ"+rest);
				}
			}

			InvocationInfoProxy.getInstance().setGroupId(WyConstants.GROUPID);
			InvocationInfoProxy.getInstance().setUserId(
					WyConstants.NCCADMIN_CUSERID);
			//װ־Ϣ
			logVO.setSend_data_sn(jsonobj.toString());
			logVO.setCreationtime(time);
			logVO.setCreator(WyConstants.NCCADMIN_CUSERID);
			
			//װϢ
			WyResultVO result=new WyResultVO();
			result.setCode(WyReturnStatus.SUCCEED);//ɹ
			result.setMessage("ִвɹ");
			Calendar call = Calendar.getInstance();
			String enddate = df.format(call.getTime());
			createResultEsbVO(esb,jsonobj.getJSONObject("esbInfo").getString("instId"),begindate,enddate);//ʼӦ
			esb.getEsbInfo().setReturnStatus(WyReturnStatus.ESB_SUCCEED);
			esb.setResultInfo(result);
			sendResponse(response, esb);// Ӧ
			
		}catch(Exception e){
			Logger.error("====кд쳣===" + e.getMessage());
			Logger.error("====кд뱨===" + jsonobj);
			
			//װ־Ϣ
			logVO.setIssuccess("N");
			logVO.setMsg(e.getMessage());
			logVO.setSend_data_sn(jsonobj.toString());
			logVO.setCreationtime(time);
			
			//װϢ
			WyResultVO result=new WyResultVO();
			result.setCode(WyReturnStatus.FAILING);//ʧ
			result.setMessage("ִвʧ");
			result.setError(e.getMessage());
			Calendar call = Calendar.getInstance();
			String enddate = df.format(call.getTime());
			createResultEsbVO(esb,jsonobj.getJSONObject("esbInfo").getString("instId"),begindate,enddate);//ʼӦ
			esb.getEsbInfo().setReturnMsg("ʧ");
			esb.getEsbInfo().setReturnCode(WyReturnStatus.ESB_FAILING_CODE);
			esb.getEsbInfo().setReturnStatus(WyReturnStatus.ESB_ERROR);
			esb.setResultInfo(result);//Ӧ
			sendResponse(response, esb);// Ӧ
			
		}finally{
			try {
				//־
				logVO.setResult_data_sn(com.alibaba.fastjson.JSONObject.toJSONString(esb).toString());
				dao.insertVO(logVO);
			} catch (Exception e) {
				Logger.debug("кű־ʧ" + e.getMessage());
			}
		}
		
	}
	
	/**
	 * jsonתVO
	 * @time 2020-12-03
	 * @param header,logVO
	 */
	public AssLineNumLogVO jsonToVO(JSONObject header,AssLineNumLogVO logVO){
		Iterator<String> it;
		String attributeName;
		Object value;
		it = (Iterator<String>) header.keys();
		while (it.hasNext()) {
			attributeName = it.next();
			if (StringUtils.isEmpty(attributeName)) {
				continue;
			}
			value = header.get(attributeName);
			if (value == null || StringUtils.isEmpty(value.toString()) || header.isNull(attributeName)) {
				continue;
			}
			logVO.setAttributeValue(attributeName, value);
		}
		return logVO;
	}
	
	/**
	 * ESBӦ
	 * @param esb
	 * @param instId ԴID
	 * @param begindate ʼʱ
	 * @param enddate ʱ
	 */
	public void createResultEsbVO(final WyResultEsbVO esb,String instId,String begindate,String enddate){
		WyEsbInfoVO esbInfo=new WyEsbInfoVO();
		WyQueryInfoVO queryInfo=new WyQueryInfoVO();

		if(instId!=null && !"".equals(instId)){
			esbInfo.setInstId(instId);
		}else{
			esbInfo.setInstId(getStringUUID());//ʹUUIDΪˮ
		}
		esbInfo.setRequestTime(begindate);//ʼʱ
		esbInfo.setResponseTime(enddate);//Ӧʱ
		esbInfo.setReturnStatus(WyReturnStatus.ESB_SUCCEED);//ĬӦɹ
		esbInfo.setReturnCode(WyReturnStatus.ESB_SUCCEED_CODE);//Ĭϳɹcode
		esbInfo.setReturnMsg("ɹ");//ĬӦɹʾ
		esb.setEsbInfo(esbInfo);
		esb.setQueryInfo(queryInfo);
	}
	
	/**
	 * UUIDֵ
	 */
	public static String getStringUUID(){
		return UUID.randomUUID().toString();
	}
	
	/**
	 * ӦϢ
	 * @param response
	 * @param esb
	 */
	public void sendResponse(final HttpServletResponse response,WyResultEsbVO esb){
		String jsondata=com.alibaba.fastjson.JSONObject.toJSONString(esb).toString();
		PrintWriter out=null;
		try {
			response.setHeader("Content-type", "application/json;charset=UTF-8");
			out = new PrintWriter(new OutputStreamWriter(response.getOutputStream(),"UTF-8"));
	        out.write(jsondata);
	        out.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			if(out!=null){
				out.close();
			}
		}
	}
	
	/**
	 * PostύJson
	 * @param request
	 * @return
	 * @throws Exception 
	 */
	private JSONObject findPostJsonValue(final HttpServletRequest request) throws Exception{
		BufferedReader br=null;
		try {
			br= new BufferedReader(new InputStreamReader(
					(ServletInputStream) request.getInputStream(), "utf-8"));
			StringBuffer sb = new StringBuffer();
			String temp=null;
			while ((temp = br.readLine())!= null) {
				sb.append(temp);
			}
			return new JSONObject(sb.toString());
		} catch (Exception e) {
			throw e;
		}finally{
			try {
				if(br!=null)
					br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
}
