package nc.net.uapbd.activity;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;
import java.util.regex.Pattern;

import org.restlet.engine.util.StringUtils;

import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IVOPersistence;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.net.uapbd.pojo.CODEVALUE;
import nc.net.uapbd.pojo.DATA;
import nc.net.uapbd.pojo.DATAINFO;
import nc.net.uapbd.pojo.DATAINFOS;
import nc.net.uapbd.pojo.ESB;
import nc.net.uapbd.pojo.PROPERTY;
import nc.net.uapbd.pojo.SPECIALITY;
import nc.vo.bd.bankaccount.BankAccbasVO;
import nc.vo.bd.bankdoc.BankdocVO;
import nc.vo.org.DeptVO;
import nc.vo.org.OrgVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.SuperVO;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFLiteralDate;

public  class PostUtils {
	


	public static BaseDAO baseDao = new BaseDAO();
	
	
	public static final List<String[]> accountingBookRequest = new ArrayList() {{
			add(new String[] {
					"NCC_FIN_ORG_PK","֯","pk_org"
			});
			add(new String[] {
					"NCC_FIN_ORG_CODE","֯","code"
			});
			add(new String[] {
					"NCC_FIN_ORG_NAME","֯","name"
			});
			add(new String[] {
					"NCC_FIN_PARENT_ORG_PK","ϼ֯","pk_fatherorg"
			});
			add(new String[] {
					"NCC_FIN_PARENT_ORG_CODE","ϼ֯","select code from org_orgs where pk_org =pk_fatherorg"
			});
			add(new String[] {
					"NCC_FIN_PARENT_ORG_NAME","ϼ֯","select name from org_orgs where pk_org =pk_fatherorg"
			});
			add(new String[] {
					"ACCOUNT_SET_PERIOD","׽ʱ","def43"
			});
			add(new String[] {
					"ACCOUNT_SEAL_PERIOD","׷ʱ","def44"
			});
			add(new String[] {
					"IS_COMMNAME_NULL","ĿǷ","def8"
			});
			//add
			add(new String[] {
					"IS_PROPERTY_OUTSIDE_CODE","ҵǷر","select code from bd_defdoc where pk_defdoc =def15"
			});
			add(new String[] {
					"IS_PROPERTY_OUTSIDE_NAME","ҵǷ","select name from bd_defdoc where pk_defdoc =def15"
			});
			add(new String[] {
					"PROPERTY_CHARGES_TYPE_CODE","ҵӹܷʽ","select code from bd_defdoc where pk_defdoc =def16"
			});
			add(new String[] {
					"PROPERTY_CHARGES_TYPE_NAME","ҵӹܷʽ","select name from bd_defdoc where pk_defdoc =def16"
			});
			add(new String[] {
					"IS_CONSOLIDATED_LISTING_STATEMENT_CODE","˾Ƿϲб","select code from bd_defdoc where pk_defdoc =def20"
			});
			add(new String[] {
					"IS_CONSOLIDATED_LISTING_STATEMENT_NAME","˾Ƿϲб","select name from bd_defdoc where pk_defdoc =def20"
			});
			add(new String[] {
					"ACTUAL_ACCOUNTING_SYSTEM_CODE","ʵʺϵͳ","select code from bd_defdoc where pk_defdoc =def37"
			});
			add(new String[] {
					"ACTUAL_ACCOUNTING_SYSTEM_NAME","ʵʺϵͳ","select name from bd_defdoc where pk_defdoc =def37"
			});
			add(new String[] {
					"EQUITY_SITUATION_CODE","Ȩ","select code from bd_defdoc where pk_defdoc =def41"
			});
			add(new String[] {
					"EQUITY_SITUATION_NAME","Ȩ","select name from bd_defdoc where pk_defdoc =def41"
			});
			add(new String[] {
					"ENABLE_STATUS","ʹ״̬","enablestate"
			});
			add(new String[] {
					"AREA_CODE","","select code from bd_defdoc where pk_defdoc =def11"
			});
			add(new String[] {
					"AREA_NAME","","select name from bd_defdoc where pk_defdoc =def11"
			});
			add(new String[] {
					"PLATE_CODE","","select code from bd_defdoc where pk_defdoc =def6"
			});
			add(new String[] {
					"PLATE_NAME","","select name from bd_defdoc where pk_defdoc =def6"
			});
			add(new String[] {
					"IS_VIRTUAL_UNIT","Ƿⵥλ","def30"
			});
			add(new String[] {
					"IS_POST_TO_MDM","ǷѴMDM","def46"
			});
			add(new String[] {
					"CREATE_USER_CODE","˱","select user_code from sm_user where cuserid =creator"
			});
			add(new String[] {
					"CREATE_USER_NAME","","select user_name from sm_user where cuserid =creator"
			});
			add(new String[] {
					"CREATE_TIME","ʱ","creationtime"
			});
			add(new String[] {
					"LAST_UPDATE_USER_CODE","˱","select user_code from sm_user where cuserid =modifier"
			});
			add(new String[] {
					"LAST_UPDATE_USER_NAME","","select user_name from sm_user where cuserid =modifier"
			});
			add(new String[] {
					"LAST_UPDATE_TIME","ʱ","modifiedtime"
			});
			add(new String[] {
					"IS_DELETE","ɾ״̬","dr"
			});
			
	}};
	
	
	public static final List<String[]> deptRequest = new ArrayList() {{
		add(new String[] {
				"NCC_FIN_DEPT_PK","","pk_dept"
		});
		add(new String[] {
				"NCC_FIN_DEPT_CODE","ű","code"
		});
		add(new String[] {
				"NCC_FIN_DEPT_NAME","","name"
		});
		add(new String[] {
				"NCC_FIN_ORG_PK","֯","pk_org"
		});
		add(new String[] {
				"NCC_FIN_ORG_CODE","֯","select code from org_orgs where pk_org =pk_org"
		});
		add(new String[] {
				"NCC_FIN_ORG_NAME","֯","select name from org_orgs where pk_org =pk_org"
		});
		add(new String[] {
				"NCC_PARENT_DEPT_PK","ϼ","pk_fatherorg"
		});
		add(new String[] {
				"NCC_PARENT_DEPT_CODE","ϼű","select code from org_orgs where pk_org =pk_fatherorg"
		});
		add(new String[] {
				"NCC_PARENT_DEPT_NAME","ϼ","select name from org_orgs where pk_org =pk_fatherorg"
		});
		add(new String[] {
				"DEPT_TYPE","","depttype"
		});
		add(new String[] {
				"ESTABLISH_DATE","ųʱ","createdate"
		});
		add(new String[] {
				"IS_BUDGET_UTIL","ǷԤ㵥λ","orgtype17"
		});
		add(new String[] {
				"ENABLE_STATUS","ʹ״̬","enablestate"
		});
		add(new String[] {
				"IS_POST_TO_MDM","ǷѴMDM","def15"
		});
		add(new String[] {
				"CREATE_USER_CODE","˱","select user_code from sm_user where cuserid =creator"
		});
		add(new String[] {
				"CREATE_USER_NAME","","select user_name from sm_user where cuserid =creator"
		});
		add(new String[] {
				"CREATE_TIME","ʱ","creationtime"
		});
		add(new String[] {
				"LAST_UPDATE_USER_CODE","˱","select user_code from sm_user where cuserid =modifier"
		});
		add(new String[] {
				"LAST_UPDATE_USER_NAME","","select user_name from sm_user where cuserid =modifier"
		});
		add(new String[] {
				"LAST_UPDATE_TIME","ʱ","modifiedtime"
		});
		add(new String[] {
				"IS_DELETE","ɾ״̬","select dr from org_dept where pk_dept=pk_dept"
		});
}};



public static final List<String[]> bankdocRequest = new ArrayList() {{
	add(new String[] {
			"NCC_BANK_DOC_PK","е","pk_bankdoc"
	});
	add(new String[] {
			"BANK_CODE","б","code"
	});
	add(new String[] {
			"BANK_NAME","","name"
	});
	add(new String[] {
			"SHORT_NAME","м","shortname"
	});
	add(new String[] {
			"NCC_BANK_TYPE_PK","","pk_banktype"
	});
	add(new String[] {
			"BANK_TYPE_CODE","ͱ","select code from bd_banktype where pk_banktype =pk_banktype"
	});
	add(new String[] {
			"BANK_TYPE_NAME","","select name from bd_banktype where pk_banktype =pk_banktype"
	});
	add(new String[] {
			"NCC_PARENT_DEPT_CODE","ϼű","select code from org_orgs where pk_org =pk_fatherorg"
	});
	add(new String[] {
			"COUNTRY","ҵ","select name from bd_countryzone where pk_country =pk_country"
	});
	add(new String[] {
			"AREA_CODE","","select code from bd_defdoc where pk_defdoc =areacode"
	});
	add(new String[] {
			"AREA_NAME","","select name from bd_defdoc where pk_defdoc=areacode"
	});
	add(new String[] {
			"BANK_AREA","","bankarea"
	});
	add(new String[] {
			"ORG_NUMBER","ŷк","orgnumber"
	});
	//123
	add(new String[] {
			"PROVINCE","ʡ","province"
	});
	add(new String[] {
			"CITY","","city"
	});
	add(new String[] {
			"COMBINE_NUM","к","pcombinenum"
	});
	add(new String[] {
			"IS_POST_TO_MDM","ǷѴMDM","def1"
	});
	add(new String[] {
			"CREATE_USER_CODE","˱","select user_code from sm_user where cuserid =creator"
	});
	add(new String[] {
			"CREATE_USER_NAME","","select user_name from sm_user where cuserid =creator"
	});
	add(new String[] {
			"CREATE_TIME","ʱ","creationtime"
	});
	add(new String[] {
			"LAST_UPDATE_USER_CODE","޸˱","select user_code from sm_user where cuserid =modifier"
	});
	add(new String[] {
			"LAST_UPDATE_USER_NAME","޸","select user_name from sm_user where cuserid =modifier"
	});
	add(new String[] {
			"LAST_UPDATE_TIME","ʱ","modifiedtime"
	});
	add(new String[] {
			"IS_DELETE","ɾ״̬","dr"
	});
}};

public static final List<String[]> bankaccbasRequest = new ArrayList() {{
	add(new String[] {
			"NCC_BANK_ACCBAS_PK","˻","pk_bankaccbas"
	});
	add(new String[] {
			"ACC_NUM","˺","accnum"
	});
	add(new String[] {
			"ACC_NAME","","accname"
	});
	add(new String[] {
			"OPENING_BANK","","pk_bankdoc"
	});
	add(new String[] {
			"OPENING_BANK_CODE","б","select code from bd_bankdoc where pk_bankdoc=pk_bankdoc"
	});
	add(new String[] {
			"OPENING_BANK_NAME","","select name from bd_bankdoc where pk_bankdoc=pk_bankdoc"
	});
	add(new String[] {
			"BANK_TYPE","","pk_banktype"
	});
	add(new String[] {
			"BANK_TYPE_CODE","","select code from bd_banktype where pk_banktype =pk_banktype"
	});
	add(new String[] {
			"BANK_TYPE_NAME","","select name from bd_banktype where pk_banktype =pk_banktype"
	});
	add(new String[] {
			"OPENING_FIN_ORG","λ","financeorg"
	});
	add(new String[] {
			"OPENING_FIN_ORG_CODE","λ","select code from org_financeorg  where pk_financeorg =financeorg"
	});
	add(new String[] {
			"OPENING_FIN_ORG_NAME","λ","select name from org_financeorg  where pk_financeorg =financeorg"
	});
	add(new String[] {
			"CONTROL_ORG","֯","controlorg"
	});
	//123
	add(new String[] {
			"CONTROL_ORG_CODE","֯","select code from org_financeorg where pk_financeorg =controlorg"
	});
	add(new String[] {
			"CONTROL_ORG_NAME","֯","select name from org_financeorg where pk_financeorg =controlorg"
	});
	add(new String[] {
			"ACC_OPEN_DATE","","accopendate"
	});
	add(new String[] {
			"ENABLE_STATE","״̬","enablestate"
	});
	add(new String[] {
			"ENABLE_TIME","","enabletime"
	});
	add(new String[] {
			"ENABLE_USER","","enableuser"
	});
	add(new String[] {
			"ENABLE_USER_CODE","˱","select user_code from sm_user  where cuserid =enableuser"
	});
	add(new String[] {
			"ENABLE_USER_NAME","","select user_name from sm_user  where cuserid =enableuser"
	});
	add(new String[] {
			"DISABLE_TIME","ͣ","disabletime"
	});
	add(new String[] {
			"DISABLE_USER","ͣ","disableuser"
	});
	add(new String[] {
			"DISABLE_USER_CODE","ͣ˱","select user_code from sm_user  where cuserid =disableuser"
	});
	add(new String[] {
			"DISABLE_USER_NAME","ͣ","select user_name from sm_user  where cuserid =disableuser"
	});
	add(new String[] {
			"ACC_XH_DATE","","accxhdate"
	});
	add(new String[] {
			"ARAP_PROP","ո","arapprop"
	});
	add(new String[] {
			"ACC_ATTRIBUTE","˻","accattribute"
	});
	add(new String[] {
			"ACC_STATE","˻״̬","accstate"
	});
	add(new String[] {
			"NET_QUERY_FLAG","ֱͨ״̬","netqueryflag"
	});
	add(new String[] {
			"IS_POST_TO_MDM","ǷѴMDM","def26"
	});
	add(new String[] {
			"CREATE_USER_CODE","˱","select user_code from sm_user  where cuserid =creator"
	});
	add(new String[] {
			"CREATE_USER_NAME","","select user_name from sm_user  where cuserid =creator"
	});
	add(new String[] {
			"CREATE_TIME","ʱ","creationtime"
	});
	add(new String[] {
			"LAST_UPDATE_USER_CODE","˱","select user_code from sm_user  where cuserid =modifier"
	});
	add(new String[] {
			"LAST_UPDATE_USER_NAME","","select user_name from sm_user  where cuserid =modifier"
	});
	add(new String[] {
			"LAST_UPDATE_TIME","ʱ","modifiedtime"
	});
	add(new String[] {
			"CURR_TYPE","","select pk_currtype from bd_bankaccsub where pk_bankaccbas =pk_bankaccbas"
	});
	add(new String[] {
			"CURR_TYPE_CODE","ֱ","select code from bd_currtype where pk_currtype =select pk_currtype from bd_bankaccsub where pk_bankaccbas =pk_bankaccbas"
	});
	add(new String[] {
			"CURR_TYPE_NAME","","select name from bd_currtype where pk_currtype =select pk_currtype from bd_bankaccsub where pk_bankaccbas =pk_bankaccbas"
	});
	add(new String[] {
			"IS_DEFAULT","Ĭ","select isdefault from bd_bankaccsub where pk_bankaccbas =pk_bankaccbas"
	});
	add(new String[] {
			"IS_TRADE","˻","select istrade from bd_bankaccsub where pk_bankaccbas =pk_bankaccbas"
	});
	add(new String[] {
			"IS_DELETE","ɾ״̬","dr"
	});
}};

	
	public SPECIALITY speciality = new SPECIALITY();
	
//	public static JSONObject newRequestObj(String PUUID) {
//		JSONObject obj = new JSONObject() {{
//			put("ESB",new JSONObject() {{
//				put("DATAINFOS", new JSONObject() {{
//					put("DATAINFO",new JSONArray());
//					put("PUUID",PUUID);
//				}});
//			}} );
//		}};
//		return obj;
//	}
//	
//	public static JSONObject newDataInfo(JSONObject data,JSONObject meta) {
//		meta.getJSONObject("ESB").getJSONObject("DATAINFOS").getJSONArray("DATAINFO").add(data);
//		return meta;
//	}
//	
//	public static JSONObject newColValue(JSONArray property,String code) {
//		JSONObject codevalue = new JSONObject() {{
//			put("SPECIALITY",new JSONObject() {{
//				put("PROPERTY",property);
//			}});
//			put("SPECIALITYCODE",code);
//		}};
//		return codevalue;
//	}
	
//	public static JSONArray newProperty(JSONArray property,String code,String name,String value) {
//		JSONObject obj = new JSONObject() {
//			{
//				put("PROPERTYCODE",code);
//				put("PROPERTYNAME",name);
//				put("PROPERTYVALUE",value);
//			}
//		};
//		property.add(obj);
//		return property;
//	}
	
	public static Map<String,List<SPECIALITY>> getSpeciality(List<Map<String,List<Map<String,Object>>>> values) {
		Map<String,List<SPECIALITY>> map1 = new HashMap();
		
		for(Map<String,List<Map<String,Object>>> value:values) {
			List<SPECIALITY> listspeciality = new ArrayList();
			SPECIALITY speciality = new SPECIALITY();
			List<PROPERTY> propertys = new ArrayList();
			value.forEach((k,v)->{
				for(Map<String,Object> map:value.get(k)) {
					PROPERTY property = new PROPERTY();
					if(map.get("PROPERTYVALUE") instanceof UFDateTime || map.get("PROPERTYVALUE") instanceof UFLiteralDate) {
						property.setPROPERTYCODE( map.get("PROPERTYCODE"));
						property.setPROPERTYNAME( map.get("PROPERTYNAME"));
						property.setPROPERTYVALUE(map.get("PROPERTYVALUE").toString());
						propertys.add(property);
					}else {
					property.setPROPERTYCODE( map.get("PROPERTYCODE"));
					property.setPROPERTYNAME( map.get("PROPERTYNAME"));
					property.setPROPERTYVALUE( map.get("PROPERTYVALUE").toString());
					propertys.add(property);
					}
				}
				speciality.setPROPERTY(propertys);
				//˴Ҫ
				speciality.setSPECIALITYCODE(k);
				listspeciality.add(speciality);
			});
			
			
			
			//uuid
			String uuid = UUID.randomUUID().toString().replaceAll("-","");
			map1.put(uuid,listspeciality);
		}
		
		
//		
//		for(Map<String,List<Map<String,String>>> value:values) {
//			List<SPECIALITY> listspeciality = new ArrayList();
//			SPECIALITY speciality = new SPECIALITY();
//			List<PROPERTY> propertys = new ArrayList();
//			for(Map<String,String> map:value.get(var1)) {
//				PROPERTY property = new PROPERTY();
//				property.setPROPERTYCODE( map.get("PROPERTYCODE"));
//				property.setPROPERTYNAME( map.get("PROPERTYNAME"));
//				property.setPROPERTYVALUE( map.get("PROPERTYVALUE"));
//				propertys.add(property);
//			}
//			speciality.setPROPERTY(propertys);
//			//˴Ҫ
//			speciality.setSPECIALITYCODE(value.get(0).get("code"));
//			listspeciality.add(speciality);
//			//uuid
//			String uuid = UUID.randomUUID().toString().replaceAll("-","");
//			map1.put(uuid,listspeciality);
//		}
		
		return map1;
	}
	
	public static ESB getESB(Map<String,List<SPECIALITY>> map) {
		DATA data = new DATA();
		ESB esb = new ESB();
		DATAINFOS datainfos = new DATAINFOS();
		List<DATAINFO> listdatainfo = new ArrayList();
		
		map.forEach((key,value)->{
			DATAINFO datainfo = new DATAINFO();
			CODEVALUE codevalue = new CODEVALUE();
			codevalue.setSPECIALITY(value);
			datainfo.setCODEVALUE(codevalue);
			datainfo.setUUID(key);
			listdatainfo.add(datainfo);
		});
		datainfos.setDATAINFO(listdatainfo);
		String puuid = UUID.randomUUID().toString().replaceAll("-","");
		datainfos.setPUUID(puuid);
		data.setDATAINFOS(datainfos);
		esb.setDATA(data);
		return esb;
		
	}
	
	
	

	public static List<Map<String,List<Map<String,Object>>>> VOHandler(SuperVO[] vos) {
		List<Map<String,List<Map<String,Object>>>> listMap = new ArrayList(); 
		for(SuperVO vo:vos) {
			Map<String,List<Map<String,Object>>> every = new HashMap();
			List<Map<String,Object>> key = inputProperty(vo);
			//keyֵSPECIALITYCODE
			every.put("JBXX", key);
			listMap.add(every);
//			if(vo instanceof AccountingBookVO) {
//				Map<String,List<Map<String,String>>> every = new HashMap();
//				List<Map<String,String>> key = inputProperty(vo);
//				//keyֵSPECIALITYCODE
//				every.put("JBXX", key);
//				listMap.add(every);
//			}else if(vo instanceof DeptVO) {
//				Map<String,List<Map<String,String>>> every = new HashMap();
//				List<Map<String,String>> key = inputProperty(vo);
//				//keyֵSPECIALITYCODE
//				every.put("JBXX", key);
//				listMap.add(every);
//			}
		}
		return listMap;
		
		
		
	}
	
	
	//ݷͱ
	public static JSONObject sendHttpJsonPost(String url,String param,String syncode,String puuid) throws Exception{  
	       HttpURLConnection httpURLConnection = null;  
	       OutputStream out = null; //д  
	       BufferedReader br = null;   //  
	       int responseCode = 0;    //ԶӦHTTP״̬  
	       StringBuffer result=new StringBuffer();  
	       try{  
	           URL sendUrl = new URL(url);  
	           httpURLConnection = (HttpURLConnection)sendUrl.openConnection();  
	           //postʽ  
	           httpURLConnection.setRequestMethod("POST");  
	           //һҪ Content-Type ҪȻ˽ղ  
	           httpURLConnection.setRequestProperty("Content-Type", "application/Json; charset=UTF-8");  
	           httpURLConnection.setRequestProperty("usercode", "ncc");  
	           httpURLConnection.setRequestProperty("password", "ncc");  
	           httpURLConnection.setRequestProperty("sysid", "NCC");  
	           httpURLConnection.setRequestProperty("syncode", syncode);  
	           httpURLConnection.setRequestProperty("puuid", puuid);  
	           //ָʾӦóҪдURL,ֵĬΪfalseǷ񴫲Σ  
	           httpURLConnection.setDoOutput(true);  
	           httpURLConnection.setDoInput(true);   
	             
	           httpURLConnection.setUseCaches(false);//ʹû
	           httpURLConnection.setConnectTimeout(120000); //120ӳʱ  
	           httpURLConnection.setReadTimeout(120000);    //120ȡʱ  
	           //  
	           out = httpURLConnection.getOutputStream();  
	           out.write(param.getBytes());  
	           out.flush(); //ջ,  
	           responseCode = httpURLConnection.getResponseCode();  
	           //ȡԴ  
	           br = new BufferedReader(new InputStreamReader(httpURLConnection.getInputStream(),"UTF-8"));  
	           String line="";
	           while ((line = br.readLine()) != null) {
	               result.append(line);
	           }
	       }catch(Exception e) {
	    	   throw e;
	       }finally{
				try {
					if(out!=null)
						out.close();
					if(br!=null)
						br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}  
	       }
	       if(result!=null && result.length()>0)//תΪJson
	    	   return com.alibaba.fastjson.JSONObject.parseObject(result.toString());
	       else
	    	   return null; 
	   }
	
	
	public static  List<Map<String,Object>> inputProperty(SuperVO vo) {
		List<Map<String,Object>> key = new ArrayList();
		Map<String,String> map = new HashMap<String,String>();
		List<String[]> list = null;
		
		decideList(vo).forEach((k)->{
			Map<String,Object> every = new HashMap();
			every.put("PROPERTYCODE",k[0] );
			every.put("PROPERTYNAME", k[1]);
			if(k[2]==null||k[2]=="") {				
			}else {
			if(Pattern.matches(".*select.*", k[2])) {
				String result = query(k[2],vo);
				every.put("PROPERTYVALUE", result);	
			}else {
			every.put("PROPERTYVALUE", vo.getAttributeValue(k[2]));
			}
			if(every.get("PROPERTYVALUE")!=null) {
				key.add(every);
			}
			
			}
		});
		return key;
	}
	
	
	public static String query(String expression,SuperVO vo) {
			String result = null;		
			String[] strs = expression.split("=",2);
			if(Pattern.matches(".*select.*", strs[1])) {
				String[] strs1 = strs[1].split("=");
				strs1[0] = strs1[0] + "= ?";
				SQLParameter param = new SQLParameter();
				param.addParam(vo.getAttributeValue(strs1[1]));
				try {
					strs[1] = baseDao.executeQuery(strs1[0], param, new ColumnProcessor())==null ?null:baseDao.executeQuery(strs1[0], param, new ColumnProcessor()).toString();
				} catch (DAOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				if(!StringUtils.isNullOrEmpty(strs[1])) {
					strs[0] = strs[0] + "= ?";
					SQLParameter param1 = new SQLParameter();
					param1.addParam(strs[1]);	
					try {
						result = baseDao.executeQuery(strs[0], param1, new ColumnProcessor())==null ?null:baseDao.executeQuery(strs[0], param1, new ColumnProcessor()).toString();
					} catch (DAOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					return result;
					}
			}
			if(!StringUtils.isNullOrEmpty(strs[1])&&vo.getAttributeValue(strs[1])!=null) {
			strs[0] = strs[0] + "= ?";
			SQLParameter param = new SQLParameter();
			
			param.addParam(vo.getAttributeValue(strs[1]));	
			try {
				result = baseDao.executeQuery(strs[0], param, new ColumnProcessor())==null ?null:baseDao.executeQuery(strs[0], param, new ColumnProcessor()).toString();
			} catch (DAOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			}
		return result;
	}
	
	public static List<String[]> decideList(SuperVO vo){
		
		if(vo instanceof OrgVO) {
			return accountingBookRequest;
		}else if(vo instanceof DeptVO) {
			return deptRequest;
		}else if(vo instanceof BankAccbasVO) {
			return bankaccbasRequest;
		}else if(vo instanceof BankdocVO) {
			return bankdocRequest;
		}
		return null;
	}
	
	public static void updateAfterSuccess(SuperVO vo,boolean ifSuccess) throws BusinessException {
		IVOPersistence service = NCLocator.getInstance().lookup(IVOPersistence.class);
		String insertV = "";
		if(ifSuccess!=true) {
			insertV = "";
		}
		if(vo instanceof OrgVO) {
			vo.setAttributeValue("def46", insertV);
		}else if(vo instanceof DeptVO) {
			vo.setAttributeValue("def15", insertV);
		}else if(vo instanceof BankAccbasVO) {
			vo.setAttributeValue("def26", insertV);
		}else if(vo instanceof BankdocVO) {
			vo.setAttributeValue("def1", insertV);
		}
		if(vo.getPrimaryKey()!=null) {
			service.updateVO(vo);
		}else {
			service.insertVO(vo);
		}
		
	}
	
}
