//nslGwwQRyySTBqdb6vgDeTX2flneCaaVP7NIdF4lqqHYeWcjsCkAJ3zO1zqNoOHrDD/sz60Weax087NE4mI8NA==
package nc.bs.arap.busireg;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.Set;

import nc.bd.accperiod.InvalidAccperiodExcetion;
import nc.bs.arap.bill.ArapBillCalUtil;
import nc.bs.arap.billact.LogTime;
import nc.bs.arap.cache.ArapBusiPluginCenter;
import nc.bs.arap.verify.FaDMO;
import nc.bs.bgy.pub.VerifyLogger;
import nc.bs.businessevent.BdUpdateEvent;
import nc.bs.businessevent.BusinessEvent;
import nc.bs.businessevent.IBusinessEvent;
import nc.bs.businessevent.IEventType;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Log;
import nc.bs.logging.Logger;
import nc.bs.uap.lock.PKLock;
import nc.itf.arap.fieldmap.IBillFieldGet;
import nc.itf.arap.prv.IArapVerifyLogPrivate;
import nc.itf.fi.pub.Currency;
import nc.itf.fi.pub.SysInit;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.busibean.SysinitAccessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.md.data.access.NCObject;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.MDPersistenceService;
import nc.pubitf.accperiod.AccountCalendar;
import nc.pubitf.arap.bill.IArapBillPubQueryService;
import nc.pubitf.arap.receivable.IArapReceivableBillPubQueryService;
import nc.pubitf.bd.accessor.GeneralAccessorFactory;
import nc.pubitf.bd.accessor.IGeneralAccessor;
import nc.pubitf.pu.m21.arap.mf1.IOrderQueryForVerify;
import nc.pubitf.pu.m25.ap.f1.IInvoiceQueryForVerify;
import nc.pubitf.so.m30.sobalance.ISoBalance4VerifyQryBill;
import nc.pubitf.uapbd.CurrencyRateUtilHelper;
import nc.vo.arap.agiotage.AgiotageChildVO;
import nc.vo.arap.agiotage.ArapBusiDataVO;
import nc.vo.arap.agiotage.ArapBusiDataVOList;
import nc.vo.arap.basebill.BaseAggVO;
import nc.vo.arap.basebill.BaseBillVO;
import nc.vo.arap.basebill.BaseItemVO;
import nc.vo.arap.basebill.IArapItemFieldVO;
import nc.vo.arap.bill.util.ArapVOTransformUtil;
import nc.vo.arap.debttransfer.DebtTransferVO;
import nc.vo.arap.event.IArapBSEventType;
import nc.vo.arap.gathering.GatheringBillItemVO;
import nc.vo.arap.global.ArapBillDealVOConsts;
import nc.vo.arap.pay.PayBillItemVO;
import nc.vo.arap.payable.PayableBillItemVO;
import nc.vo.arap.payable.PayableBillVO;
import nc.vo.arap.pfflow.ArapBillMapVO;
import nc.vo.arap.pfflow.ArapBillMapVOTool;
import nc.vo.arap.pub.ArapBillTypeInfo;
import nc.vo.arap.pub.ArapConstant;
import nc.vo.arap.pub.BillEnumCollection;
import nc.vo.arap.pub.BillEnumCollection.FromSystem;
import nc.vo.arap.receivable.ReceivableBillItemVO;
import nc.vo.arap.sysinit.SysinitConst;
import nc.vo.arap.utils.ARAPModuleEnableUtil;
import nc.vo.arap.utils.ArrayUtil;
import nc.vo.arap.utils.StringUtil;
import nc.vo.arap.verify.AggverifyVO;
import nc.vo.arap.verify.RBVerify;
import nc.vo.arap.verify.SameMnyVerify;
import nc.vo.arap.verify.UnsameMnyVerify;
import nc.vo.arap.verify.VerifyDetailVO;
import nc.vo.arap.verify.VerifyTool;
import nc.vo.arap.verify.VerifyfaVO;
import nc.vo.arap.verifynew.ProxyVerify;
import nc.vo.arap.verifynew.QueryAndRuleFaVO;
import nc.vo.bd.accessor.IBDData;
import nc.vo.fi.pub.SqlUtils;
import nc.vo.fipub.exception.ExceptionHandler;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.SuperVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.pub.MapList;
import nc.vo.pubapp.pattern.pub.PubAppTool;
import nc.vo.tmpub.util.SqlUtil;
import nc.vo.verifynew.pub.ConditionVO;
import nc.vo.verifynew.pub.DefaultVerifyRuleVO;
import nc.vo.verifynew.pub.VerifyCom;
import nccloud.bs.arap.sagas.util.SagasUtils;
import nccloud.bs.arap.util.Collections;
import nccloud.commons.lang.ArrayUtils;
import nccloud.commons.lang.StringUtils;
import nccloud.vo.arap.bdloss.BdLossChildVO;
import nccloud.vo.arap.bdrecovery.BdRecoverySKVO;

@SuppressWarnings("unchecked")
public class BillRegisterForBusiDataBO {

	private static String SPECIAL_KEY = "def1"; // ӦӦڲմֶμ¼εݵ;

	Map<String, ArrayList<AggverifyVO>> aggMap = new HashMap<String, ArrayList<AggverifyVO>>();

	AggregatedValueObject[] aggvos = null;
	
	// add by wenfx 20220615 start
	// TODO ԴӦԴ־¼
	private VerifyLogger log = new VerifyLogger(BillRegisterForBusiDataBO.class.getName());

	private boolean logFlag = false;
	// add by wenfx 20220615 end

	public AggregatedValueObject[] getAggvos() {
		return this.aggvos;
	}

	public void setAggvos(AggregatedValueObject[] aggvos) {
		this.aggvos = aggvos;
	}

	String pkorg = "";

	private String pk_user;

	private Integer syscode;

	public Integer getSyscode() {
		return this.syscode;
	}

	public void setSyscode(Integer syscode) {
		this.syscode = syscode;
	}

	public String getPkorg() {
		return this.pkorg;
	}

	public void setPkorg(String pkorg) {
		this.pkorg = pkorg;
	}

	public String getPk_user() {
		return this.pk_user;
	}

	public void setPk_user(String pkUser) {
		this.pk_user = pkUser;
	}

	/**
	 * ͳһӿ
	 * 
	 * @param obj
	 * @return
	 */
	protected AggregatedValueObject[] dealUserObj(Object obj) {
		if (obj instanceof BusinessEvent.BusinessUserObj) {
			obj = ((BusinessEvent.BusinessUserObj) obj).getUserObj();
		}
		AggregatedValueObject[] retvos = null;
		if (obj.getClass().isArray()) {
			retvos = (AggregatedValueObject[]) obj;
		} else {
			retvos = new AggregatedValueObject[] { (AggregatedValueObject) obj };
		}
		this.pk_user = (String) retvos[0].getParentVO().getAttributeValue(ArapBusiDataVO.APPROVER);
		this.syscode = (Integer) retvos[0].getParentVO().getAttributeValue(ArapBusiDataVO.SYSCODE);
		this.pkorg = (String) retvos[0].getParentVO().getAttributeValue(ArapBusiDataVO.PK_ORG);
		return retvos;
	}

	/**
	 * ҵ񵥾ݵ˽ӿ
	 */
	public void doAction(IBusinessEvent event) throws BusinessException {
		this.doBusiAction(event);
	}

	/**
	 * չ
	 * 
	 * @param vos
	 * @param ruleVOMap
	 * @param com
	 * @throws BusinessException
	 * @throws MetaDataException
	 */
	private void billRBVerifyBySrcBillForExtend(AggregatedValueObject[] vos,
			Hashtable<String, DefaultVerifyRuleVO> ruleVOMap, VerifyCom verifyCom)
			throws BusinessException, MetaDataException {
		// ѯչ򣬽д
		List<Object> rules = ArapBusiPluginCenter.getAllVerifyrulePlugins(getSyscode());

		ArrayList<AggverifyVO> aggVOList = new ArrayList<AggverifyVO>();
		BillVerifyRuleInvoker ruleInvoker = null;
		for (AggregatedValueObject vo : vos) {
			for (Object vrule : rules) {
				ruleInvoker = new BillVerifyRuleInvoker(vrule);
				if (ruleInvoker.isMatch((BaseAggVO) vo)) {
					// ո֧ͬԶֹڵ㷴֧,ÿҪʹöverifycom
					VerifyCom com = new VerifyCom();
					com.setIsauto(UFBoolean.TRUE);
					if (vrule instanceof BillVerifyRule
							&& "nc.impl.fct.pub.verify.FctBillVerifyRule".equals(vrule.getClass().getName())) {
						// ոͬעĺչ
						com.setIsauto(UFBoolean.FALSE);
						com.setIsreserve(VerifyDetailVO.reserve_fct);
					}

					String[] matchFields = ruleInvoker.getMatchFields();
					for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
						rule.setM_creditObjKeys(matchFields);
						rule.setM_debtObjKeys(matchFields);
					}

					String queryOpBillSql = ruleInvoker.getQueryOpBillSql((BaseAggVO) vo);
					NCObject[] objectByCond = null;
					if (PubAppTool.isNull(queryOpBillSql)) {
						objectByCond = MDPersistenceService.lookupPersistenceQueryService()
								.queryBillOfNCObjectByCond(ArapBusiDataVO.class, " 1=2 ", false);
					} else {
						objectByCond = MDPersistenceService.lookupPersistenceQueryService().queryBillOfNCObjectByCond(
								ArapBusiDataVO.class, queryOpBillSql + " and billclass in ('yf','ys','fk','sk') ",
								false);
					}

					List<ArapBusiDataVO> jfList = new ArrayList<ArapBusiDataVO>();
					List<ArapBusiDataVO> dfList = new ArrayList<ArapBusiDataVO>();
					// ֱ Է
					if (objectByCond != null) {
						for (NCObject data : objectByCond) {
							ArapBusiDataVO busiDataVO = (ArapBusiDataVO) data.getContainmentObject();
							busiDataVO.setAttributeValue(ArapBusiDataVO.SETT_MONEY, busiDataVO.getOccupationmny());

							if (busiDataVO.getDirection().intValue() == 1) {
								jfList.add(busiDataVO);
							} else {
								dfList.add(busiDataVO);
							}
						}
					}
					this.aggMap.clear();
					this.aggMap = this.onVerify(com, ruleVOMap, jfList.toArray(new ArapBusiDataVO[0]),
							dfList.toArray(new ArapBusiDataVO[0]));
					aggVOList.addAll(this.getAggVerifyVO(this.aggMap, UFBoolean.FALSE));
					if (aggVOList != null && aggVOList.size() > 0) {
						NCLocator.getInstance().lookup(IArapVerifyLogPrivate.class).save(aggVOList, ruleVOMap, com);
						// ²ѯݱϢ
						this.reQueryBillIteminfo(vo);

						aggVOList.clear();
					}
					this.aggMap.clear();

					// ruleԱʹ
					for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
						rule.setM_creditObjKeys(null);
						rule.setM_debtObjKeys(null);
					}
				}
			}
		}
	}

	private void reQueryBillIteminfo(AggregatedValueObject vo) throws BusinessException {
		CircularlyAccessibleValueObject[] childrenVO = vo.getChildrenVO();
		List<String> pks = new ArrayList<String>();
		for (CircularlyAccessibleValueObject s : childrenVO) {
			pks.add(s.getPrimaryKey());
		}

		if (vo.getParentVO().getAttributeValue(IBillFieldGet.PK_BILLTYPE).equals(IBillFieldGet.F0)) {
			IArapReceivableBillPubQueryService service = NCLocator.getInstance()
					.lookup(IArapReceivableBillPubQueryService.class);
			try {
				ReceivableBillItemVO[] items = service.queryRecieableBillItem(pks.toArray(new String[pks.size()]));
				vo.setChildrenVO(items);
			} catch (BusinessException e) {
				ExceptionHandler.handleException(e);
			}
		} else if (vo.getParentVO().getAttributeValue(IBillFieldGet.PK_BILLTYPE).equals(IBillFieldGet.F1)) {
			try {
				Collection<PayableBillItemVO> bills = MDPersistenceService.lookupPersistenceQueryService()
						.queryBillOfVOByPKs(PayableBillItemVO.class, pks.toArray(new String[pks.size()]), false);
				PayableBillItemVO[] items = bills.toArray(new PayableBillItemVO[] {});
				vo.setChildrenVO(items);
			} catch (BusinessException e) {
				ExceptionHandler.handleException(e);
			}
		}
	}

	private void doBusiAction(IBusinessEvent event) throws BusinessException, MetaDataException, DAOException {
		// Ч
		long t1 = System.currentTimeMillis();
		if (IArapBSEventType.TYPE_EFFECTION_AFTER.equals(event.getEventType())) {
			BusinessEvent e = (BusinessEvent) event;
			if (null != e.getUserObject()) {
				AggregatedValueObject[] vos = this.dealUserObj(e.getUserObject());
				
				// add by wenfx 20220615 start
				// TODO ֻ¼ԴӦЧ
				if ("F1-Cxx-W02".equals(vos[0].getParentVO().getAttributeValue(PayableBillVO.PK_TRADETYPE))
						&& vos[0].getParentVO().getAttributeValue(PayableBillVO.DEF1) != null) {
//					List<Object> ret = (List<Object>) NCLocator.getInstance().lookup(IUAPQueryBS.class).executeQuery(
//							"select billid from sap_po_log where billid='" + vos[0].getParentVO().getPrimaryKey() + "'",
//							new ColumnListProcessor());
//					if (ret != null && ret.size() > 0) {
						log.info(vos[0].getParentVO().getPrimaryKey());
						logFlag = true;
//					}
				}
				// add by wenfx 20220615 end
				
				this.setAggvos(vos);
				for (AggregatedValueObject obj : vos) {
					CircularlyAccessibleValueObject parentVO = obj.getParentVO();
					UFBoolean isinit = (UFBoolean) parentVO.getAttributeValue("isinit");
					if (isinit != null && isinit.booleanValue()) {
						// ڳݣ˼ֱӷ
						if(logFlag) {
							log.info("ڳʶΪڳδֱӽ");
						}
						return;
					}
				}

				List<ArapBusiDataVO> busiDataVOList = new ArapVOTransformUtil().transform(vos);
				doInsertRegister(busiDataVOList);

				if (busiDataVOList != null && busiDataVOList.size() > 0 && !SagasUtils.isCompensateStage()) {
					// sagabusidata ׶β
					SagasUtils.frozenAndAddSaga(SagasUtils.OTHER,
							busiDataVOList.toArray(new ArapBusiDataVO[busiDataVOList.size()]), IBillFieldGet.BILLNO,
							busiDataVOList.get(0).getPk_billtype());
				}

				for (AggregatedValueObject obj : vos) {
					String billclass = (String) obj.getParentVO().getAttributeValue("billclass");
					if (billclass != null && (billclass.equals(ArapConstant.ARAP_ZS_BILLCLASS)
							|| billclass.equals(ArapConstant.ARAP_ZF_BILLCLASS))) {
						if (logFlag) {
							log.info("billclassΪ" + billclass + "δֱӽ");
						}
						return;
					}
				}

				// ʽɵԶ
				List<String> pks = new ArrayList<String>();
				List<ArapBillMapVO> scmList = new ArrayList<ArapBillMapVO>();
				List<ArapBillMapVO> defF2List = new ArrayList<ArapBillMapVO>();
				List<ArapBillMapVO> psList = new ArrayList<ArapBillMapVO>();
				List<ArapBillMapVO> pcmListNoMatch = new ArrayList<ArapBillMapVO>();
				MapList<String, ArapBillMapVO> pcmListBatchNoMatch = new MapList<String, ArapBillMapVO>();
				List<ArapBillMapVO> pcmListMatch = new ArrayList<ArapBillMapVO>();
				Hashtable<String, DefaultVerifyRuleVO> ruleVOMap = this.creatVerifyRuleVO();
				VerifyCom com = new VerifyCom();

				// begin
				// Ԥݺ add by zhaoyanf
				vos = billPreVerify(vos, ruleVOMap, com);
				// end

				// ոҵע
				this.billRBVerifyBySrcBillForExtend(vos, ruleVOMap, null);

				// Զ
				String pk_billtype = "";
				Map<String, VerifyfaVO> tradetypes = new HashMap<String, VerifyfaVO>();
				MapList<VerifyfaVO, String> tradeTypeBills = new MapList<VerifyfaVO, String>();
				for (AggregatedValueObject vo : vos) {
					VerifyfaVO faVO = null;
					// Դϵͳ
					Integer src_syscode = (Integer) vo.getParentVO().getAttributeValue(IBillFieldGet.SRC_SYSCODE);
					BaseItemVO[] childrenVO = (BaseItemVO[]) vo.getChildrenVO();

					pk_billtype = (String) vo.getParentVO().getAttributeValue(IBillFieldGet.PK_BILLTYPE);
					if (IBillFieldGet.F0.equals(pk_billtype) || IBillFieldGet.F2.equals(pk_billtype)) {
						faVO = new VerifyfaVO();
						faVO.setNode_code("20060VPS");
					} else if (IBillFieldGet.F1.equals(pk_billtype) || IBillFieldGet.F3.equals(pk_billtype)) {
						faVO = new VerifyfaVO();
						faVO.setNode_code("20080VPS");
					}
					if (faVO != null) {
						String pk_org = (String) vo.getParentVO().getAttributeValue(IBillFieldGet.PK_ORG);
						String pk_tradetype = (String) vo.getParentVO().getAttributeValue(IBillFieldGet.PK_TRADETYPEID);
						String key = pk_org + pk_tradetype;
						faVO.setPk_org(pk_org);
						faVO.setBf_transtype(pk_tradetype);
						if (!tradetypes.containsKey(key)) {
							tradetypes.put(key, faVO);
							tradeTypeBills.put(faVO, vo.getParentVO().getPrimaryKey());
						} else {
							tradeTypeBills.put(tradetypes.get(key), vo.getParentVO().getPrimaryKey());
						}
					}

					if (ArapBillDealVOConsts.BILLTYPE_21.equals(childrenVO[0].getTop_billtype())
							|| ArapBillDealVOConsts.BILLTYPE_36D1.equals(childrenVO[0].getTop_billtype())
							|| ArapBillDealVOConsts.BILLTYPE_36D7.equals(childrenVO[0].getTop_billtype())) {
						for (BaseItemVO itemVO : childrenVO) {
							if ((ArapBillDealVOConsts.BILLTYPE_36D1.equals(childrenVO[0].getTop_billtype())
									|| ArapBillDealVOConsts.BILLTYPE_36D7.equals(childrenVO[0].getTop_billtype()))
									&& ArapBillDealVOConsts.BILLTYPE_21.equals(childrenVO[0].getSrc_billtype())) {
								// ɹ--ֱӰչӦԶ߼
								ArapBillMapVO mapVO = ArapBillMapVOTool
										.changeVotoBillMapNew((BaseBillVO) vo.getParentVO(), itemVO);
								mapVO.setS_itemid(itemVO.getPurchaseorder());// 
								// ͸Ϊ21classname_pu  classname_ps ƥʱƥ䵽 classname_ps
								// Ӷȡ com.setReserveFlag(VerifyDetailVO.reserve_pc)Ԥռýд
								mapVO.setS_billid(itemVO.getSrc_billid());
								mapVO.setS_billtype(ArapBillDealVOConsts.BILLTYPE_21);
								scmList.add(mapVO);

							} else if (itemVO.getTop_termch() == null) {
								ArapBillMapVO mapVO = ArapBillMapVOTool
										.changeVotoBillMapNew((BaseBillVO) vo.getParentVO(), itemVO);
								mapVO.setS_itemid(itemVO.getPurchaseorder());// 
								scmList.add(mapVO);
							} else {
								// Ӧ--,Զֹ֧ڵ㷴
								ArapBillMapVO mapVO = new ArapBillMapVO();
								mapVO.setT_itemid(itemVO.getPrimaryKey());
								mapVO.setS_termid(itemVO.getTop_termch());
								mapVO.setS_itemid(itemVO.getPrimaryKey());
								mapVO.setS_system(src_syscode);
								mapVO.setS_billtype(itemVO.getTop_billtype());
								mapVO.setYbje(itemVO.getMoney_bal());
								psList.add(mapVO);
							}
						}
					} else if (ArapBillDealVOConsts.BILLTYPE_25.equals(childrenVO[0].getTop_billtype())
							|| ArapBillDealVOConsts.BILLTYPE_45.equals(childrenVO[0].getTop_billtype())
							|| ArapBillDealVOConsts.BILLTYPE_Z2.equals(childrenVO[0].getTop_billtype())) {
						for (BaseItemVO itemVO : childrenVO) {
							ArapBillMapVO mapVO = ArapBillMapVOTool.changeVotoBillMapNew((BaseBillVO) vo.getParentVO(),
									itemVO);
							scmList.add(mapVO);
						}
					} else if (ArapBillDealVOConsts.BILLTYPE_30.equals(childrenVO[0].getSrc_billtype())
							|| ArapBillDealVOConsts.BILLTYPE_Z3.equals(childrenVO[0].getTop_billtype())
							|| ArapBillDealVOConsts.BILLTYPE_32.equals(childrenVO[0].getTop_billtype())) {
						for (BaseItemVO itemVO : childrenVO) {
							ArapBillMapVO mapVO = ArapBillMapVOTool
									.changeVotoBillMapNewForSo((BaseBillVO) vo.getParentVO(), itemVO);
							scmList.add(mapVO);
						}
					} else if (ArapBillDealVOConsts.BILLTYPE_4D48.equals(childrenVO[0].getTop_billtype())
							|| ArapBillDealVOConsts.BILLTYPE_4D50.equals(childrenVO[0].getTop_billtype())
							|| ArapBillDealVOConsts.BILLTYPE_4D46.equals(childrenVO[0].getTop_billtype())
							|| "4D52".equals(childrenVO[0].getTop_billtype())
							|| "4D39".equals(childrenVO[0].getTop_billtype())
							|| "4D83".equals(childrenVO[0].getTop_billtype())
							|| "4D53".equals(childrenVO[0].getTop_billtype())
							|| "4D33".equals(childrenVO[0].getTop_billtype())) {
						Set<String> set_4D46 = new HashSet<String>();
						Set<String> set_other = new HashSet<String>();
						for (BaseItemVO itemVO : childrenVO) {
							String srcBillid = itemVO.getSrc_billid();
							if (StringUtils.isNotEmpty(srcBillid)) {
								if (ArapBillDealVOConsts.BILLTYPE_4D46.equals(childrenVO[0].getTop_billtype())) {
									set_4D46.add(srcBillid);
								} else {
									set_other.add(srcBillid);
								}
							}
						}
						if (set_4D46.size() > 0) {
							Collection<PayableBillItemVO> itemVOList = MDPersistenceService
									.lookupPersistenceQueryService().queryBillOfVOByCond(
											ArapBillTypeInfo.getInstance(IBillFieldGet.F1).getItemvoClass(),
											SqlUtils.getInStr(IArapItemFieldVO.SRC_BILLID,
													set_4D46.toArray(new String[set_4D46.size()]), true)
													+ " and dr = 0",
											false);
							if (itemVOList != null && !itemVOList.isEmpty()) {
								Map<String, List<PayableBillItemVO>> srcMap = new HashMap<String, List<PayableBillItemVO>>();
								for (PayableBillItemVO itemCollection : itemVOList) {
									String src_billid = itemCollection.getSrc_billid();
									if (!srcMap.containsKey(src_billid)) {
										srcMap.put(src_billid, new ArrayList<PayableBillItemVO>());
									}
									srcMap.get(src_billid).add(itemCollection);
								}
								for (BaseItemVO itemVO : childrenVO) {
									String srcBillid = itemVO.getSrc_billid();
									if (StringUtils.isNotEmpty(srcBillid) && ArapBillDealVOConsts.BILLTYPE_4D46
											.equals(childrenVO[0].getTop_billtype())) {
										List<PayableBillItemVO> payableBillItemList = srcMap.get(srcBillid);
										if (payableBillItemList != null && payableBillItemList.size() > 0) {
											for (PayableBillItemVO item : payableBillItemList) {
												ArapBillMapVO mapVO = new ArapBillMapVO();
												mapVO.setT_itemid(itemVO.getPrimaryKey());
												mapVO.setS_itemid(item.getPrimaryKey());
												mapVO.setS_system(1);// Ӧ

												if (!StringUtil.isEmpty(itemVO.getSrc_itemid())
														&& !StringUtil.isEmpty(item.getSrc_itemid())
														&& itemVO.getSrc_itemid().equals(item.getSrc_itemid())) {
													pcmListMatch.add(mapVO);
												} else {
													pcmListBatchNoMatch.put(item.getParentPK(), mapVO);
												}
											}
										}
									}
								}
								srcMap.clear();
							}
						}

						if (set_other.size() > 0) {
							Collection<PayBillItemVO> itemVOList = MDPersistenceService.lookupPersistenceQueryService()
									.queryBillOfVOByCond(
											ArapBillTypeInfo.getInstance(IBillFieldGet.F3).getItemvoClass(),
											SqlUtils.getInStr(IArapItemFieldVO.SRC_BILLID,
													set_other.toArray(new String[set_other.size()]), true)
													+ " and dr = 0",
											false);
							if (itemVOList != null && !itemVOList.isEmpty()) {
								Map<String, List<PayBillItemVO>> srcMapOther = new HashMap<String, List<PayBillItemVO>>();
								for (PayBillItemVO itemVO : itemVOList) {
									String src_billid = itemVO.getSrc_billid();
									if (!srcMapOther.containsKey(src_billid)) {
										srcMapOther.put(src_billid, new ArrayList<PayBillItemVO>());
									}
									srcMapOther.get(src_billid).add(itemVO);
								}
								for (BaseItemVO itemVO : childrenVO) {
									String srcBillid = itemVO.getSrc_billid();
									if (StringUtils.isNotEmpty(srcBillid) && !ArapBillDealVOConsts.BILLTYPE_4D46
											.equals(childrenVO[0].getTop_billtype())) {
										List<PayBillItemVO> payBillItemList = srcMapOther.get(srcBillid);
										if (payBillItemList != null && payBillItemList.size() > 0) {
											for (PayBillItemVO item : payBillItemList) {
												ArapBillMapVO mapVO = new ArapBillMapVO();
												mapVO.setT_itemid(itemVO.getPrimaryKey());
												mapVO.setS_itemid(item.getPrimaryKey());
												mapVO.setS_system(1);// Ӧ

												if (!StringUtil.isEmpty(itemVO.getSrc_itemid())
														&& !StringUtil.isEmpty(item.getSrc_itemid())
														&& itemVO.getSrc_itemid().equals(item.getSrc_itemid())) {
													pcmListMatch.add(mapVO);
												} else {
													pcmListBatchNoMatch.put(item.getParentPK(), mapVO);
												}
											}
										}

									}
								}
								srcMapOther.clear();
							}
						}
						set_4D46.clear();
						set_other.clear();
					} else if ("4D62".equals(childrenVO[0].getTop_billtype()) && IBillFieldGet.F2.equals(pk_billtype)) {
						// 4D60 - 4D65 - F0
						// 4D60 - 4D62 - F2
						// ͬͬӦպտ
						Set<String> srcbillSet = new HashSet<String>(); // տ
						for (BaseItemVO itemVO : childrenVO) {
							srcbillSet.add(itemVO.getSrc_billid());

						}

						if (srcbillSet.size() > 0) {
							Collection<ReceivableBillItemVO> itemVOList = MDPersistenceService
									.lookupPersistenceQueryService().queryBillOfVOByCond(
											ArapBillTypeInfo.getInstance(IBillFieldGet.F0).getItemvoClass(),
											SqlUtils.getInStr(IArapItemFieldVO.SRC_BILLID,
													srcbillSet.toArray(new String[srcbillSet.size()]), true)
													+ " and dr = 0",
											false);

							if (itemVOList != null && itemVOList.size() > 0) {
								Map<String, List<ReceivableBillItemVO>> srcbill2map = new HashMap<String, List<ReceivableBillItemVO>>();
								for (ReceivableBillItemVO itemVO : itemVOList) {
									String src_billid = itemVO.getSrc_billid();
									if (!srcbill2map.containsKey(src_billid)) {
										srcbill2map.put(src_billid, new ArrayList<ReceivableBillItemVO>());
									}
									srcbill2map.get(src_billid).add(itemVO);
								}

								for (BaseItemVO itemVO : childrenVO) {
									if (StringUtil.isEmpty(itemVO.getSrc_billid())) {
										continue;
									}

									List<ReceivableBillItemVO> values = srcbill2map.get(itemVO.getSrc_billid());
									if (values != null && values.size() != 0) {
										for (ReceivableBillItemVO item : values) {
											ArapBillMapVO mapVO = new ArapBillMapVO();
											mapVO.setT_itemid(itemVO.getPrimaryKey());
											mapVO.setS_itemid(item.getPrimaryKey());
											pcmListNoMatch.add(mapVO);
										}
									}
								}
								srcbill2map.clear();
							}
						}
					} else if ("4D65".equals(childrenVO[0].getTop_billtype()) && IBillFieldGet.F0.equals(pk_billtype)) {
						Set<String> srcbillSet = new HashSet<String>();
						for (BaseItemVO itemVO : childrenVO) {
							if (!StringUtil.isEmpty(itemVO.getSrc_billid())) {
								srcbillSet.add(itemVO.getSrc_billid());
							}
						}
						if (srcbillSet.size() > 0) {
							Collection<GatheringBillItemVO> itemVOList = MDPersistenceService
									.lookupPersistenceQueryService().queryBillOfVOByCond(
											ArapBillTypeInfo.getInstance(IBillFieldGet.F2).getItemvoClass(),
											SqlUtils.getInStr(IArapItemFieldVO.SRC_BILLID,
													srcbillSet.toArray(new String[srcbillSet.size()]), true)
													+ " and dr = 0",
											false);

							if (itemVOList != null && itemVOList.size() > 0) {
								Map<String, List<GatheringBillItemVO>> srcbill2map = new HashMap<String, List<GatheringBillItemVO>>();
								for (GatheringBillItemVO itemVO : itemVOList) {
									String src_billid = itemVO.getSrc_billid();
									if (!srcbill2map.containsKey(src_billid)) {
										srcbill2map.put(src_billid, new ArrayList<GatheringBillItemVO>());
									}
									srcbill2map.get(src_billid).add(itemVO);
								}

								for (BaseItemVO itemVO : childrenVO) {
									if (StringUtil.isEmpty(itemVO.getSrc_billid())) {
										continue;
									}
									List<GatheringBillItemVO> values = srcbill2map.get(itemVO.getSrc_billid());
									if (values != null && values.size() != 0) {
										for (GatheringBillItemVO item : values) {
											ArapBillMapVO mapVO = new ArapBillMapVO();
											mapVO.setT_itemid(itemVO.getPrimaryKey());
											mapVO.setS_itemid(item.getPrimaryKey());
											pcmListNoMatch.add(mapVO);
										}
									}
								}
								srcbill2map.clear();
							}
						}
					}

					if (ArapBillDealVOConsts.BILLTYPE_36D1.equals(childrenVO[0].getTop_billtype())
							|| ArapBillDealVOConsts.BILLTYPE_36D7.equals(childrenVO[0].getTop_billtype())) {
						for (BaseItemVO itemVO : childrenVO) {
							String srcBillid = itemVO.getSrc_billid();
							if (StringUtils.isNotEmpty(srcBillid)) {
								Collection<PayableBillItemVO> itemCollections = MDPersistenceService
										.lookupPersistenceQueryService().queryBillOfVOByCond(
												ArapBillTypeInfo.getInstance(IBillFieldGet.F1).getItemvoClass(),
												SqlUtils.getInStr(IArapItemFieldVO.SRC_BILLID,
														new String[] { srcBillid }, true) + " and pk_org='"
														+ itemVO.getPk_org() + "' and dr = 0",
												false);
								if (itemCollections != null) {
									for (PayableBillItemVO item : itemCollections) {
										ArapBillMapVO mapVO = new ArapBillMapVO();
										mapVO.setT_itemid(itemVO.getPrimaryKey());
										mapVO.setS_itemid(item.getPrimaryKey());
										mapVO.setS_system(1);// Ӧ

										if (itemVO.getSrc_itemid() != null) {
											if (!itemVO.getSrc_itemid().equals(item.getSrc_itemid())) {
												continue;
											}
											pcmListMatch.add(mapVO);
										} else {
											pcmListBatchNoMatch.put(item.getParentPK(), mapVO);
										}
									}
								}
							}
						}
					}
					UFBoolean isrefund = (UFBoolean) vo.getParentVO().getAttributeValue(IBillFieldGet.ISREFUND);
					// ӦӦڲĵݽԶ + ˿ݵĺ
					if (src_syscode.intValue() == FromSystem.AR.VALUE.intValue()
							|| src_syscode.intValue() == FromSystem.AP.VALUE.intValue()
							|| (isrefund != null && isrefund.booleanValue())) {
						pks.add(vo.getParentVO().getPrimaryKey());
					}

					// ӦӦƵĻϵͳݹտܽϵ
					if (vo.getParentVO().getAttributeValue(IBillFieldGet.PK_BILLTYPE).equals(IBillFieldGet.F2)) {
						for (BaseItemVO itemVO : childrenVO) {
							ArapBillMapVO mapVO = ArapBillMapVOTool
									.changeVotoBillMapNewForSo((BaseBillVO) vo.getParentVO(), itemVO);
							defF2List.add(mapVO);
						}
					}
				}
				try {
					if (scmList != null && !scmList.isEmpty()) {
						// Ӧ ѯغϵ
						if (scmList.get(0).getS_billtype() == null) {
							// ɹ-Ӧ ɹ-ͬ- Զ
							this.VerifyByContractNo(scmList, com, ruleVOMap);
							if (logFlag) {
								log.info("߹Ӧδֱӽ");
							}
							return;
						}
						List<ArapBillMapVO> newList = new ArrayList<ArapBillMapVO>();
						newList.addAll(scmList);
						List<ArapBillMapVO> puList1 = new ArrayList<ArapBillMapVO>();
						for (ArapBillMapVO vo : scmList) {
							if (StringUtils.isEmpty(vo.getS_itemid())) {
							} else {
								puList1.add(vo);
							}
						}
						Map<ArapBillMapVO, Collection<ArapBillMapVO>> arapBillMap = null;
						if (scmList.get(0).getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_21)) {
							com.setReserveFlag(VerifyDetailVO.reserve_pu);
							com.setIsauto(UFBoolean.FALSE);
							if (Collections.isNotEmpty(puList1)) {
								arapBillMap = NCLocator.getInstance().lookup(IInvoiceQueryForVerify.class)
										.queryArapBillmap(scmList.toArray(new ArapBillMapVO[0]));
							}
						} else if (scmList.get(0).getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_36D7)
								|| scmList.get(0).getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_36D1)) {
							if (ARAPModuleEnableUtil.isPUEnable(InvocationInfoProxy.getInstance().getGroupId())) {
								com.setReserveFlag(VerifyDetailVO.reserve_pc);
								com.setIsauto(UFBoolean.FALSE);
								if (Collections.isNotEmpty(puList1)) {
									arapBillMap = NCLocator.getInstance().lookup(IInvoiceQueryForVerify.class)
											.queryArapBillmap(scmList.toArray(new ArapBillMapVO[0]));
								}
							}
						} else if (scmList.get(0).getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_25)
								|| scmList.get(0).getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_45)) {
							com.setReserveFlag(VerifyDetailVO.reserve_pu);
							com.setIsauto(UFBoolean.FALSE);
							if (Collections.isNotEmpty(puList1)) {
								arapBillMap = NCLocator.getInstance().lookup(IOrderQueryForVerify.class)
										.queryArapBillmap(scmList.toArray(new ArapBillMapVO[0]));
							}
						} else if (scmList.get(0).getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_30)
								|| scmList.get(0).getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_32)) {
							com.setReserveFlag(VerifyDetailVO.reserve_so);
							com.setIsauto(UFBoolean.TRUE);
							if (Collections.isNotEmpty(puList1)) {
								arapBillMap = NCLocator.getInstance().lookup(ISoBalance4VerifyQryBill.class)
										.queryArapBillmap(scmList.toArray(new ArapBillMapVO[0]));
							}
						}

						this.printMapForDebug(arapBillMap);

						Collection<Collection<ArapBillMapVO>> mapCollections = null;
						if (arapBillMap != null && arapBillMap.size() > 0) {
							arapBillMap = ArapBillMapVOTool.combineSameSourceBillMap(arapBillMap);

							// ֯صmapvo
							for (ArapBillMapVO vo : arapBillMap.keySet()) {
								Collection<ArapBillMapVO> collection = arapBillMap.get(vo);
								for (ArapBillMapVO vo1 : collection) {
									vo1.setT_billid(vo.getT_billid());
									vo1.setT_billtype(vo.getT_billtype());
									vo1.setT_itemid(vo.getT_itemid());
									vo1.setPk_currtype(vo.getPk_currtype());
								}
							}
							//  --ԹӦ
							mapCollections = arapBillMap.values();
							for (Collection<ArapBillMapVO> collection : mapCollections) {
								this.doVerifyWithMap(collection, ruleVOMap, com, null);
							}
						}
						// ɹ-Ӧ ɹ-ͬ- Զ
						this.VerifyByContractNo(newList, com, ruleVOMap);
					}
					/**
					 * add by ҫ 2019-5-14 ҵҵӦԴGUID begin
					 */
					String djlxbm = (String) vos[0].getParentVO().getAttributeValue("pk_tradetype");
					if ("F3-Cxx-W01".equals(djlxbm) || "F1-Cxx-W02".equals(djlxbm)) {
						VerifyByGuid(vos, com, ruleVOMap);
					}
					if ("F1-Cxx-W01".equals(djlxbm) || "F1-Cxx-W02".equals(djlxbm)) {
						return;
					}
					/**
					 * add by ҫ 2019-5-14 ҵҵӦԴGUID end
					 */

					// տѾ۶Ԥ
					if (defF2List.size() > 0) {
						Map<ArapBillMapVO, Collection<ArapBillMapVO>> arapBillMap = null;

						if (ARAPModuleEnableUtil.isSOEnable(InvocationInfoProxy.getInstance().getGroupId())) {
							arapBillMap = NCLocator.getInstance().lookup(ISoBalance4VerifyQryBill.class)
									.queryArapBillmap(scmList.toArray(new ArapBillMapVO[0]));
							com.setReserveFlag(VerifyDetailVO.reserve_so);
						}

						Collection<Collection<ArapBillMapVO>> mapCollections = null;
						if (arapBillMap != null && arapBillMap.size() > 0) {
							arapBillMap = ArapBillMapVOTool.combineSameSourceBillMap(arapBillMap);

							// ֯صmapvo
							for (ArapBillMapVO vo : arapBillMap.keySet()) {
								Collection<ArapBillMapVO> collection = arapBillMap.get(vo);
								for (ArapBillMapVO vo1 : collection) {
									vo1.setT_billid(vo.getT_billid());
									vo1.setT_billtype(vo.getT_billtype());
									vo1.setT_itemid(vo.getT_itemid());
									vo1.setPk_currtype(vo.getPk_currtype());
								}
							}
							//  --ԹӦ
							mapCollections = arapBillMap.values();
							com.setIsauto(UFBoolean.TRUE);
							for (Collection<ArapBillMapVO> collection : mapCollections) {
								this.doVerifyWithMap(collection, ruleVOMap, com, null);
							}
						}
					}

					if (pks != null && pks.size() > 0) {
						com.setReserveFlag(VerifyDetailVO.reserve_arap);
						com.setExactVerify(true);
						com.setIsauto(UFBoolean.TRUE);
						for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
							rule.setM_creditObjKeys(new String[] { BillRegisterForBusiDataBO.SPECIAL_KEY });
							rule.setM_debtObjKeys(new String[] { BillRegisterForBusiDataBO.SPECIAL_KEY });
						}
						// arapڲĵʱԶ
						Collection<ArapBillMapVO> billMapData = new BaseDAO().retrieveByClause(ArapBillMapVO.class,
								SqlUtils.getInStr("t_billid", pks.toArray(new String[] {}), true)
										+ " and ISMANUAL<>'Y'");
						// arapڲԶ˿Чɵ˿տԴӦյԶ
						UFBoolean isrefund = (UFBoolean) vos[0].getParentVO().getAttributeValue(IBillFieldGet.ISREFUND);
						if (isrefund != null && isrefund.booleanValue()) {
							com.setRefund(true);
						}
						this.doArapVerifyWithMap(billMapData, ruleVOMap, com);
						this.updateBillMapYbye(billMapData, true, null);
					}

					// ʽĸų̵
					if (psList != null && !psList.isEmpty()) {
						for (String key : ruleVOMap.keySet()) {
							DefaultVerifyRuleVO ruleVO = ruleVOMap.get(key);
							ruleVO.setIsFkpc(new Boolean(true));
						}
						com.setReserveFlag(VerifyDetailVO.reserve_pc);
						com.setIsauto(UFBoolean.TRUE);

						for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
							rule.setM_creditObjKeys(new String[] { SPECIAL_KEY });
							rule.setM_debtObjKeys(new String[] { SPECIAL_KEY });
						}

						this.doVerifyWithMap(psList, ruleVOMap, com, null);
					}
					// ĿԤͽȿĺ
					if (pcmListNoMatch.size() > 0 || pcmListMatch.size() > 0 || pcmListBatchNoMatch.size() > 0) {
						com.setReserveFlag(VerifyDetailVO.reserve_pcm);
						com.setIsauto(UFBoolean.FALSE);
						String billclass = (String) vos[0].getParentVO().getAttributeValue(IBillFieldGet.BILLCLASS);
						if (billclass.equals("ys") || billclass.equals("sk")) {
							for (ArapBillMapVO vo : pcmListNoMatch) {
								List<ArapBillMapVO> voss = new ArrayList<ArapBillMapVO>();
								voss.add(vo);
								this.doVerifyWithMap(voss, ruleVOMap, com);
							}
						} else {
							for (ArapBillMapVO vo : pcmListMatch) {
								List<ArapBillMapVO> voss = new ArrayList<ArapBillMapVO>();
								voss.add(vo);
								this.doVerifyWithMap(voss, ruleVOMap, com);
							}

							for (String key : pcmListBatchNoMatch.keySet()) {
								List<ArapBillMapVO> list = pcmListBatchNoMatch.get(key);
								this.doVerifyWithMap(list, ruleVOMap, com);
							}

							if (pcmListNoMatch.size() > 0) {
								this.doVerifyWithMap(pcmListNoMatch, ruleVOMap, com);
							}
						}
					}

					// Զ
					for (VerifyfaVO faVO : tradeTypeBills.keySet()) {
						if (faVO != null) {
							FaDMO dmo = new FaDMO();
							String sql = "  pk_org='" + faVO.getPk_org() + "' and node_code='" + faVO.getNode_code()
									+ "' and dr=0 and isinit='1'  and ";
							if (IBillFieldGet.F0.equals(pk_billtype) || IBillFieldGet.F3.equals(pk_billtype)) {
								sql += "  (COALESCE(bf_transtype,'~') ='~' or bf_transtype ='' or bf_transtype ='"
										+ faVO.getBf_transtype() + "') order by bf_transtype";
							} else {
								sql += "   (COALESCE(df_transtype,'~') ='~' or df_transtype ='' or df_transtype ='"
										+ faVO.getBf_transtype() + "') order by df_transtype";
							}
							List<VerifyfaVO> verifyfaVOs = dmo.queryFa(sql);
							if (verifyfaVOs != null && verifyfaVOs.size() > 0) {
								for (VerifyfaVO favo : verifyfaVOs) {
									int szxt = 0;
									if (favo.getNode_code().equals("20060VPS")) {// Ӧ
										szxt = 0;
									} else if (favo.getNode_code().equals("20080VPS")) {// Ӧ
										szxt = 1;
									}
									QueryAndRuleFaVO convertVo = new QueryAndRuleFaVO(favo, favo.getPk_org(),
											InvocationInfoProxy.getInstance().getUserId().trim(), Integer.valueOf(szxt),
											null, new UFDate(InvocationInfoProxy.getInstance().getBizDateTime()));

									ConditionVO condition = convertVo.getFilterConditionVO();
									if (IBillFieldGet.F0.equals(pk_billtype) || IBillFieldGet.F3.equals(pk_billtype)) {
										condition.setAttributeValue("jfFa", " and " + SqlUtils.getInStr("pk_bill",
												tradeTypeBills.get(faVO).toArray(new String[] {}), true));
									} else {
										condition.setAttributeValue("dfFa", " and " + SqlUtils.getInStr("pk_bill",
												tradeTypeBills.get(faVO).toArray(new String[] {}), true));
									}
									DefaultVerifyRuleVO[] rules = convertVo.getRuleVO();
									if (rules == null || rules.length == 0) {
									} else {
										ProxyVerify.getIArapVerifyLogPrivate().autoVerify(condition, rules);
									}
								}
							}
						}
					}
				} catch (BusinessException e1) {
					throw ExceptionHandler.handleException(e1);
				}
			}

		}
		// ȡЧǰ
		else if (IArapBSEventType.TYPE_UNEFFECTION_BEFORE.equals(event.getEventType())) {
			this.uneffectBill(event);
		}

		// -ڳ
		else if (IEventType.TYPE_INSERT_AFTER.equals(event.getEventType())) {
			BusinessEvent e = (BusinessEvent) event;
			if (null != e.getUserObject()) {
				AggregatedValueObject[] vos = this.dealUserObj(e.getUserObject());
				// ڳ󱣴
				UFBoolean isinit = (UFBoolean) vos[0].getParentVO().getAttributeValue("isinit"); // ڳ־
				if (isinit != null && isinit.booleanValue()) {
					List<ArapBusiDataVO> busiDataVOList = new ArapVOTransformUtil().transform(vos);
					this.doInsertRegister(busiDataVOList);
				}
			}
		}

		// ɾ-ڳ
		else if (IEventType.TYPE_DELETE_BEFORE.equals(event.getEventType())) {
			BusinessEvent e = (BusinessEvent) event;
			if (null != e.getUserObject()) {
				AggregatedValueObject[] vos = this.dealUserObj(e.getUserObject());
				List<String> deldata = new ArrayList<String>();
				for (AggregatedValueObject vo : vos) {
					deldata.add(vo.getParentVO().getPrimaryKey());
				}
				this.doCheckBillDeal(deldata);
				this.doDeleteRegisterByBillid(deldata.toArray(new String[] {}));
			}
		}

		if (IEventType.TYPE_UPDATE_AFTER.equals(event.getEventType())) {
			BdUpdateEvent e = (BdUpdateEvent) event;
			if (null != e.getNewObject()) {
				AggregatedValueObject[] vos = this.dealUserObjForInit(e.getNewObject());
				// ڳ󱣴
				UFBoolean isinit = (UFBoolean) vos[0].getParentVO().getAttributeValue("isinit"); // ڳ־
				String pk_bill = vos[0].getParentVO().getPrimaryKey(); // ڳ־
				if (isinit != null && isinit.booleanValue()) {
					// ɾٲ
					new BaseDAO().deleteByClause(ArapBusiDataVO.class, " pk_bill ='" + pk_bill + "'");
					List<ArapBusiDataVO> busiDataVOList = new ArapVOTransformUtil().transform(vos);
					doInsertRegister(busiDataVOList);
				}

			}
		}
		LogTime.debug(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006ver_0",
				"02006ver-0258")/*
								 * @res "BillRegisterForBusiData(ҵ񵥾ݵ˽ӿ)"
								 */, t1);
	}

	private AggregatedValueObject[] billUneffectPreVerify(AggregatedValueObject[] vos, boolean isfkpc)
			throws BusinessException {
		Set<String> billSet = new HashSet<String>();
		Set<String> billtypeSet = new HashSet<String>();
		for (AggregatedValueObject vo : vos) {
			billSet.add(vo.getParentVO().getPrimaryKey());
			billtypeSet.add((String) vo.getParentVO().getAttributeValue(IBillFieldGet.PK_BILLTYPE));
		}

		Collection<ArapBillMapVO> billMapData = new BaseDAO().retrieveByClause(ArapBillMapVO.class,
				SqlUtils.getInStr("t_billid", billSet.toArray(new String[billSet.size()]), true) + " and ISMANUAL='Y'");
		Map<String, UFDouble> key2ybye = this.doUnVerifyWithMap(billMapData, isfkpc, true);

		this.updateBillMapYbye(billMapData, false, key2ybye);

		// 7²ѯ
		IArapBillPubQueryService service = NCLocator.getInstance().lookup(IArapBillPubQueryService.class);
		// 
		BaseAggVO[] bfAggVOs = service.findBillByPrimaryKey(billSet.toArray(new String[0]),
				billtypeSet.toArray(new String[0]));
		return bfAggVOs;
	}

	/**
	 * Ԥĺ
	 * 
	 * @param vos
	 * @param ruleVOMap
	 * @param com
	 * @throws BusinessException
	 */
	private AggregatedValueObject[] billPreVerify(AggregatedValueObject[] vos,
			Hashtable<String, DefaultVerifyRuleVO> ruleVOMap, VerifyCom com) throws BusinessException {
		Set<String> billSet = new HashSet<String>();
		Set<String> billtypeSet = new HashSet<String>();
		for (AggregatedValueObject vo : vos) {
			billSet.add(vo.getParentVO().getPrimaryKey());
			billtypeSet.add((String) vo.getParentVO().getAttributeValue(IBillFieldGet.PK_BILLTYPE));
		}
		// 1ѯԤ
		Collection<ArapBillMapVO> billMapData = new BaseDAO().retrieveByClause(ArapBillMapVO.class,
				SqlUtils.getInStr("t_billid", billSet.toArray(new String[billSet.size()]), true) + " and ISMANUAL='Y'");
		if (billMapData == null || billMapData.isEmpty())
			return vos;
		com.setReserveFlag(VerifyDetailVO.reserve_arap);
		com.setExactVerify(true);
		for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
			rule.setM_creditObjKeys(new String[] { BillRegisterForBusiDataBO.SPECIAL_KEY });
			rule.setM_debtObjKeys(new String[] { BillRegisterForBusiDataBO.SPECIAL_KEY });
		}

		this.aggMap.clear();
		Set<String> pks = new HashSet<String>();
		for (ArapBillMapVO billMapVO : billMapData) {
			pks.add(billMapVO.getS_itemid());
			pks.add(billMapVO.getT_itemid());
		}
		if (pks.isEmpty())
			return vos;
		Collection<ArapBusiDataVO> busiList = new BaseDAO().retrieveByClause(ArapBusiDataVO.class,
				SqlUtils.getInStr("pk_item", pks.toArray(new String[] {}), true) + " and money_bal <> 0 "
						+ " and pausetransact ='N' ");
		if (busiList == null || busiList.isEmpty())
			return vos;
		ArapBusiDataVO[] busiDataVOs = busiList.toArray(new ArapBusiDataVO[busiList.size()]);
		DefaultVerifyRuleVO ruleVO = ruleVOMap.values().iterator().next();
		VerifyTool.sortVector(busiDataVOs, ruleVO.getM_verifySeq());
		// Ƚts ʹ
		Map<String, String> busiDataTsMap = new HashMap<String, String>();
		Map<String, List<ArapBusiDataVO>> pk2BusiDataVO = new HashMap<String, List<ArapBusiDataVO>>();
		for (ArapBusiDataVO vo : busiDataVOs) {
			busiDataTsMap.put(vo.getPk_busidata(), vo.getTs().toString());
			String pk_item = vo.getPk_item();
			if (!pk2BusiDataVO.containsKey(pk_item))
				pk2BusiDataVO.put(pk_item, new ArrayList<ArapBusiDataVO>());
			pk2BusiDataVO.get(pk_item).add(vo);
		}
		com.setBusiDataTsMap(busiDataTsMap);
		com.setIsauto(UFBoolean.TRUE);
		aggMap.clear();

		// 2busidatavoеsett_money;
		for (ArapBillMapVO billMapVO : billMapData) {
			UFDouble sett_money = billMapVO.getYbye();
			// Դ
			List<ArapBusiDataVO> sBusiDataVOList = pk2BusiDataVO.get(billMapVO.getS_itemid());
			setSettmoney(sBusiDataVOList, sett_money);
			// Ŀ
			List<ArapBusiDataVO> tBusiDataVOList = pk2BusiDataVO.get(billMapVO.getT_itemid());
			setSettmoney(tBusiDataVOList, sett_money);
		}

		// 4飺跽vovo
		List<ArapBusiDataVO> jf_vos = new ArrayList<ArapBusiDataVO>();// 跽
		List<ArapBusiDataVO> df_vos = new ArrayList<ArapBusiDataVO>();// 
		for (ArapBusiDataVO vo : busiDataVOs) {
			Integer direction = (Integer) vo.getAttributeValue(ArapBusiDataVO.DIRECTION);
			if (direction.intValue() == 1) {
				jf_vos.add(vo);
			} else {
				df_vos.add(vo);
			}
		}

		// 5
		aggMap = onVerify4Pre(billMapData, com, ruleVOMap, jf_vos.toArray(new ArapBusiDataVO[] {}),
				df_vos.toArray(new ArapBusiDataVO[] {}));
		// 6װvo
		ArrayList<AggverifyVO> aggVOList = this.getAggVerifyVO(aggMap, com.getIsauto());
		this.dealOrgScomment(aggVOList);
		// 7
		if (aggVOList != null && aggVOList.size() > 0) {
			NCLocator.getInstance().lookup(IArapVerifyLogPrivate.class).save(aggVOList, ruleVOMap, com);
		}

		this.updateBillMapYbye(billMapData, true, null);

		// 7²ѯ
		IArapBillPubQueryService service = NCLocator.getInstance().lookup(IArapBillPubQueryService.class);
		// 
		BaseAggVO[] bfAggVOs = service.findBillByPrimaryKey(billSet.toArray(new String[0]),
				billtypeSet.toArray(new String[0]));
		return bfAggVOs;
	}

	/**
	 * Ԥ
	 * 
	 * @param billMapData
	 * @param com
	 * @param ruleVOMap
	 * @param jf_vos
	 * @param df_vos
	 * @return
	 */
	private Map<String, ArrayList<AggverifyVO>> onVerify4Pre(Collection<ArapBillMapVO> billMapData, VerifyCom com,
			Map<String, DefaultVerifyRuleVO> ruleVOMap, ArapBusiDataVO[] jf_vos, ArapBusiDataVO[] df_vos) {

		// Զ ֻкԳ壬ֺͬ
		com.setM_creditSelected(df_vos);
		com.setM_debitSelected(jf_vos);
		AggverifyVO aggvo = null;
		if (!ArrayUtils.isEmpty(jf_vos) || !ArrayUtils.isEmpty(df_vos)) {
			// ڲԳ壬ݼĺԳ
			// дڶԶ
			DefaultVerifyRuleVO rulevo = ruleVOMap.get("RB_VERIFY");
			RBVerify rbverify = new RBVerify(com);
			SameMnyVerify smverify = new SameMnyVerify(com);
			for (ArapBillMapVO billMapVO : billMapData) {
				String s_itemid = billMapVO.getS_itemid();
				String t_itemid = billMapVO.getT_itemid();
				String sDirect = "F0".equals(billMapVO.getS_billtype()) || "F3".equals(billMapVO.getS_billtype()) ? "D"
						: "C";
				String tDirect = "F0".equals(billMapVO.getT_billtype()) || "F3".equals(billMapVO.getT_billtype()) ? "D"
						: "C";
				if (sDirect.equals(tDirect)) {
					int i = 0;
					for (ArapBusiDataVO df_vo : df_vos) {
						if (s_itemid.equals(df_vo.getPk_item()) || t_itemid.equals(df_vo.getPk_item())) {
							df_vo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, billMapVO.getPk_billmap());
						} else {
							df_vo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, i++);
						}
					}
					for (ArapBusiDataVO jf_vo : jf_vos) {
						if (s_itemid.equals(jf_vo.getPk_item()) || t_itemid.equals(jf_vo.getPk_item())) {
							jf_vo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, billMapVO.getPk_billmap());
						} else {
							jf_vo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, i++);
						}
					}
					aggvo = rbverify.onVerify(jf_vos, df_vos, rulevo);
					if (!ArrayUtils.isEmpty(aggvo.getChildrenVO())) {
						if (this.aggMap.containsKey("RB_VERIFY")) {
							this.aggMap.get("RB_VERIFY").add(aggvo);
						} else {
							ArrayList<AggverifyVO> temp = new ArrayList<AggverifyVO>();
							temp.add(aggvo);
							this.aggMap.put("RB_VERIFY", temp);
						}
					}
				} else {
					int i = 0;
					for (ArapBusiDataVO df_vo : df_vos) {
						if (s_itemid.equals(df_vo.getPk_item()) || t_itemid.equals(df_vo.getPk_item())) {
							df_vo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, billMapVO.getPk_billmap());
						} else {
							df_vo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, i++);
						}
					}
					for (ArapBusiDataVO jf_vo : jf_vos) {
						if (s_itemid.equals(jf_vo.getPk_item()) || t_itemid.equals(jf_vo.getPk_item())) {
							jf_vo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, billMapVO.getPk_billmap());
						} else {
							jf_vo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, i++);
						}
					}
					aggvo = smverify.onVerify(jf_vos, df_vos, rulevo);
					if (!ArrayUtils.isEmpty(aggvo.getChildrenVO())) {
						if (this.aggMap.containsKey("SAME_VERIFY")) {
							this.aggMap.get("SAME_VERIFY").add(aggvo);
						} else {
							ArrayList<AggverifyVO> temp = new ArrayList<AggverifyVO>();
							temp.add(aggvo);
							this.aggMap.put("SAME_VERIFY", temp);
						}
					}
				}
			}
		}

		return this.aggMap;

	}

	/**
	 * ýͺʱƥά
	 * 
	 * @param busiDataVOList
	 * @param sett_money
	 */
	private void setSettmoney(List<ArapBusiDataVO> busiDataVOList, UFDouble sett_money) {
		if (busiDataVOList != null && !busiDataVOList.isEmpty()) {
			UFDouble tmp = sett_money;
			for (ArapBusiDataVO busiDataVO : busiDataVOList) {
				if (UFDouble.ZERO_DBL.compareTo(tmp) == 0)
					break;
				int multi = UFDouble.ZERO_DBL.compareTo(busiDataVO.getMoney_bal()) > 0 ? -1 : 1;
				UFDouble settMoney = busiDataVO.getAttributeValue(ArapBusiDataVO.SETT_MONEY) == null ? UFDouble.ZERO_DBL
						: (UFDouble) busiDataVO.getAttributeValue(ArapBusiDataVO.SETT_MONEY);
				UFDouble diffMoney = busiDataVO.getMoney_bal().sub(busiDataVO.getOccupationmny()).sub(settMoney);
				if (sett_money.multiply(busiDataVO.getMoney_bal()).compareTo(UFDouble.ZERO_DBL) < 0) {// Գ
					if (diffMoney.abs().compareTo(tmp.abs()) < 0) {
						busiDataVO.setAttributeValue(ArapBusiDataVO.SETT_MONEY, settMoney.add(diffMoney));
						tmp = tmp.add(diffMoney);
					} else {
						busiDataVO.setAttributeValue(ArapBusiDataVO.SETT_MONEY,
								settMoney.add(tmp.abs().multiply(multi)));
						tmp = UFDouble.ZERO_DBL;
					}
				} else {
					if (diffMoney.abs().compareTo(tmp.abs()) < 0) {
						busiDataVO.setAttributeValue(ArapBusiDataVO.SETT_MONEY, settMoney.add(diffMoney));
						tmp = tmp.sub(diffMoney);
					} else {
						busiDataVO.setAttributeValue(ArapBusiDataVO.SETT_MONEY, settMoney.add(tmp));
						tmp = UFDouble.ZERO_DBL;
					}
				}
			}
		}
	}

	private void printMapForDebug(Map<ArapBillMapVO, Collection<ArapBillMapVO>> arapBillMap) {
		try {
			if (arapBillMap != null) {
				for (ArapBillMapVO vo : arapBillMap.keySet()) {
					Log.getInstance(LogTime.class).debug("ARAPBILLMAP");/* -=notranslate=- */
					Log.getInstance(LogTime.class).debug(vo.getYbje());/* -=notranslate=- */
					Log.getInstance(LogTime.class).debug(vo.getYbye());/* -=notranslate=- */
					Log.getInstance(LogTime.class).debug(vo.getS_itemid());/* -=notranslate=- */
					Log.getInstance(LogTime.class).debug(vo.getT_itemid());/* -=notranslate=- */
					for (ArapBillMapVO svo : arapBillMap.get(vo)) {
						Log.getInstance(LogTime.class).debug(svo.getYbje());/* -=notranslate=- */
						Log.getInstance(LogTime.class).debug(svo.getYbye());/* -=notranslate=- */
						Log.getInstance(LogTime.class).debug(svo.getS_itemid());/* -=notranslate=- */
						Log.getInstance(LogTime.class).debug(svo.getT_itemid());/* -=notranslate=- */
					}
					Log.getInstance(LogTime.class).debug("ENDDDDD");/* -=notranslate=- */
				}
			}
		} catch (Exception e) {
		}
	}

	private void uneffectBill(IBusinessEvent event) throws BusinessException {
		BusinessEvent e = (BusinessEvent) event;
		if (null != e.getUserObject()) {
			AggregatedValueObject[] vos = this.dealUserObj(e.getUserObject());

			String billclass = ((BaseAggVO) vos[0]).getHeadVO().getBillclass();
			boolean ifF1Uneffect = billclass != null && billclass.equals(IBillFieldGet.YF);// ǷӦˣǵĻ򷴺Ҫ֪ͨӿ
			boolean isfkpc = false;// ǷӦˣǵĻ򷴺Ҫ֪ͨӿ
			if (ifF1Uneffect) {
				isfkpc = true;
			}

			// begin
			// Ԥݺ add by zhaoyanf
			vos = billUneffectPreVerify(vos, isfkpc);
			// end

			List<String> deldata = new ArrayList<String>();
			List<String> pks = new ArrayList<String>();
			List<ArapBillMapVO> puList = new ArrayList<ArapBillMapVO>(); // ɹ
			List<ArapBillMapVO> soList = new ArrayList<ArapBillMapVO>(); // ۶-տ
			List<ArapBillMapVO> htList = new ArrayList<ArapBillMapVO>(); // ۺͬ-յ
			List<ArapBillMapVO> psList = new ArrayList<ArapBillMapVO>(); // ų
			List<ArapBillMapVO> pcmList = new ArrayList<ArapBillMapVO>(); // Ŀͬ
			List<String> bodypks = new ArrayList<String>();
			List<ArapBillMapVO> F2ForSoList = new ArrayList<ArapBillMapVO>(); // տ,//
																				// ֹһտ
			for (AggregatedValueObject vo : vos) {
				Integer src_syscode = (Integer) vo.getParentVO().getAttributeValue(IBillFieldGet.SRC_SYSCODE);
				BaseItemVO[] childrenVO = (BaseItemVO[]) vo.getChildrenVO();
				if (src_syscode.intValue() == FromSystem.AR.VALUE.intValue()
						|| src_syscode.intValue() == FromSystem.AP.VALUE.intValue()) {
					pks.add(vo.getParentVO().getPrimaryKey());
					if (src_syscode.intValue() == FromSystem.AR.VALUE.intValue()
							&& vo.getParentVO().getAttributeValue(IBillFieldGet.PK_BILLTYPE).equals(IBillFieldGet.F2)) {
						for (BaseItemVO itemVO : childrenVO) {
							ArapBillMapVO mapVO = new ArapBillMapVO();
							mapVO.setT_itemid(itemVO.getPrimaryKey());
							if (IBillFieldGet.F2.equals(itemVO.getAttributeValue(IBillFieldGet.TOP_BILLTYPE))) {
								bodypks.add(itemVO.getPrimaryKey());
							} else {
								F2ForSoList.add(mapVO);
							}
						}
					}
					if (src_syscode.intValue() == FromSystem.AP.VALUE.intValue()
							&& vo.getParentVO().getAttributeValue(IBillFieldGet.PK_BILLTYPE).equals(IBillFieldGet.F3)) {
						for (BaseItemVO itemVO : childrenVO) {
							ArapBillMapVO mapVO = new ArapBillMapVO();
							mapVO.setT_itemid(itemVO.getPrimaryKey());
							if (IBillFieldGet.F3.equals(itemVO.getAttributeValue(IBillFieldGet.TOP_BILLTYPE))) {
								bodypks.add(itemVO.getPrimaryKey());
							}
						}
					}
				} else {
					String pk_billtype = (String) vo.getParentVO().getAttributeValue(IBillFieldGet.PK_BILLTYPE);
					if (pk_billtype.equals(IBillFieldGet.F0) || pk_billtype.equals(IBillFieldGet.F2)) {
						for (BaseItemVO itemVO : childrenVO) {
							ArapBillMapVO mapVO = new ArapBillMapVO();
							mapVO.setT_itemid(itemVO.getPrimaryKey());
							// ۺͬ-տ
							if (ArapBillDealVOConsts.BILLTYPE_Z3.equals(itemVO.getTop_billtype())) {
								htList.add(mapVO);
							} else {
								soList.add(mapVO);
							}
						}
					} else if (pk_billtype.equals(IBillFieldGet.F1) || pk_billtype.equals(IBillFieldGet.F3)) {
						for (BaseItemVO itemVO : childrenVO) {
							ArapBillMapVO mapVO = new ArapBillMapVO();
							mapVO.setT_itemid(itemVO.getPrimaryKey());
							// Ӧ -||ִмƻ -
							if (ArapBillDealVOConsts.BILLTYPE_36D1.equals(childrenVO[0].getTop_billtype())
									|| ArapBillDealVOConsts.BILLTYPE_36D7.equals(childrenVO[0].getTop_billtype())) {
								psList.add(mapVO);
							} else if (itemVO.getTop_billtype() != null && (ArapBillDealVOConsts.BILLTYPE_4D46
									.equals(childrenVO[0].getTop_billtype())
									|| ArapBillDealVOConsts.BILLTYPE_4D50.equals(childrenVO[0].getTop_billtype())
									|| ArapBillDealVOConsts.BILLTYPE_4D48.equals(childrenVO[0].getTop_billtype()))) {
								pcmList.add(mapVO);
							} else {
								puList.add(mapVO);
							}
						}
					}
				}
				deldata.add(vo.getParentVO().getPrimaryKey());
			}
			this.doCheckBillDeal(deldata);
			// ʽɵ˺󷴺
			try {

				if (pks != null && pks.size() > 0) {
					Collection<ArapBillMapVO> billMapData = new BaseDAO().retrieveByClause(ArapBillMapVO.class,
							SqlUtils.getInStr("t_billid", pks.toArray(new String[] {}), true) + " and ISMANUAL<>'Y'");
					this.doUnVerifyWithMap(billMapData, isfkpc, false);
					this.updateBillMapYbye(billMapData, false, null);
					// տ ֹտ
					if (billMapData == null || billMapData.size() == 0) {
						if (F2ForSoList != null && !F2ForSoList.isEmpty()) {
							// տ ֹһ տ տԤռӦյ
							this.doUnVerifyWithMap(F2ForSoList, isfkpc, false);
						}
					}
				}
				// Ŀͬ
				if (pcmList != null && !pcmList.isEmpty()) {
					this.doUnVerifyWithMap(pcmList, isfkpc, false);
					;
				}
				// ʽĸų̵
				if (psList != null && !psList.isEmpty()) {
					this.doUnVerifyWithMap(psList, Boolean.TRUE, false);
				}
				if (soList != null && !soList.isEmpty()) {
					// -տԤռӦյ
					this.doUnVerifyWithMap(soList, isfkpc, false);
				}
				if (htList != null && !htList.isEmpty()) {
					// ͬ-տԤռ
					this.doUnVerifyWithMap(htList, isfkpc, false);
				}
				if (puList != null && !puList.isEmpty()) {
					this.doUnVerifyWithMap(puList, isfkpc, false);
				}

				if (bodypks.size() > 0) {
					Collection<ArapBillMapVO> billMapData = new HashSet<ArapBillMapVO>();
					for (String pk : bodypks) {
						ArapBillMapVO vo = new ArapBillMapVO();
						vo.setT_itemid(pk);
						billMapData.add(vo);
					}
					this.doUnVerifyWithMap(billMapData, isfkpc, false);
				}

				this.doDeleteRegisterByBillid(deldata.toArray(new String[] {}));
			} catch (Exception e1) {
				throw ExceptionHandler.handleException(e1);
			}
		}
	}

	protected AggregatedValueObject[] dealUserObjForInit(Object obj) {

		AggregatedValueObject[] retvos = null;
		if (obj.getClass().isArray()) {
			retvos = (AggregatedValueObject[]) obj;
		} else {
			retvos = new AggregatedValueObject[] { (AggregatedValueObject) obj };
		}
		this.pk_user = (String) retvos[0].getParentVO().getAttributeValue(ArapBusiDataVO.APPROVER);
		this.syscode = (Integer) retvos[0].getParentVO().getAttributeValue(ArapBusiDataVO.SYSCODE);
		this.pkorg = (String) retvos[0].getParentVO().getAttributeValue(ArapBusiDataVO.PK_ORG);
		return retvos;
	}

	@SuppressWarnings("unused")
	private void VerifyByContractNo(AggregatedValueObject[] vos, VerifyCom com,
			Hashtable<String, DefaultVerifyRuleVO> ruleVOMap) throws BusinessException {
	}

	private void VerifyByContractNo(List<ArapBillMapVO> MapVOList, VerifyCom com,
			Hashtable<String, DefaultVerifyRuleVO> ruleVOMap) throws BusinessException {
	}

	//  billmap ybyeֶθֵΪ0
	private void updateBillMapYbye(Collection<ArapBillMapVO> billMapData, boolean setZero,
			Map<String, UFDouble> key2ybye) throws DAOException {
		String[] fild = new String[] { "ybye" };
		if (billMapData != null && billMapData.size() > 0) {
			if (setZero) {
				for (ArapBillMapVO vo : billMapData) {
					vo.setYbye(UFDouble.ZERO_DBL);
				}
			} else {
				if (key2ybye == null) {
					for (ArapBillMapVO vo : billMapData) {
						vo.setYbye(vo.getYbje());
					}
				} else {
					for (ArapBillMapVO vo : billMapData) {
						String key = vo.getS_itemid() + vo.getT_itemid();
						int multi = vo.getYbje().compareTo(UFDouble.ZERO_DBL) > 0 ? 1 : -1;
						if (key2ybye.get(key) != null)
							vo.setYbye(key2ybye.get(key).abs().multiply(multi));
					}
				}

			}
			billMapData.toArray(new SuperVO[0]);
			new BaseDAO().updateVOArray(billMapData.toArray(new SuperVO[0]), fild);
		}

	}

	public void doCheckBillDeal(List<String> pkbillList) throws BusinessException {
		String[] pkbillArr = pkbillList.toArray(new String[] {});
		String insql = "";
		BaseDAO dao = new BaseDAO();
		insql = SqlUtils.getInStr("pk_bill", pkbillArr, true);
		String[] fields = new String[] { VerifyDetailVO.PK_BILL, VerifyDetailVO.BILLNO };
		// ѯ
		Collection<VerifyDetailVO> verifydata = dao.retrieveByClause(VerifyDetailVO.class,
				insql + " and isauto='N' and isreserve = 0", fields);
		StringBuffer billStr = new StringBuffer();
		Set<String> billSet = new java.util.HashSet<String>();
		if (verifydata != null && verifydata.size() > 0) {
			for (VerifyDetailVO vo : verifydata) {
				billSet.add(vo.getBillno());
			}
			for (String billno : billSet) {
				billStr.append(billno);
				billStr.append(",");
			}
			int lastIndexOf = billStr.lastIndexOf(",");
			String substring = billStr.substring(0, lastIndexOf);
			throw new BusinessException(
					nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006ver_0", "02006ver-0251")/*
																										 * @res ""
																										 */
							+ substring + nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006ver_0",
									"02006ver-0259")/*
													 * @res "Ѿкȡ"
													 */);

		}
		// Ƿ洦
		Collection<AgiotageChildVO> agiotagedata = dao.retrieveByClause(AgiotageChildVO.class,
				insql + "and not exists (select 1 from ARAP_VERIFYDETAIL where " + insql + " )", fields);
		if (agiotagedata != null && agiotagedata.size() > 0) {
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006ver_0",
					"02006ver-0260")/*
									 * @res "Ѿ棬ȡ"
									 */);
		}
		// Ƿ˴
		Collection<DebtTransferVO> debtdata = dao.retrieveByClause(DebtTransferVO.class, insql, fields);
		if (debtdata != null && debtdata.size() > 0) {
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006ver_0",
					"02006ver-0261")/*
									 * @res "Ѿˣȡ"
									 */);
		}
		// Ƿʧ
		String[] badLossFields = new String[] { BdLossChildVO.PK_BILL };
		Collection<BdLossChildVO> badLossdata = dao.retrieveByClause(BdLossChildVO.class,
				insql + " and isnull(dr,0)=0 ", badLossFields);
		if (badLossdata != null && badLossdata.size() > 0) {
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006ver_0",
					"02006ver-0262")/* @res "Ѿʧȡ" */);
		}
		// Ƿջش
		String bdRecInsql = "";
		bdRecInsql = SqlUtils.getInStr(BdRecoverySKVO.PK_GATHERBILL, pkbillArr, true);
		String[] badRecFields = new String[] { BdRecoverySKVO.PK_GATHERBILL };
		Collection<BdRecoverySKVO> badRecdata = dao.retrieveByClause(BdRecoverySKVO.class,
				bdRecInsql + " and isnull(dr,0)=0 ", badRecFields);
		if (badRecdata != null && badRecdata.size() > 0) {
			throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006ver_0",
					"02006ver-0263")/* @res "Ѿջأȡ" */);
		}
	}

	protected void doInsertRegister(List<ArapBusiDataVO> insertdatas) throws BusinessException {
		Logger.debug("arap_busidata    =" + insertdatas.size());
		if (insertdatas != null && insertdatas.size() > 0)
			new BaseDAO().insertVOList(insertdatas);
	}

	protected void doUpdateRegister(List<ArapBusiDataVO> updatedatas) throws BusinessException {
		new BaseDAO().updateVOList(updatedatas);
	}

	protected void doDeleteRegisterByBillid(String[] billids) throws BusinessException {
		// ҵݼ
		if (!PKLock.getInstance().addBatchDynamicLock(billids)) {
			throw new BusinessException(
					nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006ver_0", "02006ver-0257")/*
																										 * @res ""
																										 */);
		}
		new BaseDAO().deleteByClause(ArapBusiDataVO.class, SqlUtils.getInStr("pk_bill", billids, true));
	}

	protected void doDeleteRegisterByItemid(String[] itemids) throws BusinessException {
		new BaseDAO().deleteByClause(ArapBusiDataVO.class, SqlUtils.getInStr("pk_item", itemids, true));
	}

	// 
	private Map<String, UFDouble> doUnVerifyWithMap(Collection<ArapBillMapVO> mapvos, Boolean isFkpc, Boolean isPre)
			throws BusinessException {

		if (mapvos == null || mapvos.size() == 0) {
			return null;
		}
		Map<String, String> businoMap = new HashMap<String, String>();

		List<String> pks = new ArrayList<String>();
		for (ArapBillMapVO vo : mapvos) {
			pks.add(vo.getT_itemid());
		}
		Map<String, UFDouble> key2ybye = new HashMap<String, UFDouble>();// Ԥݣڻдbillmap
		// ӱ
		Collection<VerifyDetailVO> detailColet = new BaseDAO().retrieveByClause(VerifyDetailVO.class,
				SqlUtils.getInStr("pk_item", pks.toArray(new String[] {}), true));
		for (VerifyDetailVO detailvo : detailColet) {
			if (businoMap.containsKey(detailvo.getBusino())) {
				businoMap.put(detailvo.getBusino(), businoMap.get(detailvo.getBusino()));
			} else {
				businoMap.put(detailvo.getBusino(), detailvo.getBusino());
			}
			if (isPre) {
				String key = detailvo.getPk_item2() + detailvo.getPk_item();
				UFDouble money = detailvo.getMoney_cr().add(detailvo.getMoney_de());
				if (!key2ybye.containsKey(key)) {
					key2ybye.put(key, money);
				} else {
					key2ybye.put(key, key2ybye.get(key).add(money));
				}

			}
		}
		if (businoMap.size() == 0) {
			return null;
		}
		// ֯ۺVO
		Set<String> keyset = businoMap.keySet();
		keyset.toArray(new String[keyset.size()]);
		NCLocator.getInstance().lookup(IArapVerifyLogPrivate.class)
				.onCancelVerify(keyset.toArray(new String[keyset.size()]), isFkpc);
		return key2ybye.size() == 0 ? null : key2ybye;
	}

	// 
	private void doVerifyWithMap(Collection<ArapBillMapVO> mapvos, Hashtable<String, DefaultVerifyRuleVO> ruleVOMap,
			VerifyCom com, String nouse) throws BusinessException {
		if (mapvos == null || mapvos.size() == 0) {
			return;
		}

		// ݲȷǷҪԤո־
		if (VerifyDetailVO.reserve_so.equals(com.getReserveFlag())) {
			UFBoolean isNeed = SysInit.getParaBoolean(this.getPkorg(), SysinitConst.AR35);
			if (isNeed != null && isNeed.booleanValue()) {
				for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
					rule.setM_creditObjKeys(new String[] { IArapItemFieldVO.PREPAY });
					rule.setM_debtObjKeys(new String[] { IArapItemFieldVO.PREPAY });
				}
			}
		} else if (VerifyDetailVO.reserve_pu.equals(com.getReserveFlag())) {
			UFBoolean isNeed = SysInit.getParaBoolean(this.getPkorg(), SysinitConst.AP35);
			if (isNeed != null && isNeed.booleanValue()) {
				for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
					rule.setM_creditObjKeys(new String[] { IArapItemFieldVO.PREPAY });
					rule.setM_debtObjKeys(new String[] { IArapItemFieldVO.PREPAY });
				}
			}
		} else if (VerifyDetailVO.reserve_pcm.equals(com.getReserveFlag())) {
			UFBoolean isNeed = SysInit.getParaBoolean(this.getPkorg(), SysinitConst.AP35);// Ӧ
			if (mapvos.iterator().next().getS_system() == 0) {// Ӧ
				isNeed = SysInit.getParaBoolean(this.getPkorg(), SysinitConst.AR35);
			}
			if (isNeed != null && isNeed.booleanValue()) {
				for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
					rule.setM_creditObjKeys(new String[] { IArapItemFieldVO.PREPAY });
					rule.setM_debtObjKeys(new String[] { IArapItemFieldVO.PREPAY });
				}
			}
		}

		this.aggMap.clear();
		List<String> pks = new ArrayList<String>();
		List<String> termPkList = new ArrayList<String>();
		List<String> itemPkList = new ArrayList<String>();
		Collection<ArapBusiDataVO> busiList = null;
		ArapBillMapVO[] mapVOs2 = mapvos.toArray(new ArapBillMapVO[0]);
		//  ע ٴ
		Map<String, String> item_top_termMap = new HashMap<String, String>();
		for (ArapBillMapVO vo : mapvos) {
			// ϵͳԴж ǷԸ
			if (ArapBillDealVOConsts.BILLTYPE_36D1.equals(vo.getS_billtype())
					|| ArapBillDealVOConsts.BILLTYPE_36D7.equals(vo.getS_billtype())) {
				// ж ֻʽĸų ſ԰Эк
				termPkList.add(vo.getS_termid());
				itemPkList.add(vo.getT_itemid());
				item_top_termMap.put(vo.getS_itemid(), vo.getS_termid());
			} else {
				if (vo.getS_itemid() == null) { // Դͷid Ϊ ûݲú
				} else {
					pks.add(vo.getS_itemid());
					pks.add(vo.getT_itemid());
				}
			}
		}
		if (termPkList != null && termPkList.size() > 0) {
			String sql = SqlUtils.getInStr("pk_termitem", termPkList.toArray(new String[] {}), true)
					+ " and pausetransact ='N' " + " or "
					+ SqlUtils.getInStr("pk_item", itemPkList.toArray(new String[] {}), true)
					+ " and pausetransact ='N' ";
			busiList = new BaseDAO().retrieveByClause(ArapBusiDataVO.class, sql);
			if (busiList != null) {
				for (ArapBusiDataVO b : busiList) {
					String pk_item = b.getPk_item();
					if (item_top_termMap.containsKey(pk_item)) {
						b.setDef1(item_top_termMap.get(pk_item));
					} else {
						b.setDef1(b.getPk_termitem());
					}

				}
			}
		} else {
			if (pks != null && pks.size() > 0) {
				busiList = new BaseDAO().retrieveByClause(ArapBusiDataVO.class,
						SqlUtils.getInStr("pk_item", pks.toArray(new String[] {}), true) + " and pk_org='"
								+ ruleVOMap.values().iterator().next().getPk_org() + "' and pausetransact ='N' "
								+ " and money_bal <> 0  " + " and pk_currtype ='" + mapVOs2[0].getPk_currtype()

								+ "'");
			}
		}
		if (busiList == null || busiList.size() == 0) {
			return;
		}
		// Ƚts ʹ
		Map<String, String> busiDataTsMap = new HashMap<String, String>();
		for (ArapBusiDataVO vo : busiList) {
			busiDataTsMap.put(vo.getPk_busidata(), vo.getTs().toString());
		}
		com.setBusiDataTsMap(busiDataTsMap);
		List<ArapBusiDataVO> jfList = new ArrayList<ArapBusiDataVO>();
		List<ArapBusiDataVO> dfList = new ArrayList<ArapBusiDataVO>();
		// ֱ Է
		for (ArapBusiDataVO data : busiList) {
			boolean isjf = false;
			for (ArapBillMapVO mpvo : mapVOs2) {
				if (data.getPk_item().equals(mpvo.getT_itemid())) {
					isjf = true;
				}
			}
			if (isjf) {
				jfList.add(data);
			} else {
				dfList.add(data);
			}
		}
		// 
		Integer flag = ruleVOMap.get("SAME_VERIFY").getM_verifySeq();
		ArapBusiDataVO[] jfVos = jfList.toArray(new ArapBusiDataVO[0]);
		ArapBusiDataVO[] dfVos = dfList.toArray(new ArapBusiDataVO[0]);
		VerifyTool.sortVector(jfVos, flag.intValue());
		VerifyTool.sortVector(dfVos, flag.intValue());

		Map<String, List<ArapBusiDataVO>> dfBusidataMap = getBusidataMap(dfVos);

		UFDouble clje = UFDouble.ZERO_DBL;
		UFDouble jf_clje = UFDouble.ZERO_DBL;
		for (ArapBillMapVO vo : mapVOs2) {
			clje = clje.add(vo.getYbje());
		}
		jf_clje = clje;
		// 
		if (mapVOs2[0].getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_36D1)
				|| mapVOs2[0].getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_36D7)) {
			for (ArapBillMapVO vo : mapvos) {
				if (vo.getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_36D1)
						|| vo.getS_billtype().equals(ArapBillDealVOConsts.BILLTYPE_36D7)) {
					// 룬s_item =null,s_termitem
					// UFDouble clje1 = vo.getYbje();
					if (dfList != null && dfList.size() > 0) {
						for (ArapBusiDataVO datavo : dfVos) {
							UFDouble occupationmny = datavo.getOccupationmny();
							UFDouble money_bal = datavo.getMoney_bal();
							occupationmny = money_bal.sub(occupationmny);
							// if (clje1.compareTo(occupationmny) > 0) {
							// datavo.setAttributeValue(ArapBusiDataVO.SETT_MONEY,
							// occupationmny);
							// clje1 = clje.sub(occupationmny);
							// } else {
							// clje1 = UFDouble.ZERO_DBL;
							// }
							datavo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, occupationmny);
						}
					}
				}
			}
		} else {
			//  
			if (dfList != null && dfList.size() > 0) {
				for (String pk_item : dfBusidataMap.keySet()) {
					List<ArapBusiDataVO> list = dfBusidataMap.get(pk_item);
					UFDouble verifyMoney = UFDouble.ZERO_DBL;
					for (ArapBillMapVO mapvo : mapvos) {
						if (pk_item.equals(mapvo.getS_itemid())) {
							verifyMoney = mapvo.getYbje();
							break;
						}
					}
					for (ArapBusiDataVO datavo : list) {
						UFDouble occupationmny = datavo.getOccupationmny();
						UFDouble money_bal = datavo.getMoney_bal();
						if (datavo.getPk_billtype().equals(IBillFieldGet.F2)) {
							// ۶տԤ ռ
							if (verifyMoney.compareTo(money_bal.sub(occupationmny)) > 0) {
								datavo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, money_bal.sub(occupationmny));
								verifyMoney = verifyMoney.sub(money_bal.sub(occupationmny));
							} else {
								datavo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, verifyMoney);
								verifyMoney = UFDouble.ZERO_DBL;
							}
						} else {
							if (verifyMoney.compareTo(occupationmny) > 0) {
								datavo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, occupationmny);
								verifyMoney = verifyMoney.sub(occupationmny);
							} else {
								datavo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, verifyMoney);
								verifyMoney = UFDouble.ZERO_DBL;
							}
						}
					}
				}
			}
		}
		for (ArapBusiDataVO jfvo : jfVos) {
			UFDouble occupationmny = jfvo.getOccupationmny();
			UFDouble money_bal = jfvo.getMoney_bal();
			if (jfvo.getPk_billtype().equals(IBillFieldGet.F2)) {
				// ۶տԤ ռ
				if (jf_clje.compareTo(money_bal.sub(occupationmny)) > 0) {
					jfvo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, money_bal.sub(occupationmny));
					jf_clje = jf_clje.sub(money_bal.sub(occupationmny));
				} else {
					jfvo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, jf_clje);
					jf_clje = UFDouble.ZERO_DBL;
				}
			} else {
				if (jf_clje.compareTo(occupationmny) > 0 || jf_clje.compareTo(occupationmny) < 0) {
					jfvo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, occupationmny);
					jf_clje = jf_clje.sub(occupationmny);
				} else {
					jfvo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, jf_clje);
					jf_clje = UFDouble.ZERO_DBL;
				}
			}
		}
		// for (ArapBusiDataVO jfvo : jfVos) {
		// UFDouble occupationmny = jfvo.getOccupationmny();
		// jfvo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, occupationmny);
		// }
		// for (ArapBusiDataVO dfvo : dfVos) {
		// UFDouble occupationmny = dfvo.getOccupationmny();
		// dfvo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, occupationmny);
		// }
		List<ArapBusiDataVO> jf = new ArrayList<ArapBusiDataVO>();
		List<ArapBusiDataVO> df = new ArrayList<ArapBusiDataVO>();

		for (ArapBusiDataVO jfvo : jfVos) {
			if (jfvo.getDirection().intValue() == BillEnumCollection.Direction.DEBIT.VALUE.intValue()) {
				jf.add(jfvo);
			} else {
				df.add(jfvo);
			}
		}
		for (ArapBusiDataVO jfvo : dfVos) {
			if (jfvo.getDirection().intValue() == BillEnumCollection.Direction.DEBIT.VALUE.intValue()) {
				jf.add(jfvo);
			} else {
				df.add(jfvo);
			}
		}

		aggMap = onVerify(com, ruleVOMap, jf.toArray(new ArapBusiDataVO[] {}), df.toArray(new ArapBusiDataVO[] {}));
		ArrayList<AggverifyVO> aggVOList = getAggVerifyVO(aggMap, com.getIsauto());
		// 
		if (aggVOList != null && aggVOList.size() > 0) {
			NCLocator.getInstance().lookup(IArapVerifyLogPrivate.class).save(aggVOList, ruleVOMap, com);
		}

	}

	private Map<String, List<ArapBusiDataVO>> getBusidataMap(ArapBusiDataVO[] dfVos) {
		Map<String, List<ArapBusiDataVO>> dataMap = new HashMap<String, List<ArapBusiDataVO>>();
		for (ArapBusiDataVO vo : dfVos) {
			if (dataMap.containsKey(vo.getPk_item())) {
				dataMap.get(vo.getPk_item()).add(vo);
			} else {
				List<ArapBusiDataVO> tempList = new ArrayList<ArapBusiDataVO>();
				tempList.add(vo);
				dataMap.put(vo.getPk_item(), tempList);
			}
		}

		return dataMap;
	}

	public static String SAMVERIFYFLAG = "SAMVERIFYFLAG"; // ֺͬ

	public static String UNVERIFYFLAG = "UNVERIFYFLAG"; // ֺ

	public static String HCSAMVERIFYFLAG = "HCSAMVERIFYFLAG"; // ֺͬ

	public static String HCUNVERIFYFLAG = "HCUNVERIFYFLAG"; // ֺ

	/**
	 * ոڲ
	 * 
	 * @param mapvos
	 * @param ruleVOMap
	 * @param com
	 * @throws BusinessException
	 */
	private void doArapVerifyWithMap(Collection<ArapBillMapVO> mapvos, Hashtable<String, DefaultVerifyRuleVO> ruleVOMap,
			VerifyCom com) throws BusinessException {
		// Ч⣬Ϊ
		if (mapvos != null && mapvos.size() > 0) {
			List<ArapBillMapVO> billMapDataArap = new ArrayList<ArapBillMapVO>();
			List<ArapBillMapVO> billMapDataUnRb = new ArrayList<ArapBillMapVO>();
			Map<String, List<ArapBillMapVO>> billMapDataUnSam = new HashMap<String, List<ArapBillMapVO>>();
			for (ArapBillMapVO vo : mapvos) {
				if (StringUtil.isEmpty(vo.getSettlecurr()) || vo.getSettlemoney() == null) {
					billMapDataArap.add(vo);
				} else {
					if (IBillFieldGet.F0.equals(vo.getS_billtype()) && IBillFieldGet.F3.equals(vo.getT_billtype())) { // Ӧ
						billMapDataArap.add(vo);
					} else if (vo.getS_billtype().equals(vo.getT_billtype())) {// 
						billMapDataUnRb.add(vo);
					} else {
						if (vo.getPk_currtype().equals(vo.getSettlecurr())) {// ͬ
							billMapDataArap.add(vo);
						} else { // ְαֻ
							String key = vo.getPk_currtype() + "*" + vo.getSettlecurr();
							if (billMapDataUnSam.get(key) != null) {
								billMapDataUnSam.get(key).add(vo);
							} else {
								List<ArapBillMapVO> map = new ArrayList<ArapBillMapVO>();
								map.add(vo);
								billMapDataUnSam.put(key, map);
							}
						}

					}
				}
			}
			if (billMapDataArap != null && billMapDataArap.size() > 0) {
				this.doVerifyWithMap(billMapDataArap, ruleVOMap, com);
			}
			if (billMapDataUnRb != null && billMapDataUnRb.size() > 0) {
				this.doArapVerifyWithMap(billMapDataUnRb, this.createRBVerifyRuleVO(),
						BillRegisterForBusiDataBO.HCUNVERIFYFLAG, com.getIsauto());
			}
			for (String key : billMapDataUnSam.keySet()) {
				this.doArapVerifyWithMap(billMapDataUnSam.get(key), null, BillRegisterForBusiDataBO.UNVERIFYFLAG,
						com.getIsauto());
			}
		}
	}

	/**
	 * @param mapvos      map
	 * @param ruleVOMap   
	 * @param isSamVerify Ƿͬ
	 * @param isRed       Ƿ
	 * @throws BusinessException
	 */
	private void doArapVerifyWithMap(List<ArapBillMapVO> mapvos, Hashtable<String, DefaultVerifyRuleVO> ruleVOMap,
			String verifyFlag, UFBoolean isauto) throws BusinessException {
		if (mapvos == null || mapvos.size() == 0) {
			return;
		}
		this.aggMap.clear();
		VerifyCom com = new VerifyCom();
		com.setReserveFlag(VerifyDetailVO.reserve_arap);
		com.setExactVerify(true);
		Map<String, List<ArapBusiDataVO>> busiMap = new HashMap<String, List<ArapBusiDataVO>>();
		List<String> pks = new ArrayList<String>();
		List<String> termPkList = new ArrayList<String>();
		List<String> itemPkList = new ArrayList<String>();
		Collection<ArapBusiDataVO> busiList = null;
		Map<String, String> item_TermMap = new HashMap<String, String>();
		// ϵͳԴж ǷԸ
		for (ArapBillMapVO vo : mapvos) {
			if (ArapBillDealVOConsts.BILLTYPE_36D1.equals(vo.getS_billtype())) {
				// ж ֻʽĸų ſ԰Эк
				termPkList.add(vo.getS_termid());
				itemPkList.add(vo.getT_itemid());
			} else {
				if (vo.getS_itemid() == null) { // Դͷid Ϊ ûݲú
				} else {
					pks.add(vo.getS_itemid());
					pks.add(vo.getT_itemid());
				}
			}
		}

		if (termPkList != null && termPkList.size() > 0) {
			String sql = SqlUtils.getInStr("pk_termitem", termPkList.toArray(new String[] {}), true)
					+ " and pausetransact ='N' " + " or "
					+ SqlUtils.getInStr("pk_item", itemPkList.toArray(new String[] {}), true);
			busiList = new BaseDAO().retrieveByClause(ArapBusiDataVO.class, sql);
		} else {
			if (pks != null && pks.size() > 0) {
				busiList = new BaseDAO().retrieveByClause(ArapBusiDataVO.class,
						SqlUtils.getInStr("pk_item", pks.toArray(new String[] {}), true) + " and money_bal <> 0 "
								+ " and pausetransact ='N' ");
			} else {
			}
		}
		if (busiList == null || busiList.size() == 0) {
			return;
		}

		// Ƚts ʹ
		Map<String, String> busiDataTsMap = new HashMap<String, String>();
		for (ArapBusiDataVO vo : busiList) {
			busiDataTsMap.put(vo.getPk_busidata(), vo.getTs().toString());
		}
		com.setBusiDataTsMap(busiDataTsMap);

		// Աз
		for (ArapBusiDataVO bvo : busiList) {
			item_TermMap.put(bvo.getPk_termitem(), bvo.getPk_item());
			if (busiMap.containsKey(bvo.getPk_item())) {
				List<ArapBusiDataVO> list2 = busiMap.get(bvo.getPk_item());
				list2.add(bvo);
				busiMap.put(bvo.getPk_item(), list2);
			} else {
				List<ArapBusiDataVO> slist = new ArrayList<ArapBusiDataVO>();
				slist.add(bvo);
				busiMap.put(bvo.getPk_item(), slist);
			}
		}
		Map<String, ArrayList<AggverifyVO>> aggMap = null;

		List<ArapBusiDataVO> jf_vos_list = new ArrayList<ArapBusiDataVO>();
		List<ArapBusiDataVO> df_vos_list = new ArrayList<ArapBusiDataVO>();

		// ȡε
		UFDate busiDate = null;
		if (BillRegisterForBusiDataBO.UNVERIFYFLAG.equals(verifyFlag)) {
			busiDate = busiMap.get(mapvos.get(0).getT_itemid()).get(0).getBilldate();
			ruleVOMap = this.createUnVerifyRuleVO(mapvos.get(0), busiDate);
		}
		for (ArapBillMapVO vo : mapvos) {
			ArapBusiDataVO[] jf_vos = null;
			ArapBusiDataVO[] df_vos = null;

			ArapBusiDataVO[] jf_vostemp = null;
			ArapBusiDataVO[] df_vostemp = null;
			String sItemid = vo.getS_itemid();
			String tItemid = vo.getT_itemid();
			List<ArapBusiDataVO> slist = null;
			if (ArapBillDealVOConsts.BILLTYPE_36D1.equals(vo.getS_billtype())) {
			} else {
				if (sItemid == null) {
					return;
				}
			}
			List<ArapBusiDataVO> tlist = null;
			// ų
			if (ArapBillDealVOConsts.BILLTYPE_36D1.equals(vo.getS_billtype())) {
				String stermid = vo.getS_termid();
				String titemid = vo.getT_itemid();
				// ԴЭidԴӱid
				String sitemid = item_TermMap.get(stermid);
				slist = busiMap.get(sitemid);
				tlist = busiMap.get(titemid);
			} else {
				slist = busiMap.get(sItemid);
				tlist = busiMap.get(tItemid);
			}

			if (com.isArapVerify()) {
				if (slist != null) {
					for (ArapBusiDataVO svo : slist) {
						svo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, svo.getPk_item());
					}
				}
				if (tlist != null) {
					for (ArapBusiDataVO tvo : tlist) {
						tvo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, tvo.getTop_itemid());
					}
				}
			}
			ArapBusiDataVOList svolist = new ArapBusiDataVOList(slist);
			ArapBusiDataVOList tvolist = new ArapBusiDataVOList(tlist);
			if (tvolist.getVolist() == null || tvolist.getVolist().size() == 0 || svolist.getVolist() == null
					|| svolist.getVolist().size() == 0) {
				return;
			} else {
				if (BillRegisterForBusiDataBO.SAMVERIFYFLAG.equals(verifyFlag)) {
					// ˻Ӧյ
					if (svolist.getVolist().get(0).getPk_billtype().equals(IBillFieldGet.F0)
							&& tvolist.getVolist().get(0).getPk_billtype().equals(IBillFieldGet.F3)) {
						svolist.setDealMoney(vo.getYbje().multiply(-1), com.isSoVerify(), aggMap);
						tvolist.setDealMoney(vo.getYbje(), com.isSoVerify(), aggMap);
					} else {
						svolist.setDealMoney(vo.getYbje(), com.isSoVerify(), aggMap);
						tvolist.setDealMoney(vo.getYbje(), com.isSoVerify(), aggMap);
					}
				} else if (BillRegisterForBusiDataBO.UNVERIFYFLAG.equals(verifyFlag)) {
					svolist.setUnDealMoney(vo, true, aggMap, busiDate);
					tvolist.setUnDealMoney(vo, false, aggMap, busiDate);
				} else if (BillRegisterForBusiDataBO.HCSAMVERIFYFLAG.equals(verifyFlag)) {
					svolist.setHcDealMoney(vo, true, aggMap);
					tvolist.setHcDealMoney(vo, false, aggMap);
				} else if (BillRegisterForBusiDataBO.HCUNVERIFYFLAG.equals(verifyFlag)) {
					svolist.setHcDealMoney(vo, true, aggMap);
					tvolist.setHcDealMoney(vo, false, aggMap);
				}
			}
			// ȡ֯˳ʱʹ
			this.setPkorg(vo.getPk_org());
			// жϽ
			if (this.isJie(svolist.getVolist())) {
				jf_vostemp = new ArapBusiDataVO[svolist.getVolist().size()];
				svolist.getVolist().toArray(jf_vostemp);

				df_vostemp = new ArapBusiDataVO[tvolist.getVolist().size()];
				tvolist.getVolist().toArray(df_vostemp);
			} else {
				df_vostemp = new ArapBusiDataVO[svolist.getVolist().size()];
				svolist.getVolist().toArray(df_vostemp);

				jf_vostemp = new ArapBusiDataVO[tvolist.getVolist().size()];
				tvolist.getVolist().toArray(jf_vostemp);
			}
			// ˻⴦
			if (jf_vostemp[0].getPk_billtype().equals(IBillFieldGet.F0)
					&& df_vostemp[0].getPk_billtype().equals(IBillFieldGet.F3)) {
				jf_vos = ArrayUtil.union(jf_vos, jf_vostemp);
				jf_vos = ArrayUtil.union(jf_vos, df_vostemp);
				com.setRedContrast(true);
			} else {

				jf_vos = ArrayUtil.union(jf_vos, jf_vostemp);
				df_vos = ArrayUtil.union(df_vos, df_vostemp);
			}

			if (jf_vos != null) {
				for (ArapBusiDataVO jfvo : jf_vos) {
					jf_vos_list.add(jfvo);
				}
			}
			if (df_vos != null) {
				for (ArapBusiDataVO dfvo : df_vos) {
					df_vos_list.add(dfvo);
				}
			}
			if (BillRegisterForBusiDataBO.HCSAMVERIFYFLAG.equals(verifyFlag)
					|| BillRegisterForBusiDataBO.HCUNVERIFYFLAG.equals(verifyFlag)) {
				if (this.isJie(svolist.getVolist())) {
					jf_vos_list.addAll(df_vos_list);
					df_vos_list.clear();
				} else {
					df_vos_list.addAll(jf_vos_list);
					jf_vos_list.clear();
				}
			}
		}

		if (com.isArapVerify()) {// ϲΪ
			aggMap = this.onVerify(com, ruleVOMap, jf_vos_list.toArray(new ArapBusiDataVO[] {}),
					df_vos_list.toArray(new ArapBusiDataVO[] {}));
		}

		ArrayList<AggverifyVO> aggVOList = this.getAggVerifyVO(aggMap, isauto);

		if (aggVOList != null && aggVOList.size() > 0) {
			for (AggverifyVO v : aggVOList) {
				VerifyCom.validate(v);
			}
		}

		this.dealOrgScomment(aggVOList);
		// 
		if (aggVOList != null && aggVOList.size() > 0) {
			NCLocator.getInstance().lookup(IArapVerifyLogPrivate.class).save(aggVOList, ruleVOMap, com);
		}
	}

	private void dealOrgScomment(ArrayList<AggverifyVO> aggVOList) {
		for (AggverifyVO aggVO : aggVOList) {
			VerifyDetailVO[] childrenVO = (VerifyDetailVO[]) aggVO.getChildrenVO();
			for (VerifyDetailVO verifyvo : childrenVO) {
				// մժҪ
				if (!StringUtil.isEmpty(verifyvo.getSrc_org()) && !verifyvo.getPk_org().equals(verifyvo.getSrc_org())) {
					IGeneralAccessor accessor = GeneralAccessorFactory
							.getAccessor("2cfe13c5-9757-4ae8-9327-f5c2d34bcb46");
					IBDData docByPk = accessor.getDocByPk(verifyvo.getSrc_org());
					String orgName = "";
					if (docByPk != null) {
						orgName = docByPk.getName().toString();
					}
					if (IBillFieldGet.F0.equals(verifyvo.getPk_billtype())
							|| IBillFieldGet.F2.equals(verifyvo.getPk_billtype())) {
						verifyvo.setScomment(verifyvo.getScomment() + " "
								+ nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006pub0322_0",
										"02006pub0322-0033", null, new String[] { orgName })/*
																							 * @ res "գ"
																							 */);
					} else {
						verifyvo.setScomment(verifyvo.getScomment() + " "
								+ nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006pub0322_0",
										"02006pub0322-0034", null, new String[] { orgName })/*
																							 * @ res ""
																							 */);
					}
				}
			}
		}
	}

	private void doVerifyWithMap(Collection<ArapBillMapVO> mapvos, Hashtable<String, DefaultVerifyRuleVO> ruleVOMap,
			VerifyCom com) throws BusinessException {
		if (mapvos == null || mapvos.size() == 0) {
			return;
		}
		this.aggMap.clear();
		Map<String, List<ArapBusiDataVO>> busiMap = new HashMap<String, List<ArapBusiDataVO>>();
		List<String> pks = new ArrayList<String>();
		List<String> termPkList = new ArrayList<String>();
		List<String> itemPkList = new ArrayList<String>();
		Collection<ArapBusiDataVO> busiList = null;
		Map<String, String> item_TermMap = new HashMap<String, String>();
		Map<String, String> tItem_sItemMap = new HashMap<String, String>();
		//  ע ٴ
		for (ArapBillMapVO vo : mapvos) {
			// ϵͳԴж ǷԸ
			if (ArapBillDealVOConsts.BILLTYPE_36D1.equals(vo.getS_billtype())) {
				// ж ֻʽĸų ſ԰Эк
				termPkList.add(vo.getS_termid());
				itemPkList.add(vo.getT_itemid());
			} else {
				if (vo.getS_itemid() == null) { // Դͷid Ϊ ûݲú
				} else {
					pks.add(vo.getS_itemid());
					pks.add(vo.getT_itemid());
					tItem_sItemMap.put(vo.getT_itemid(), vo.getS_itemid());
				}
			}
		}

		// ݲȷǷҪԤո־
		if (VerifyDetailVO.reserve_so.equals(com.getReserveFlag())) {
			UFBoolean isNeed = SysInit.getParaBoolean(this.getPkorg(), SysinitConst.AR35);
			if (isNeed != null && isNeed.booleanValue()) {
				for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
					rule.setM_creditObjKeys(new String[] { IArapItemFieldVO.PREPAY });
					rule.setM_debtObjKeys(new String[] { IArapItemFieldVO.PREPAY });
				}
			}
		} else if (VerifyDetailVO.reserve_pu.equals(com.getReserveFlag())) {
			UFBoolean isNeed = SysInit.getParaBoolean(this.getPkorg(), SysinitConst.AP35);
			if (isNeed != null && isNeed.booleanValue()) {
				for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
					rule.setM_creditObjKeys(new String[] { IArapItemFieldVO.PREPAY });
					rule.setM_debtObjKeys(new String[] { IArapItemFieldVO.PREPAY });
				}
			}
		} else if (VerifyDetailVO.reserve_pcm.equals(com.getReserveFlag())) {
			UFBoolean isNeed = SysInit.getParaBoolean(this.getPkorg(), SysinitConst.AP35);// Ӧ
			if (mapvos.iterator().next().getS_system() == 0) {// Ӧ
				isNeed = SysInit.getParaBoolean(this.getPkorg(), SysinitConst.AR35);
			}
			if (isNeed != null && isNeed.booleanValue()) {
				for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
					rule.setM_creditObjKeys(new String[] { IArapItemFieldVO.PREPAY });
					rule.setM_debtObjKeys(new String[] { IArapItemFieldVO.PREPAY });
				}
			}
		}

		if (termPkList != null && termPkList.size() > 0) {
			String sql = SqlUtils.getInStr("pk_termitem", termPkList.toArray(new String[] {}), true)
					+ " and pausetransact ='N' " + " or "
					+ SqlUtils.getInStr("pk_item", itemPkList.toArray(new String[] {}), true);
			busiList = new BaseDAO().retrieveByClause(ArapBusiDataVO.class, sql);
		} else {
			if (pks != null && pks.size() > 0) {
				busiList = new BaseDAO().retrieveByClause(ArapBusiDataVO.class,
						SqlUtils.getInStr("pk_item", pks.toArray(new String[] {}), true) + " and money_bal <> 0 "
								+ " and pausetransact ='N' ");
			} else {
			}
		}

		if (busiList == null || busiList.size() == 0) {
			return;
		}

		// Ƚts ʹ
		Map<String, String> busiDataTsMap = new HashMap<String, String>();
		for (ArapBusiDataVO vo : busiList) {
			busiDataTsMap.put(vo.getPk_busidata(), vo.getTs().toString());
		}
		com.setBusiDataTsMap(busiDataTsMap);

		// Աз
		for (ArapBusiDataVO bvo : busiList) {
			item_TermMap.put(bvo.getPk_termitem(), bvo.getPk_item());
			if (busiMap.containsKey(bvo.getPk_item())) {
				List<ArapBusiDataVO> list2 = busiMap.get(bvo.getPk_item());
				list2.add(bvo);
				busiMap.put(bvo.getPk_item(), list2);
			} else {
				List<ArapBusiDataVO> slist = new ArrayList<ArapBusiDataVO>();
				slist.add(bvo);
				busiMap.put(bvo.getPk_item(), slist);
			}
		}
		Map<String, ArrayList<AggverifyVO>> aggMap = null;

		List<ArapBusiDataVO> jf_vos_list = new ArrayList<ArapBusiDataVO>();
		List<ArapBusiDataVO> df_vos_list = new ArrayList<ArapBusiDataVO>();

		for (ArapBillMapVO vo : mapvos) {
			ArapBusiDataVO[] jf_vos = null;
			ArapBusiDataVO[] df_vos = null;

			ArapBusiDataVO[] jf_vostemp = null;
			ArapBusiDataVO[] df_vostemp = null;
			String sItemid = vo.getS_itemid();
			String tItemid = vo.getT_itemid();
			List<ArapBusiDataVO> slist = null;
			if (ArapBillDealVOConsts.BILLTYPE_36D1.equals(vo.getS_billtype())) {
			} else {
				if (sItemid == null) {
					continue;
				}
			}
			List<ArapBusiDataVO> tlist = null;
			// ų
			if (ArapBillDealVOConsts.BILLTYPE_36D1.equals(vo.getS_billtype())) {
				String stermid = vo.getS_termid();
				String titemid = vo.getT_itemid();
				// ԴЭidԴӱid
				String sitemid = item_TermMap.get(stermid);
				slist = busiMap.get(sitemid);
				tlist = busiMap.get(titemid);
			} else {
				slist = busiMap.get(sItemid);
				tlist = busiMap.get(tItemid);
			}

			if (com.isArapVerify()) {
				if (slist != null) {
					for (ArapBusiDataVO svo : slist) {
						svo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, svo.getPk_item());
					}
				}
				if (tlist != null) {
					if (com.isRefund()) {
						for (ArapBusiDataVO tvo : tlist) {
							tvo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY,
									tItem_sItemMap.get(tvo.getPk_item()));
						}
					} else {
						for (ArapBusiDataVO tvo : tlist) {
							tvo.setAttributeValue(BillRegisterForBusiDataBO.SPECIAL_KEY, tvo.getTop_itemid());
						}
					}
				}
			}

			ArapBusiDataVOList svolist = new ArapBusiDataVOList(slist);
			ArapBusiDataVOList tvolist = new ArapBusiDataVOList(tlist);
			if (tvolist.getVolist() == null || tvolist.getVolist().size() == 0 || svolist.getVolist() == null
					|| svolist.getVolist().size() == 0) {
				continue;
			} else {
				// ˻Ӧյ
				if (svolist.getVolist().get(0).getPk_billtype().equals(IBillFieldGet.F0)
						&& tvolist.getVolist().get(0).getPk_billtype().equals(IBillFieldGet.F3)) {
					svolist.setDealMoney(vo.getYbje().multiply(-1), com.isSoVerify(), aggMap);
					tvolist.setDealMoney(vo.getYbje(), com.isSoVerify(), aggMap);
				} else {
					svolist.setDealMoney(vo.getYbje(), com.isSoVerify(), aggMap, com.getReserveFlag());
					tvolist.setDealMoney(vo.getYbje(), com.isSoVerify(), aggMap, com.getReserveFlag());
				}
			}
			// ȡ֯˳ʱʹ
			this.setPkorg(vo.getPk_org());
			// жϽ
			if (this.isJie(svolist.getVolist())) {
				jf_vostemp = new ArapBusiDataVO[svolist.getVolist().size()];
				svolist.getVolist().toArray(jf_vostemp);

				df_vostemp = new ArapBusiDataVO[tvolist.getVolist().size()];
				tvolist.getVolist().toArray(df_vostemp);
			} else {
				df_vostemp = new ArapBusiDataVO[svolist.getVolist().size()];
				svolist.getVolist().toArray(df_vostemp);

				jf_vostemp = new ArapBusiDataVO[tvolist.getVolist().size()];
				tvolist.getVolist().toArray(jf_vostemp);
			}
			// ˻⴦
			if (jf_vostemp[0].getPk_billtype().equals(IBillFieldGet.F0)
					&& df_vostemp[0].getPk_billtype().equals(IBillFieldGet.F3)) {
				jf_vos = ArrayUtil.union(jf_vos, jf_vostemp);
				jf_vos = ArrayUtil.union(jf_vos, df_vostemp);
				com.setRedContrast(true);
			} else {

				jf_vos = ArrayUtil.union(jf_vos, jf_vostemp);
				df_vos = ArrayUtil.union(df_vos, df_vostemp);
			}

			if (!com.isArapVerify() && com.getReserveFlag().intValue() != VerifyDetailVO.reserve_pcm) {
				aggMap = this.onVerify(com, ruleVOMap, jf_vos, df_vos);
				// for(ArapBusiDataVO v:jf_vos){
				// v.setAttributeValue("SETT_MONEY", null);
				// }
				// for(ArapBusiDataVO v:df_vos){
				// v.setAttributeValue("SETT_MONEY", null);
				// }
			} else {
				if (jf_vos != null) {
					for (ArapBusiDataVO jfvo : jf_vos) {
						jf_vos_list.add(jfvo);
					}
				}
				if (df_vos != null) {
					for (ArapBusiDataVO dfvo : df_vos) {
						df_vos_list.add(dfvo);
					}
				}
			}
		}

		if (com.isArapVerify() || com.getReserveFlag().intValue() == VerifyDetailVO.reserve_pcm) {// ϲΪ
			aggMap = this.onVerify(com, ruleVOMap, jf_vos_list.toArray(new ArapBusiDataVO[] {}),
					df_vos_list.toArray(new ArapBusiDataVO[] {}));
		}

		ArrayList<AggverifyVO> aggVOList = this.getAggVerifyVO(aggMap, com.getIsauto());
		this.dealOrgScomment(aggVOList);
		// 
		if (aggVOList != null && aggVOList.size() > 0) {
			NCLocator.getInstance().lookup(IArapVerifyLogPrivate.class).save(aggVOList, ruleVOMap, com);
		}
	}

	private Map<String, ArrayList<AggverifyVO>> onVerify(VerifyCom com, Map<String, DefaultVerifyRuleVO> ruleVOMap,
			ArapBusiDataVO[] jf_vos, ArapBusiDataVO[] df_vos) throws BusinessException {

		// Զ ֻкԳ壬ֺͬ

		com.setM_creditSelected(df_vos);
		com.setM_debitSelected(jf_vos);
		AggverifyVO aggvo = null;
		if (!ArrayUtils.isEmpty(jf_vos) || !ArrayUtils.isEmpty(df_vos)) {
			if (!ArrayUtils.isEmpty(jf_vos)) {
				SagasUtils.frozenAndAddSaga(SagasUtils.OTHER, jf_vos, IBillFieldGet.BILLNO, jf_vos[0].getPk_billtype());
			}
			if (!ArrayUtils.isEmpty(df_vos)) {
				SagasUtils.frozenAndAddSaga(SagasUtils.OTHER, df_vos, IBillFieldGet.BILLNO, df_vos[0].getPk_billtype());
			}

			for (String key : ruleVOMap.keySet()) {
				if (ArrayUtils.isEmpty(jf_vos) || ArrayUtils.isEmpty(df_vos)) {
					if (key.equals("SAME_VERIFY")) {
						continue;
					}
				} else {
					String billclass = jf_vos[0].getBillclass();
					String billclass2 = df_vos[0].getBillclass();

					if (billclass.equals(IBillFieldGet.YS) && billclass2.equals(IBillFieldGet.FK)
							|| billclass.equals(IBillFieldGet.FK) && billclass2.equals(IBillFieldGet.YS)) {
						if (key.equals("SAME_VERIFY") || key.equals("UNSAME_VERIFY")) {
							continue;
						}
					}
					if (billclass.equals(IBillFieldGet.YS) && billclass2.equals(IBillFieldGet.SK)
							|| billclass.equals(IBillFieldGet.SK) && billclass2.equals(IBillFieldGet.YS)
							|| billclass.equals(IBillFieldGet.YF) && billclass2.equals(IBillFieldGet.FK)
							|| billclass.equals(IBillFieldGet.FK) && billclass2.equals(IBillFieldGet.YF)) {
						if (key.equals("RB_VERIFY")) {
							continue;
						}
					}
				}

				DefaultVerifyRuleVO rulevo = ruleVOMap.get(key);
				if (key.equals("SAME_VERIFY")) {

					SameMnyVerify smverify = new SameMnyVerify(com);
					aggvo = smverify.onVerify(jf_vos, df_vos, rulevo);
					if (aggvo == null) {
						continue;
					}
					if (!ArrayUtils.isEmpty(aggvo.getChildrenVO())) {
						if (this.aggMap.containsKey("SAME_VERIFY")) {
							this.aggMap.get(key).add(aggvo);
						} else {
							ArrayList<AggverifyVO> temp = new ArrayList<AggverifyVO>();
							temp.add(aggvo);
							this.aggMap.put("SAME_VERIFY", temp);
						}
					}
				} else if (key.equals("RB_VERIFY")) {
					RBVerify rbverify = new RBVerify(com);
					aggvo = rbverify.onVerify(jf_vos, df_vos, rulevo);
					if (!ArrayUtils.isEmpty(aggvo.getChildrenVO())) {
						if (this.aggMap.containsKey("RB_VERIFY")) {
							this.aggMap.get(key).add(aggvo);
						} else {
							ArrayList<AggverifyVO> temp = new ArrayList<AggverifyVO>();
							temp.add(aggvo);
							this.aggMap.put("RB_VERIFY", temp);
						}
					}
				} else if (key.equals("UNSAME_VERIFY")) {
					UnsameMnyVerify unsameMnyVerify = new UnsameMnyVerify(com);
					aggvo = unsameMnyVerify.onVerify(jf_vos, df_vos, rulevo);
					if (!ArrayUtils.isEmpty(aggvo.getChildrenVO())) {
						if (this.aggMap.containsKey("UNSAME_VERIFY")) {
							this.aggMap.get(key).add(aggvo);
						} else {
							ArrayList<AggverifyVO> temp = new ArrayList<AggverifyVO>();
							temp.add(aggvo);
							this.aggMap.put("UNSAME_VERIFY", temp);
						}

					}
				}

			}
		}

		return this.aggMap;

	}

	@SuppressWarnings("rawtypes")
	private ArrayList<AggverifyVO> getAggVerifyVO(Map<String, ArrayList<AggverifyVO>> aggMap, UFBoolean isauto)
			throws BusinessException {
		List<VerifyDetailVO> detailVOList = new ArrayList<VerifyDetailVO>();
		ArrayList resultList = new ArrayList();
		if (aggMap == null) {
			return resultList;
		}
		for (String key : aggMap.keySet()) {
			detailVOList.clear();
			ArrayList<AggverifyVO> arrayList = aggMap.get(key);
			if (arrayList != null) {
				for (AggverifyVO aggVO : arrayList) {
					VerifyDetailVO[] childrenVO = (VerifyDetailVO[]) aggVO.getChildrenVO();
					// ˺Զñ־λ ¼ѯ
					for (VerifyDetailVO verifyvo : childrenVO) {
						verifyvo.setIsauto(isauto);
						detailVOList.add(verifyvo);
					}
				}
				// ֯ۺvo
				AggverifyVO aggVO = new AggverifyVO();
				aggVO.setChildrenVO(detailVOList.toArray(new VerifyDetailVO[0]));
				// ȫ űλ
				VerifyCom.calGroupAndGloablMny(aggVO);
				ArrayList<AggverifyVO> aggvolist = (ArrayList) VerifyCom.verifySumData(aggVO);

				resultList.addAll(aggvolist);
			}
		}
		return resultList;
	}

	/**
	 * ֺ
	 * 
	 * @param vo
	 * @param busiDate ȡεӦĻʡ
	 * @return
	 * @throws BusinessException
	 */
	private Hashtable<String, DefaultVerifyRuleVO> createUnVerifyRuleVO(ArapBillMapVO vo, UFDate busiDate)
			throws BusinessException {
		Hashtable<String, DefaultVerifyRuleVO> ruleMap = new Hashtable<String, DefaultVerifyRuleVO>();
		DefaultVerifyRuleVO rulevo = this.getVerifyRuleVO();
		rulevo.setM_verifyName("UNSAME_VERIFY");
		// Ƿ֯ ֯бȡűңȡ֯
		String pk_group = InvocationInfoProxy.getInstance().getGroupId();
		String pk_org = InvocationInfoProxy.getInstance().getGroupId();
		if (vo.getPk_org().equals(vo.getPk_org1())) {
			pk_org = vo.getPk_org();
		}
		String verifyCurr = CurrencyRateUtilHelper.getInstance().getLocalCurrtypeByOrgID(pk_org);
		rulevo.setM_verifyCurr(verifyCurr);
		// UFDate busiDate =new
		// UFDate(InvocationInfoProxy.getInstance().getBizDateTime());
		// жԴǷ跽
		if (IBillFieldGet.F2.equals(vo.getS_billtype()) || IBillFieldGet.F1.equals(vo.getS_billtype())) {
			// 跽֡
			int rateType = ArapBillCalUtil.getRateType(vo.getT_billtype(), pk_group);
			rulevo.setM_debitCurr(vo.getPk_currtype());
			rulevo.setM_jfbz2zjbzHL(Currency.getRate(pk_org, vo.getPk_currtype(), verifyCurr, busiDate, rateType));
			rulevo.setM_debttoBBExchange_rate(
					Currency.getRate(vo.getPk_org(), vo.getPk_currtype(), busiDate, rateType));
			// ֡
			int rateType1 = ArapBillCalUtil.getRateType(vo.getS_billtype(), pk_group);
			rulevo.setM_creditCurr(vo.getSettlecurr());
			rulevo.setM_dfbz2zjbzHL(Currency.getRate(pk_org, vo.getSettlecurr(), verifyCurr, busiDate, rateType1));
			rulevo.setM_creditoBBExchange_rate(
					Currency.getRate(vo.getPk_org1(), vo.getSettlecurr(), busiDate, rateType1));
		} else {
			// 跽֡
			int rateType = ArapBillCalUtil.getRateType(vo.getS_billtype(), pk_group);
			rulevo.setM_debitCurr(vo.getSettlecurr());
			rulevo.setM_jfbz2zjbzHL(Currency.getRate(pk_org, vo.getSettlecurr(), verifyCurr, busiDate, rateType));
			rulevo.setM_debttoBBExchange_rate(
					Currency.getRate(vo.getPk_org1(), vo.getSettlecurr(), busiDate, rateType));

			// ֡
			int rateType1 = ArapBillCalUtil.getRateType(vo.getT_billtype(), pk_group);
			rulevo.setM_creditCurr(vo.getPk_currtype());
			rulevo.setM_dfbz2zjbzHL(Currency.getRate(pk_org, vo.getPk_currtype(), verifyCurr, busiDate, rateType1));
			rulevo.setM_creditoBBExchange_rate(
					Currency.getRate(vo.getPk_org(), vo.getPk_currtype(), busiDate, rateType1));
		}
		ruleMap.put("UNSAME_VERIFY", rulevo);
		return ruleMap;
	}

	private Hashtable<String, DefaultVerifyRuleVO> createRBVerifyRuleVO() {
		Hashtable<String, DefaultVerifyRuleVO> ruleMap = new Hashtable<String, DefaultVerifyRuleVO>();
		DefaultVerifyRuleVO rulevo = this.getVerifyRuleVO();
		rulevo.setM_verifyName("RB_VERIFY");
		ruleMap.put("RB_VERIFY", rulevo);
		return ruleMap;
	}

	// private Hashtable<String, DefaultVerifyRuleVO> createVerifyRuleVO() {
	// Hashtable<String, DefaultVerifyRuleVO> ruleMap =
	// new Hashtable<String, DefaultVerifyRuleVO>();
	// DefaultVerifyRuleVO rulevo = this.getVerifyRuleVO();
	// rulevo.setM_verifyName("SAME_VERIFY");
	// ruleMap.put("SAME_VERIFY", rulevo);
	// return ruleMap;
	// }

	private DefaultVerifyRuleVO getVerifyRuleVO() {
		DefaultVerifyRuleVO rulevo = new DefaultVerifyRuleVO();
		Integer m_hxSeq = Integer.valueOf(0);
		// UFDateTime busidate = null;
		try {
			// busidate =
			// NCLocator.getInstance().lookup(IServerEnvironmentService.class)
			// .getServerTime();
			String hxSeq = "";
			if (this.getSyscode() == 0) {
				hxSeq = SysinitAccessor.getInstance().getParaString(this.getPkorg(), "AR1");
			} else {
				hxSeq = SysinitAccessor.getInstance().getParaString(this.getPkorg(), "AP1");
			}
			if (SysinitConst.VERIFY_ZAO.equals(hxSeq)) {
				m_hxSeq = Integer.valueOf(0);
			} else {
				m_hxSeq = Integer.valueOf(1);
			}

		} catch (Exception e) {
			ExceptionHandler.consume(e);
		}
		rulevo.setM_verifySeq(m_hxSeq);
		UFDate clrq = new UFDate(InvocationInfoProxy.getInstance().getBizDateTime());
		rulevo.setM_Clrq(clrq);
		AccountCalendar ac = AccountCalendar.getInstanceByPk_org(this.getPkorg());
		try {
			ac.setDate(clrq);
		} catch (InvalidAccperiodExcetion e) {
			ExceptionHandler.consume(e);
		}
		rulevo.setSystem(this.getSyscode());
		rulevo.setPk_org(this.getPkorg());
		rulevo.setM_Clnd(ac.getYearVO().getPeriodyear());
		rulevo.setM_Clqj(ac.getMonthVO().getAccperiodmth());
		rulevo.setIsOccuption(true);
		rulevo.setM_clr(this.getPk_user());
		return rulevo;
	}

	private Hashtable<String, DefaultVerifyRuleVO> creatVerifyRuleVO() {

		Hashtable<String, DefaultVerifyRuleVO> ruleMap = new Hashtable<String, DefaultVerifyRuleVO>();
		DefaultVerifyRuleVO rulevo = this.getVerifyRuleVO();
		rulevo.setM_verifyName("SAME_VERIFY");
		DefaultVerifyRuleVO rbrulevo = (DefaultVerifyRuleVO) rulevo.clone();
		rbrulevo.setM_verifyName("RB_VERIFY");
		ruleMap.put("SAME_VERIFY", rulevo);
		ruleMap.put("RB_VERIFY", rbrulevo);

		return ruleMap;
	}

	private boolean isJie(List<ArapBusiDataVO> listvo) {
		for (ArapBusiDataVO vo : listvo) {
			if (vo == null) {
				return false;
			}
			Integer int_fx = (Integer) vo.getAttributeValue(ArapBusiDataVO.DIRECTION);
			if (int_fx == null) {
				return false;
			}

			int fx = int_fx.intValue();

			return fx == 1;

		}
		return false;
	}

	/**
	 * @author ҫ
	 * @time 2019-5-15
	 * @param MapVOList
	 * @param com
	 * @param ruleVOMap
	 * @description ¼ӵķ,ԴGUIDҵӦ
	 */
	private void VerifyByGuid(AggregatedValueObject[] vos, VerifyCom com,
			Hashtable<String, DefaultVerifyRuleVO> ruleVOMap) {
		try {
			CircularlyAccessibleValueObject headValueObject = vos[0].getParentVO();
			Object pk_tradetype = headValueObject.getAttributeValue("pk_tradetype");
			List<String> pk_itemList = new ArrayList<String>();
			Object guid = null;
			String qryitemsql = "";

			UFBoolean iszhibaojin = UFBoolean.FALSE;
			if ("F3-Cxx-W01".equals(pk_tradetype)) {
				// def70Ƿʱ𸶿def8
				iszhibaojin = vos[0].getParentVO().getAttributeValue("def8") == null ? UFBoolean.FALSE
						: new UFBoolean(vos[0].getParentVO().getAttributeValue("def8").toString());
			} else {
				// def109Ƿʱ𸶿def14
				iszhibaojin = vos[0].getParentVO().getAttributeValue("def14") == null ? UFBoolean.FALSE
						: new UFBoolean(vos[0].getParentVO().getAttributeValue("def14").toString());
				if (logFlag) {
					log.info("iszhibaojin:"+iszhibaojin);
				}
			}

			if ("F3-Cxx-W01".equals(pk_tradetype)) {
				// def59 ǷƱ def3
				Object def3 = headValueObject.getAttributeValue("def3");

				UFBoolean isticketpay = null == def3 ? UFBoolean.FALSE : new UFBoolean(def3.toString());

				if (!isticketpay.booleanValue() && iszhibaojin.booleanValue()) {
					// def73ӦӦguid def11
					guid = headValueObject.getAttributeValue("def11");
					qryitemsql = "select pah.pk_payablebill\n" + "  from ap_payablebill pah\n" + " where pah.def1 = '"
							+ guid + "'\n" + "   and nvl(pah.dr, 0) = 0\n" + "  and pah.def14='Y'\n";
				}
			} else if ("F1-Cxx-W01".equals(pk_tradetype) || "F1-Cxx-W02".equals(pk_tradetype)) {
				guid = headValueObject.getAttributeValue("def1");
				// def95 ǷƱ def3
				Object def3 = headValueObject.getAttributeValue("def3");

				UFBoolean isticketpay = null == def3 ? UFBoolean.FALSE : new UFBoolean(def3.toString());
				if (logFlag) {
					log.info("isticketpay:"+isticketpay);
				}

				if (isticketpay.booleanValue() && iszhibaojin.booleanValue()) {
					qryitemsql = "select p.pk_paybill\n" + "  from ap_paybill p\n" + " where p.def11 = '" + guid + "'\n"
							+ "   and nvl(p.dr, 0) = 0\n" + "  and p.def8='Y'\n";
				} else {
					// def60 ԴGUID def1
					qryitemsql = "select p.pk_paybill\n" + "  from ap_paybill p\n" + " where p.def1 = '" + guid + "'\n"
							+ "   and nvl(p.dr, 0) = 0 \n" + "  and nvl(p.def3,'N')='N'";
				}
			} else {
				return;
			}
			pk_itemList.add(headValueObject.getPrimaryKey());

			if (logFlag) {
				log.info("qryitemsql:"+qryitemsql);
			}
			if (qryitemsql == "") {
				return;
			}

			List<String> list = (List<String>) new BaseDAO().executeQuery(qryitemsql, new ColumnListProcessor());
			nc.vo.tmpub.util.ArrayUtil.addListToList(pk_itemList, list);

			String qrySql = new StringBuilder("money_bal <> 0 and pk_bill in ("
					+ SqlUtil.buildSqlConditionForIn(pk_itemList.toArray(new String[0])) + ")").toString();
			Map<String, String> busiDataTsMap = new HashMap<String, String>();
			List<ArapBusiDataVO> dataList = new ArrayList<ArapBusiDataVO>();
			List<ArapBusiDataVO> jfdataList = new ArrayList<ArapBusiDataVO>();
			List<ArapBusiDataVO> dfdataList = new ArrayList<ArapBusiDataVO>();
			if (logFlag) {
				log.info("qrySql:"+qrySql);
			}
			NCObject[] ncObjects = MDPersistenceService.lookupPersistenceQueryService()
					.queryBillOfNCObjectByCond(ArapBusiDataVO.class, qrySql, false);
			if (logFlag) {
				for (NCObject ncObject : ncObjects) {
					log.info("ncObject_pk:" + ((ArapBusiDataVO) ncObject.getContainmentObject()).getPk_bill() + ":"
							+ ((ArapBusiDataVO) ncObject.getContainmentObject()).getMoney_bal());
				}
			}
			if (!ArrayUtils.isEmpty(ncObjects)) {
				for (DefaultVerifyRuleVO rule : ruleVOMap.values()) {
					rule.setM_creditObjKeys(new String[] { ArapBusiDataVO.DEF1,ArapBusiDataVO.DEF19});//ԴGUIDͱ̯ڼΪ
					rule.setM_debtObjKeys(new String[] { ArapBusiDataVO.DEF1,ArapBusiDataVO.DEF25});//ԴGUIDͱ̯ڼΪ
				}
				for (NCObject obj : ncObjects) {
					ArapBusiDataVO dataVO = (ArapBusiDataVO) obj.getContainmentObject();
					dataList.add(dataVO);
					// Ƚts ʹ
					busiDataTsMap.put(dataVO.getPk_busidata(), dataVO.getTs().toString());
					com.setBusiDataTsMap(busiDataTsMap);
				}
				// 
				for (ArapBusiDataVO datavo : dataList) {
					datavo.setAttributeValue(ArapBusiDataVO.SETT_MONEY, datavo.getOccupationmny());// Ҫý,Ȼ޷

					if (datavo.getCustomer() != null && datavo.getSupplier() == null) {
						datavo.setSupplier(datavo.getCustomer());
					}

					if (datavo.getDirection().intValue() == 1) {
						jfdataList.add(datavo);
						datavo.setDef1(guid.toString());// ͨӦpkаӦ͸
						datavo.setAttributeValue("SETT_MONEY", datavo.getMoney_bal());
					} else {
						dfdataList.add(datavo);
						datavo.setDef1(guid.toString());
						datavo.setAttributeValue("SETT_MONEY", datavo.getMoney_bal());
					}
				}
				Map<String, ArrayList<AggverifyVO>> aggMap = onVerify(com, ruleVOMap,
						jfdataList.toArray(new ArapBusiDataVO[0]), dfdataList.toArray(new ArapBusiDataVO[0]));
				ArrayList<AggverifyVO> aggVOList = getAggVerifyVO(aggMap);
				// 
				if (aggVOList != null && aggVOList.size() > 0) {
					NCLocator.getInstance().lookup(IArapVerifyLogPrivate.class).save(aggVOList, ruleVOMap, com);
				}else if (logFlag) {
					log.info("aggVOListΪ");
				}
			}else if(logFlag) {
				log.info("ncObjectsΪգδֱӷ");
			}
		} catch (Exception e) {
			ExceptionUtils.wrappBusinessException(e.getMessage());
		}
	}

	private ArrayList<AggverifyVO> getAggVerifyVO(Map<String, ArrayList<AggverifyVO>> aggMap) throws BusinessException {
		ArrayList resultList = new ArrayList();
		if (aggMap == null) {
			return resultList;
		}
		for (String key : aggMap.keySet()) {
			List<VerifyDetailVO> detailVOList = new ArrayList<VerifyDetailVO>();
			ArrayList<AggverifyVO> arrayList = aggMap.get(key);
			if (arrayList != null) {
				for (AggverifyVO aggVO : arrayList) {
					VerifyDetailVO[] childrenVO = (VerifyDetailVO[]) aggVO.getChildrenVO();
					// ˺Զñ־λ ¼ѯ
					for (VerifyDetailVO verifyvo : childrenVO) {
						verifyvo.setIsauto(UFBoolean.TRUE);
						detailVOList.add(verifyvo);
					}
				}
				// ֯ۺvo
				AggverifyVO aggVO = new AggverifyVO();
				aggVO.setChildrenVO(detailVOList.toArray(new VerifyDetailVO[0]));
				// ȫ űλ
				VerifyCom.calGroupAndGloablMny(aggVO);
				ArrayList<AggverifyVO> aggvolist = (ArrayList) VerifyCom.verifySumData(aggVO);

				resultList.addAll(aggvolist);
			}
		}
		return resultList;
	}
}

//nslGwwQRyySTBqdb6vgDeTX2flneCaaVP7NIdF4lqqHYeWcjsCkAJ3zO1zqNoOHrDD/sz60Weax087NE4mI8NA==