package nc.bs.arap.busireg;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;

import nc.bs.arap.constant.PropertyNCBilltypeConstant;
import nc.bs.arap.util.NCToMyXmlUtil;
import nc.bs.businessevent.IBusinessEvent;
import nc.bs.businessevent.IBusinessListener;
import nc.bs.businessevent.IEventType;
import nc.bs.dao.BaseDAO;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.arap.pay.PayBillVO;
import nc.vo.esb.ArapRequestToEsbAnnotatioVO;
import nc.vo.esb.ResultEsbMyToNcVO;
import nc.vo.esb.ResultMyToNcVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;

/** 
 * @author zhengyao3/֣
 * @date 2018-10-10 3:58:35
 * @Description:ҵĸȡ,ɾԴӿ
 *
 */
public class PaybillOfMyResversibleListener extends PayablebillOfMyResversibleListener implements IBusinessListener  {

	@Override
	public void doAction(IBusinessEvent event)
			throws BusinessException {
		AggregatedValueObject[] billvos = getAggVO(event);
		for (AggregatedValueObject bill : billvos) {
			PayBillVO vo =  (PayBillVO) bill.getParentVO();
			String tradeType = vo.getPk_tradetype();
			//ƱԴ
			String def3 = vo.getDef3();//def59Ϊ3
			if("Y".equals(def3)){
				continue;
			}
			if(PropertyNCBilltypeConstant.F3W01BILLTYPE.equals(tradeType)){
				String billType = "";
				String businessGUID = "";
				String operatorType = "";
				String URLCode = "";
				String elementResult = "";
				String elementResponse = "";
				if(IEventType.TYPE_UNAPPROV_BEFORE.equals(event.getEventType())){//ȡǰ
					operatorType = "ȡ";
					URLCode = "MY-NC-PM-003";
					elementResponse = "CheckOrderResponse";
					elementResult = "CheckOrderResult";
				}else if(IEventType.TYPE_DELETE_AFTER.equals(event.getEventType())){//ɾ
					operatorType = "ɾ";
					URLCode = "MY-NC-PM-002";
					elementResponse = "DeleteOrderResponse";
					elementResult = "DeleteOrderResult";
				}
				//޸ĵõķʽ,עеXstream begin
				businessGUID = vo.getDef1();//def60Ϊ1
				XStream x = new XStream(new DomDriver("utf-8"));
				x.alias("requestBaseEntity", ArapRequestToEsbAnnotatioVO.class);
				if(businessGUID == null || businessGUID.length() == 0){
					String sql = "select a.def1 from ap_paybill a where a.pk_paybill = '"+vo.getPk_paybill()+"'";
					Object value = new BaseDAO().executeQuery(sql, new ColumnProcessor());
					if(value != null && value.toString().length() > 0){
						businessGUID = value.toString();
					}
				}
				String def37 = vo.getDef37();//def63Ϊdef37 Դݱ
				String requestXML = x.toXML(getEsbVO(billType, businessGUID, operatorType,null,def37));
				String resultXML = NCToMyXmlUtil.sendXMLToMy(requestXML, URLCode, businessGUID);
				//ĵõķʽ,עеXstream end 
				ResultEsbMyToNcVO resultVO = NCToMyXmlUtil
						.getReverseResultEsbMyToNcVO(resultXML,elementResponse,elementResult);// ԴصXMLתɶӦVO
				if (resultVO != null) {
					ResultMyToNcVO resultInfoVO = resultVO.getResultInfo();
					if (!"S".equals(resultInfoVO.getStatus())) {// S,ʧ
						throw new BusinessException("Դ"
								+ resultInfoVO.getBusinessGUID()
								+ "ȡɾӿʧ,Ϊ:" + resultInfoVO.getReturnMsg());
					}
				}
			}
		}
	}

}
