package nc.bs.arap.termendtransact;

/**
 * ĩBOࡣ
 * ڣ(2001-8-21 10:06:57)
 * ޸ڣ(2001-8-21 10:06:57)
 * @authorwyan
 */

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import nc.bs.bd.businessevent.ReportInfo;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.itf.arap.termendtransact.ICloseAccountService;
import nc.itf.fi.pub.SysInit;
import nc.itf.uap.sf.ICreateCorpQueryService;
import nc.pubitf.accperiod.AccountCalendar;
import nc.pubitf.fip.service.IFipQueryService;
import nc.pubitf.org.IAccountingBookPubService;
import nc.pubitf.org.ICloseAccPubServicer;
import nc.pubitf.org.ICloseAccQryPubServicer;
import nc.vo.arap.dap.RetBillVo;
import nc.vo.arap.pub.ArapConstant;
import nc.vo.arap.termendtransact.AgiotageVO;
import nc.vo.arap.termendtransact.FilterCondVO;
import nc.vo.arap.termendtransact.RemoteTransferVO;
import nc.vo.arap.termendtransact.ReportVO;
import nc.vo.arap.termendtransact.TermEndVO;
import nc.vo.arap.transaction.FirstNotClosedAccountMonthVO;
import nc.vo.arap.utils.ARAPModuleEnableUtil;
import nc.vo.bd.period2.AccperiodmonthVO;
import nc.vo.fipub.exception.ExceptionHandler;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;

public class ReckoningBO { 
	private static final String AP22 = "AP22";
	private static final String AR22 = "AR22";
	private List<ReportInfo> reportInfo = new ArrayList<ReportInfo>();

	/**
	 * ReckoningBO ע⡣
	 */
	public ReckoningBO() {
		super();
	}

	/**
	 * ӻƽ̨ýֹûɻƾ֤ĵϢ ڣ(2002-6-6 14:38:55)
	 * @return java.util.Vector
	 * @param vo nc.vo.arap.termendtransact.FilterCondVO
	 */
	private RetBillVo[] getNotCreateVoucherDoc(FilterCondVO vo) throws BusinessException {

		RetBillVo[] voNoCreateVouDocs = null;
		try {
			String year = vo.getYear();
			String month = vo.getQj();

			AccountCalendar ac = AccountCalendar.getInstanceByPk_org(vo.getPk_org());
			ac.set(year, month);

			String[] billPks = NCLocator
					.getInstance()
					.lookup(IFipQueryService.class)
					.queryOperatingBill(ArapConstant.ARAP_AR_BILLCLASS.equals(vo.getSfbz()) ? "AR" : "AP", null, vo.getPk_org(), ac.getMonthVO().getBegindate(), ac.getMonthVO().getEnddate(),
							UFBoolean.FALSE);
			if (billPks == null || billPks.length == 0) {
				return null;
			}
			ReckoningDMO dmo = new ReckoningDMO();
			voNoCreateVouDocs = dmo.getRetBillVOByPks(billPks, vo);

		} catch (Exception e) {
			throw ExceptionHandler.handleException(this.getClass(), e);
		}

		return voNoCreateVouDocs;
	}

	/**
	 * Ҫܣ Ҫ㷨 쳣 ڣ(2001-9-21 15:51:09) ޸ڣ(2001-9-21 15:51:09)
	 * @authorwyan
	 * @return java.util.Vector
	 * @param vRep nc.vo.arap.termendtransact.ReportVO
	 */
	public Vector<Object> getRowTitle(ReportVO vRep) throws BusinessException {

		Vector<Object> vData = new Vector<Object>();
		try {
			vData.add(Integer.valueOf(vRep.getBh()));
			vData.add(vRep.getInfo());
			vData.add(vRep.getCount());
		} catch (Exception e) {
			throw ExceptionHandler.handleException(this.getClass(), e);
		}
		return vData;
	}

	/**
	 * Ҫܣĩ Ҫ㷨 쳣 ڣ(2001-8-16 17:58:10) ޸ڣ(2001-8-16 17:58:10)
	 * @authorwyan
	 */
	public RemoteTransferVO onReckoningCheck(FilterCondVO voCond, AgiotageVO voCurrency) throws BusinessException {

		RemoteTransferVO voRemote = new RemoteTransferVO();
		ReportVO repVO = new ReportVO();
		Vector<Vector<String>> vCheckData = new Vector<Vector<String>>();
		Vector<Vector<String>> vResult = new Vector<Vector<String>>();
		boolean bState = true; /* ˱־true-ʾԽ false-־Խ */
		try {
			ReckoningDMO dmo = new ReckoningDMO();
			int i = 1; /* Ϊûѡ飬Ϊ̬ */
			/* µǷȫЧ */
			if (voCond.getMode1() != null) {
				vCheckData = dmo.onReckoningCheckStep1(voCond);
				vResult = vCheckData;
				i++;
				if ((voCond.getMode1().equals("control")) && (vCheckData.size() > 1)) /* ȥ */{
					bState = false;
				}

			}
			/* ոǷȫ */
			if (voCond.getMode2() != null) {
				vCheckData = dmo.onReckoningCheckStep2(voCond);
				Vector<String> vTem = new Vector<String>();
				vTem.addElement(Integer.valueOf(i).toString());
				if (voCond.getSfbz().equals(ArapConstant.ARAP_AR_BILLCLASS)) {
					vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0048")/*
																															 * @res "δտ"
																															 */);
				}
				if (voCond.getSfbz().equals(ArapConstant.ARAP_AP_BILLCLASS)) {
					vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0049")/*
																															 * @res "δĸ"
																															 */);
				}
				vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0052", null, new String[] { String.valueOf(vCheckData.size()) }));// {0}

				vResult.addElement(vTem);
				if (vCheckData.size() != 0) {
					for (int j = 0; j < vCheckData.size(); j++) {
						vResult.addElement(vCheckData.elementAt(j));
					}
				}
				i++;
				if ((voCond.getMode2().equals("control")) && (vCheckData.size() != 0)) {
					bState = false;
				}
			}
			/* µǷȫɻƾ֤ */
			if (voCond.getMode3() != null) {
				Vector<String> vTem = new Vector<String>();
				int iSum = 0;
				RetBillVo[] voNotCreateVouDocs = getNotCreateVoucherDoc(voCond);
				if (voNotCreateVouDocs == null) {
					voNotCreateVouDocs = new RetBillVo[0];
				}
				vTem.addElement(Integer.valueOf(i).toString());
				vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0051")/*
																														 * @res "δɻƾ֤"
																														 */);
				vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("common", "UC000-0002282")/*
																												 * @res ""
																												 */);
				vResult.addElement(vTem);
				if (voNotCreateVouDocs.length != 0) {
					for (int j = 0; j < voNotCreateVouDocs.length; j++) {
						Vector<String> v = new Vector<String>();
						v.addElement("");
						v.addElement(voNotCreateVouDocs[j].getBillType() + voNotCreateVouDocs[j].getBillNo());
						v.addElement("");
						vResult.addElement(v);
					}
				}
				vResult.elementAt(vResult.size() - iSum - 1).setElementAt(
						nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0052", null, new String[] { String.valueOf(voNotCreateVouDocs.length) }), 2);// {0}
				i++;
				if ((voCond.getMode3().equals("control")) && (voNotCreateVouDocs.length != 0)) {
					bState = false;
				}
			}
			/* µǷȫ */
			if (voCond.getMode4() != null) {
				repVO = dmo.onReckoningCheckStep3(voCond, voCurrency);
				Vector<String> vTem = new Vector<String>();
				vTem.addElement(Integer.valueOf(i).toString());
				vTem.addElement(repVO.getInfo());
				vTem.addElement("");
				vResult.addElement(vTem);
				if ((voCond.getMode4().equals("control")) && (!repVO.getState())) {
					bState = false;
				}
			}
			// getDJZB().remove();
			voRemote.setTranData1(vResult); /* ˼ */
			voRemote.setReckoningState(bState); /*  */

		} catch (Exception e) {
			throw ExceptionHandler.handleException(this.getClass(), e);
		}

		return voRemote;

	}

	public static String[] getPreviousSettleAccountYearMonth(String[] enableInfo, String[] cancelSettInfo, String prodID, String pk_org) throws BusinessException {
		FirstNotClosedAccountMonthVO firstNoAccVO = new FirstNotClosedAccountMonthVO();
		String accYear = null;
		String accMonth = null;

		try {
			String year = cancelSettInfo[0]; /* ѡеҪȡ˵ڵ */
			String cope = cancelSettInfo[1]; /* ѡеҪȡ˵ڵڼ */

			AccountCalendar ac = AccountCalendar.getInstanceByPk_org(pk_org);
			ac.set(year);
			if (enableInfo == null) {
				enableInfo = NCLocator.getInstance().lookup(ICreateCorpQueryService.class).queryEnabledPeriod(pk_org, prodID);
			}

			String enabledYear = enableInfo[0]; /*  */
			String enabledMonth = enableInfo[1]; /*  */

			if (year.equals(enabledYear) && (cope.equals(enabledMonth))) {
				return new String[2];
			}
			if (cope.equals("01")) {
				accYear = Integer.valueOf(Integer.valueOf(year).intValue() - 1).toString();
				ac.set(accYear);
				AccperiodmonthVO[] tmpMonths = ac.getMonthVOsOfCurrentYear();
				accMonth = tmpMonths[tmpMonths.length - 1].getYearmth().substring(5, 7);
			}
			if (!cope.equals("01")) {
				accYear = year;
				Integer iMon = Integer.valueOf(Integer.valueOf(cope).intValue() - 1);
				if (iMon.intValue() < 10) {
					accMonth = "0" + iMon.toString();
				} else {
					accMonth = iMon.toString();
				}
			}
			firstNoAccVO.setNotAccMonth(accMonth);
			firstNoAccVO.setNotAccYear(accYear);
		} catch (Exception ex) {
			ExceptionHandler.handleException(ex);
		}

		return new String[] { accYear, accMonth };
	}

	/**
	 * į̃
	 * @param prodId ϵͳ
	 * @param endVO VO
	 * @param isCancel Ƿ
	 * @throws BusinessException
	 */
	public void termEndOperation(String prodId, TermEndVO endvo, boolean isCancel) throws BusinessException {
		boolean enabled = ARAPModuleEnableUtil.isEnable(InvocationInfoProxy.getInstance().getGroupId(), ARAPModuleEnableUtil.GL_MODULE_ID); // ģǷãûòУ
		if (enabled) {
			checkUnCloseAcc(prodId.equals("AR"), endvo.getYear(), endvo.getMonth(), endvo.getPk_org());
		}
		if (isCancel) {
			String[] previousSettleAccountYearMonth = getPreviousSettleAccountYearMonth(new String[] { endvo.getEnableyear(), endvo.getEnablemonth() },
					new String[] { endvo.getYear(), endvo.getMonth() }, prodId, endvo.getPk_org());
			endvo.setYear(previousSettleAccountYearMonth[0]);
			endvo.setMonth(previousSettleAccountYearMonth[1]);
		}

		try {
			NCLocator.getInstance().lookup(ICloseAccountService.class).updateCloseAccountInfo(endvo.getNodecode(), endvo.getPk_org(), endvo.getYear(), endvo.getMonth());
		} catch (Exception e) {
			ExceptionHandler.handleException(e);
		}
		// ȡ˺ҪϢuapĹģ
		NCLocator.getInstance().lookup(ICloseAccPubServicer.class).reAccount(endvo.getNodecode(), endvo.getPk_org(), endvo.getPk_org(), endvo.getPk_periodmonth());
	}

	public List<ReportInfo> onReckoningReportCheck(FilterCondVO voCond, AgiotageVO voCurrency) throws BusinessException {
		ReportVO repVO = new ReportVO();
		Vector<Vector<String>> vCheckData = new Vector<Vector<String>>();
		Vector<Vector<String>> vResult = new Vector<Vector<String>>();
		UFBoolean bState = UFBoolean.TRUE; /* ˱־true-ʾԽ false-־Խ */
		String periodState = voCond.getPeriodState();
		try {
			ReckoningDMO dmo = new ReckoningDMO();
			int i = 1; /* Ϊûѡ飬Ϊ̬ */
			/* µǷȫЧ */
			if (voCond.getMode1() != null) {
				UFBoolean isStrongCheck = UFBoolean.FALSE;
				vCheckData = dmo.onReckoningCheckStep1(voCond);
				vResult = vCheckData;
				i++;
				List<Vector<String>> detail = Collections.list(vCheckData.elements());
				List<String> msg = new ArrayList<>();
				for (int j = 1; j < detail.size(); j++) {
					Vector<String> vector = detail.get(j);
					if (vector.elementAt(1) == null) {
						continue;
					}
					msg.add(vector.elementAt(1));
				}
				if (("control".equals(voCond.getMode1())) && (vCheckData.size() > 1)) /* ȥ */{
					bState = UFBoolean.FALSE;
				}
				if ("control".equals(voCond.getMode1())) {
					isStrongCheck = UFBoolean.TRUE;
				}
				addReprotInfo(vResult.get(0).get(1), bState, isStrongCheck, vResult.get(0).get(2), periodState, msg);// ûݺŵЭͬδȷϵ

			}
			/* ոǷȫ */
			if (voCond.getMode2() != null) {
				UFBoolean isStrongCheck = UFBoolean.FALSE;
				vCheckData = dmo.onReckoningCheckStep2(voCond);
				Vector<String> vTem = new Vector<String>();
				vTem.addElement(Integer.valueOf(i).toString());
				if (ArapConstant.ARAP_AR_BILLCLASS.equals(voCond.getSfbz())) {
					vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0048")/*
																															 * @res "δտ"
																															 */);
				}
				if (ArapConstant.ARAP_AP_BILLCLASS.equals(voCond.getSfbz())) {
					vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0049")/*
																															 * @res "δĸ"
																															 */);
				}
				vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0052", null, new String[] { String.valueOf(vCheckData.size()) }));// {0}
				if (("control".equals(voCond.getMode2())) && (vCheckData.size() != 0)) {
					bState = UFBoolean.FALSE;
				}
				if ("control".equals(voCond.getMode2())) {
					isStrongCheck = UFBoolean.TRUE;
				}
				vResult.addElement(vTem);
				if (vCheckData.size() != 0) {

					List<Vector<String>> detail = Collections.list(vCheckData.elements());
					List<String> msg = new ArrayList<>();
					for (int j = 0; j < detail.size(); j++) {
						Vector<String> vector = detail.get(j);
						msg.add(vector.elementAt(1));
					}
					addReprotInfo(vTem.elementAt(1), bState, isStrongCheck, vTem.elementAt(2), periodState, msg);
				}
				i++;

			}
			/* µǷȫɻƾ֤ */
			if (voCond.getMode3() != null) {
				UFBoolean isStrongCheck = UFBoolean.FALSE;
				Vector<String> vTem = new Vector<String>();
				int iSum = 0;
				RetBillVo[] voNotCreateVouDocs = getNotCreateVoucherDoc(voCond);
				if (voNotCreateVouDocs == null) {
					voNotCreateVouDocs = new RetBillVo[0];
				}
				vTem.addElement(Integer.valueOf(i).toString());
				vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0051")/*
																														 * @res "δɻƾ֤"
																														 */);
				vTem.addElement(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("common", "UC000-0002282")/*
																												 * @res ""
																												 */);
				vResult.addElement(vTem);

				List<String> detail = new ArrayList<>();// ˱ϸϢ

				if (voNotCreateVouDocs.length != 0) {

					for (int j = 0; j < voNotCreateVouDocs.length; j++) {
						Vector<String> v = new Vector<String>();
						v.addElement("");
						v.addElement(voNotCreateVouDocs[j].getBillType() + voNotCreateVouDocs[j].getBillNo());
						v.addElement("");
						detail.add(v.elementAt(1));
						// vResult.addElement(v);
					}
				}
				vResult.elementAt(vResult.size() - iSum - 1).setElementAt(
						nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006v61020_0", "02006v61020-0052", null, new String[] { String.valueOf(voNotCreateVouDocs.length) }), 2);// {0}
				i++;
				if ((voCond.getMode3().equals("control")) && (voNotCreateVouDocs.length != 0)) {
					bState = UFBoolean.FALSE;
				}
				if ("control".equals(voCond.getMode3())) {
					isStrongCheck = UFBoolean.TRUE;
				}
				addReprotInfo(vTem.elementAt(1), bState, isStrongCheck, vTem.elementAt(2), periodState, detail);
			}
			/* µǷȫ */
			if (voCond.getMode4() != null) {
				UFBoolean isStrongCheck = UFBoolean.FALSE;
				repVO = dmo.onReckoningCheckStep3(voCond, voCurrency);
				Vector<String> vTem = new Vector<String>();
				vTem.addElement(Integer.valueOf(i).toString());
				vTem.addElement(repVO.getInfo());
				vTem.addElement("");
				vResult.addElement(vTem);
				if ((voCond.getMode4().equals("control")) && (!repVO.getState())) {
					bState = UFBoolean.FALSE;
				}
				if ("control".equals(voCond.getMode4())) {
					isStrongCheck = UFBoolean.TRUE;
				}
				addReprotInfo(repVO.getInfo(), bState, isStrongCheck, null, periodState, null);// ʾ׼ȷʾݵĸ
			}

		} catch (Exception e) {
			throw ExceptionHandler.handleException(this.getClass(), e);
		}

		return reportInfo;

	}

	/**
	 * reportInfoϢװ
	 * @param checkitem 
	 * @param isPass Ƿͨ
	 * @param isStrongCheck ǷϵͳǿУ
	 * @param explain ˵֮ģ
	 */
	private void addReprotInfo(String checkitem, UFBoolean isPass, UFBoolean isStrongCheck, String explain, String periodState, List<String> detail) {
		ReportInfo info = new ReportInfo();
		info.setPk_accperiod(periodState);
		info.setIsPass(isPass);
		info.setIsStrongCheck(isStrongCheck);
		info.setCheckItem(checkitem);
		info.setExplain(explain);
		if (detail != null) {
			info.setDetail(detail);
		}
		reportInfo.add(info);
	}

	private void checkUnCloseAcc(boolean isar2, String year, String cope, String pk_org) throws BusinessException {
		Map<String, String> book = NCLocator.getInstance().lookup(IAccountingBookPubService.class).queryAccountingBookIDByFinanceOrgIDWithMainAccountBook(new String[] { pk_org });
		String pkbook = null;
		if (book == null || book.size() == 0) {
			return;
		}

		String param = SysInit.getParaString(pk_org, isar2 ? AR22 : AP22);

		if ("Y".equals(param)) {
			pkbook = book.values().iterator().next();
			String period = year + "-" + cope;

			boolean res = NCLocator.getInstance().lookup(ICloseAccQryPubServicer.class).isCloseByAccountBookId(pkbook, period);

			String para = SysInit.getParaString(pk_org, "GL034");
			if (res && para != null && para.equals(pkbook)) {
				throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("2006pub_0", "02006pub-0475")/* @res "ѾʣܽӦӦˣ" */);
			}
		}

	}
}