package nc.bs.my.arap;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import nc.bs.arap.constant.PropertyFormularConstant;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.bs.trade.business.HYPubBO;
import nc.itf.sap.log.IExtLogService;
import nc.itf.uap.pf.IPFBusiAction;
import nc.net.servlet.IReturnStatus;
import nc.pub.sap.constant.SapConstants;
import nc.vo.arap.payable.AggPayableBillVO;
import nc.vo.arap.payable.PayableBillItemVO;
import nc.vo.arap.payable.PayableBillVO;
import nc.vo.esb.EsbInfoVO;
import nc.vo.esb.QueryInfoVO;
import nc.vo.esb.ResultEsbVO;
import nc.vo.esb.ResultEsbVO_Arap;
import nc.vo.esb.ResultGuidVO;
import nc.vo.esb.ResultVO;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.sap.log.SapPurchaseLogVO;
import nc.vo.uap.busibean.exception.BusiBeanException;
import ncc.bs.arap.myutil.MYArapItfUtil;
import uap.json.JSONObject;
/**
 * @Description: My->NC F1-Cxx-W01
 * @author ա̹԰my
 * @date 2018-9-14
 * @version with NC V6.3
 */
public class MyArapWriteReceivablesBS {
	
	private String ITFTYPE = "NC-MY-PM-001";
//	//
//	private  String PK_BILLTYPEID = "0000Z3000000000000F0";  
//	//
//	private String PK_BILLTYPECODE = "F1";    
//	//
//	private String PK_TRADETYPEID = "1001H810000003BRY2YA";    
//	
//	//UUID ɱʶ
//	private final String GUID = UUID.randomUUID().toString();   
	/**
	 * ʱ侫ȷ
	 */
	public static SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
	public ResultEsbVO_Arap myArapWriteReceivablesBS(String key, String billdata,String postJson) {
		Logger.error("ӿڣnc.pubitf.sap.fi.ISapFi");
		Logger.error("ҵ" + this.getClass().getName());
		Logger.error("ҵຯmyarapinset");
		Logger.error("1 key" + key);
		Logger.error("2 billdata" + billdata);
		return doAction(key,billdata,postJson);
	}
	private ResultEsbVO_Arap doAction(String key, String billdata,String postJson) {
		//
		String billid = "";
		//֯
		String pk_org = "";
		//ݱ
		String billno="";
		//ͱ
		String pk_tradetype = "F1-Cxx-W01";
		
		// jsonϢ
		ResultEsbVO_Arap esbvo = new ResultEsbVO_Arap();
		ResultGuidVO sapResultVO = new ResultGuidVO();
		//wby 20211108 Ĭֵ 
		sapResultVO.setCode(IReturnStatus.ESB_SUCCEED_CODE);
		sapResultVO.setMessage("MYϵͳNCϵͳ Ӧɹ");
		sapResultVO.setError("");
		AggPayableBillVO aggVO = null;
		try {
			Logger.info("Ӧ У鴫Ĳ");
			if (!SapConstants.CHECK_KEY.equals(key)) {
				throw new Exception("key֤ʧ ");
			}
			if (billdata == null) {
				throw new Exception("ӦϢΪգ");
			}
			// ǿУ a.billdataΪУ顾Ϊգ򷵻شjsonʽݡ
			JSONObject data = new JSONObject(billdata);
	
			aggVO = MYArapItfUtil.jsonToAggVO(data,AggPayableBillVO.class,PayableBillVO.class,PayableBillItemVO.class);
			sapResultVO.setGuid(aggVO.getHeadVO().getDef1());
			PayableBillItemVO[]  bvo = (PayableBillItemVO[]) aggVO.getChildrenVO();
			if ("02".equals(aggVO.getHeadVO().getDef39())) {
				for (int i = 0; i < bvo.length; i++) {
					bvo[i].setNotax_de(bvo[i].getMoney_de());
					bvo[i].setLocal_notax_de(bvo[i].getLocal_money_de()); 
				}
			}
			
			MYArapItfUtil.notNullCheckAndExFormula(PropertyFormularConstant.F1W01HEAD,PropertyFormularConstant.F1W01BODY, aggVO);
		    HYPubBO bo =new HYPubBO();
			String def1=(String) bo.findColValue("ap_payablebill", "def1", " nvl(dr,0)=0 and def1='"+aggVO.getHeadVO().getDef1()+"'");
			if (def1!=null && !"".equals(def1)) {
				throw new BusiBeanException("쳣MY-GUIDظ-"+aggVO.getHeadVO().getDef1());
			}
			// ִб桢ύ
			IPFBusiAction baService = NCLocator.getInstance().lookup(IPFBusiAction.class);
			
			pk_tradetype = aggVO.getHeadVO().getPk_tradetype();
			pk_org=aggVO.getHeadVO().getPk_org();
			if(pk_tradetype == null || "null".equals(pk_tradetype)) {
				ExceptionUtils.wrappBusinessException("pk_tradetypeΪ");
			}
			if(pk_org == null || "null".equals(pk_org)) {
				ExceptionUtils.wrappBusinessException("pk_orgΪ");
			}
			//  creator
			baService.processAction("SAVE", pk_tradetype, null, aggVO, null,null);
			baService.processAction("COMMIT", pk_tradetype, null, aggVO, null,null);
			
			billid=aggVO.getHeadVO().getPk_payablebill();
			billno=aggVO.getHeadVO().getBillno();
			if(billid == null || "null".equals(billid)) {
				ExceptionUtils.wrappBusinessException("pk_tradetypeΪ");
			}
			if(billno == null || "null".equals(billno)) {
				ExceptionUtils.wrappBusinessException("billnoΪ");
			}
			//Ҫ
			//
			baService.processAction("APPROVE",pk_tradetype, null, aggVO, null, null);
//		    //---
//		    if(aggVO.getHeadVO().getDef71() != null && aggVO.getHeadVO().getDef71().length() > 0){
//				new ArapWsBillRegisterForBusiDataBO().doAction2(aggVO.getHeadVO(),aggVO.getHeadVO().getDef71());
//		    }
			
			//Ҫ
		    
			//·ֵ
			esbvo.setPayablebillvo(aggVO.getHeadVO());
		} catch (Exception e) {
			// װ쳣־Ϣ
			Logger.debug("Ӧͬʧ : " + e.getMessage());
			sapResultVO.setMessage("MYϵͳNCϵͳ Ӧʧ");
			sapResultVO.setCode(IReturnStatus.ESB_FAILING_CODE);
			String message = e.getMessage() != null ? e.getMessage() : e.toString();
			sapResultVO.setError(message);
		} finally {
			// ־
			try {
				//־VO
				esbvo.setResultInfo(sapResultVO);
				createEsbVO(1, esbvo, new JSONObject(billdata), sapResultVO);// Ӧ MDGToNcSupplierServelet.java  Ӧ
				String issuccess_sn = "";
				if (IReturnStatus.ESB_SUCCEED_CODE.equals(sapResultVO.getCode())) {
					issuccess_sn = "Y";
				} else {
					issuccess_sn = "N";
				}
				List<SapPurchaseLogVO> logvo_list = new ArrayList<SapPurchaseLogVO>();
				SapPurchaseLogVO log = new SapPurchaseLogVO();
				log.setPk_org(ITFTYPE);
		    	log.setBillid(billid);
		    	log.setBillno(billno);
		    	log.setPk_billtypecode("F1");
		    	log.setPk_transtypecode(pk_tradetype);
		    	log.setSend_data_sn(postJson);
		    	//json
		    	ResultEsbVO rvo = new ResultEsbVO();
		    	rvo.setEsbInfo(esbvo.getEsbInfo());
		    	rvo.setQueryInfo(esbvo.getQueryInfo());
		    	rvo.setResultInfo(esbvo.getResultInfo());
		    	log.setResultdata_sn(com.alibaba.fastjson.JSONObject.toJSONString(rvo));
		    	// json
		    	log.setMsg_sn(sapResultVO.getMessage()+sapResultVO.getError());
		    	log.setIssuccess_sn(issuccess_sn);
		    	log.setDef1(this.getClass().getName());
				IExtLogService logService=NCLocator.getInstance().lookup(IExtLogService.class);
				logService.insertLog_RequiresNew(log);
			} catch (Exception e) {
				Logger.debug("־ʧ : " + e.getMessage());
			}
		}
		return esbvo;
	}
	
	/**
	 * ESB
	 * 
	 * @param newi
	 * @param esb
	 *            VO
	 * @return newi=0()/newi=1(Ӧ)
	 */
	@SuppressWarnings("rawtypes")
	public void createEsbVO(int newi,  ResultEsbVO_Arap esb,
			uap.json.JSONObject jsonobj, ResultVO resultvo) {
		uap.json.JSONObject esbinfo = jsonobj.getJSONObject("esbInfo");
		Date date = Calendar.getInstance().getTime();// ȡǰʱ
		EsbInfoVO esbInfo = new EsbInfoVO();
		esbInfo.setReturnCode(resultvo.getCode());
		esbInfo.setInstId(esbinfo.getString("instId"));
		esbInfo.setReturnMsg(resultvo.getMessage());
		// ȡ
		QueryInfoVO queryInfo = new QueryInfoVO();
		queryInfo.setTotalPage("");// ĬҳΪ 1
		queryInfo.setCurrentPage("");// ĬϵǰҳΪ 1
		if (newi == 0) {// ʱ
			esbInfo.setRequestTime(dateFormat.format(date));
		} else {// Ӧʱ
			esbInfo.setRequestTime(dateFormat.format(date));
			esbInfo.setResponseTime(dateFormat.format(date));
			if (IReturnStatus.ESB_SUCCEED_CODE.equals(resultvo.getCode())) {
				esbInfo.setReturnStatus(IReturnStatus.ESB_SUCCEED);// Ӧɹ
			} else if (IReturnStatus.ESB_ERROR_CODE.equals(resultvo.getCode())) {
				esbInfo.setReturnStatus(IReturnStatus.ESB_ERROR);// Ӧ쳣
			} else {
				esbInfo.setReturnStatus(IReturnStatus.ESB_FAILING);// Ӧʧ
			}
		}
		esb.setEsbInfo(esbInfo);
		esb.setQueryInfo(queryInfo);
	}
}
