package nc.bs.sap.fi;

import java.util.HashMap;
import java.util.UUID;

import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.impl.pubapp.env.BSContext;
import nc.itf.uap.pf.IplatFormEntry;
import nc.pub.sap.constant.SapConstants;
import nc.pubitf.arap.receivable.IArapReceivableBillPubQueryService;
import nc.util.mmf.framework.base.MMStringUtil;
import nc.util.mmf.framework.base.MMValueCheck;
import nc.util.mmf.framework.base.MMValueConvert;
import nc.util.uap.twxt.WYTwxtUtil;
import nc.vo.arap.receivable.AggReceivableBillVO;
import nc.vo.arap.receivable.ReceivableBillVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pubapp.AppContext;
import nc.vo.pubapp.pflow.PfUserObject;
import nc.vo.sap.log.SapFinanceLogVO;
import nc.vo.sap.result.SAPResultVO;
/**
 * @Description: ڲӦЭͬȷ  ɾӿ
 * @author Գ ̹԰SAPר
 * @date 2018-06-01
 * @version with NC V6.3
 */
public class SapFiWriteSynergeticDelete {
	private String ITFTYPE = "SAPڲӦϢ";
	//
	private  String PK_BILLTYPEID = "0000Z3000000000000F0";
	//
	private String PK_BILLTYPECODE = "F0";
	//
	private String PK_TRADETYPEID="";
	//ͱ
	private String PK_TRADETYPE = "";   
	//
	private String billid = "";
	//ݱ
	private String billno = "";
	//֯
	private String pk_org = "";
	//Ϣ
	private String rsInfo = "";
	//UUID ɱʶ
	private final String GUID = UUID.randomUUID().toString();   
	public String sapWriteSynergeticDelete(String key, String billdata) {
		Logger.error("ҵ" + this.getClass().getName());
		Logger.error("ҵຯSapwriteSynergeticDelete");
		Logger.error("1 key" + key);
		Logger.error("2 billdata" + billdata);
		return doAtion(key,billdata);
	}

	private String doAtion(String key, String billdata) {
		    IplatFormEntry baService = NCLocator.getInstance().lookup(IplatFormEntry.class);
	     	ReceivableBillVO hvo = null;
	     	BaseDAO dao = new BaseDAO();
	  		//صjsonϢ
			SAPResultVO sapResultVO = new SAPResultVO();
			//ʱĬϲ
			HashMap<String, Object> customProperties = new HashMap<String, Object>();
			customProperties.put("notechecked", "notechecked");
			try {
				if (!SapConstants.CHECK_KEY.equals(key)) {
					throw new Exception("key֤ʧ  ");
				}
				if (MMStringUtil.isEmpty(billdata)) {
					throw new Exception("ڲӦϢΪ  ");
				}
				JSONObject jsonObj = JSONObject.parseObject(billdata);
				JSONObject data = (JSONObject) jsonObj.get("data");
				if (data.containsKey("pk_recbill") && MMValueCheck.isEmpty(data.get("pk_recbill"))) {
					sapResultVO.setMsg("쳣(pk_recbill)Ϊ");
					return rsInfo =JSONObject.toJSONString(sapResultVO);
				}
				String pk_recbill = (String) data.get("pk_recbill");
				IArapReceivableBillPubQueryService queryService=NCLocator.getInstance().lookup(IArapReceivableBillPubQueryService.class);
				AggReceivableBillVO[] aggvos =queryService.findBillByPrimaryKey(new String[] {pk_recbill});
				if (MMValueCheck.isEmpty(aggvos)) {
						sapResultVO.setIssuccess(SapConstants.FAIL_TRANS);
						sapResultVO.setMsg("쳣NCC");
						return rsInfo =JSONObject.toJSONString(sapResultVO);
				}
				AggReceivableBillVO aggvo=aggvos[0];
				if(new UFBoolean(aggvo.getHeadVO().getDef8()).booleanValue()){
					sapResultVO.setIssuccess(SapConstants.SU_TRANS);
					sapResultVO.setMsg("NCݣ"+aggvo.getHeadVO().getPk_recbill()+"Эͬ벻Ҫظ");
					return rsInfo =JSONObject.toJSONString(sapResultVO);
				}
				InvocationInfoProxy.getInstance().setProperty("issapconfirm", "Y");
				BSContext.getInstance().setSession("issapconfirm", "Y");
 			    if (data.containsKey("def37") && MMValueConvert.toUFBoolean(data.get("def37")).booleanValue() && (!data.getBooleanValue("def38") || !data.containsKey("def38"))) {
 			    	Logger.error("SAPڲӦЭͬȷ");
			    	hvo= (ReceivableBillVO) aggvo.getParentVO();
			        billid = hvo.getPk_recbill();
				    pk_org = hvo.getPk_org();
				    PK_TRADETYPEID = hvo.getPk_tradetypeid();
				    PK_TRADETYPE = hvo.getPk_tradetype();
				    billno = hvo.getBillno();
			    	ITFTYPE="SAPڲӦЭͬȷ";
			    	PK_BILLTYPECODE =hvo.getPk_tradetype();
			    	// ״̬ΪYʱ  Զ
					PfUserObject PfUserObject=new PfUserObject();
					PfUserObject[] Pfs=new PfUserObject[]{PfUserObject};
			        String actionName = "APPROVE";
			        InvocationInfoProxy.getInstance().setUserId(hvo.getBillmaker());
			    	baService.processAction(actionName,PK_BILLTYPECODE,null, aggvo, Pfs, customProperties);
			    	dao.executeUpdate("update ar_recbill set def8='Y',approver='"+hvo.getBillmaker()+"' where pk_recbill='"+hvo.getPk_recbill()+"'");
				}
			    //SAP def38
			    if (data.containsKey("def38") && data.getBooleanValue("def38")) {
				    Logger.error("SAPڲӦȷ");
				    hvo= (ReceivableBillVO) aggvo.getParentVO();
				    billid = hvo.getPk_recbill(); 
				    pk_org = hvo.getPk_org();
				    PK_TRADETYPEID = hvo.getPk_tradetypeid();
				    PK_TRADETYPE = hvo.getPk_tradetype();
				    //ݺ
				    billno = hvo.getBillno();
				    ITFTYPE="SAPڲӦȷ";
				    PK_BILLTYPEID =hvo.getPk_tradetypeid();
				    PK_BILLTYPECODE = hvo.getPk_tradetype();
			    	if (!MMValueConvert.toUFBoolean(hvo.getDef8()).booleanValue()) {
			    		if(hvo.getApprovestatus()==1) {//ͨŽȡ
			    		//SAP ΪY жЭͬȷǷΪNΪNʱ ޸ SAPΪN,SAPΪY  ޸ SAP Y
			    		String actionName="UNAPPROVE";
			    		PfUserObject PfUserObject=new PfUserObject();
						PfUserObject[] Pfs=new PfUserObject[]{PfUserObject};
			    		baService.processAction(actionName,PK_BILLTYPECODE,null, aggvo, Pfs, customProperties);
			    		}
			    		dao.executeUpdate("update ar_recbill set def7='N' where pk_recbill='"+hvo.getPk_recbill()+"'");
					}else {
						//sap ΪY.жЭͬȷǷΪYΪYʱ ޸ SAPΪY 
						dao.executeUpdate("update ar_recbill set def9='Y' where pk_recbill='"+hvo.getPk_recbill()+"'");
					}
				}
				// װͬɹ־Ϣ		
				sapResultVO.setBillid(billid);
				sapResultVO.setIssuccess(SapConstants.SU_TRANS);
				sapResultVO.setMsg("ɹ");
				rsInfo =JSONObject.toJSONString(sapResultVO);
			 } catch (Exception e) {
				// װ쳣־Ϣ
				Logger.debug("ڲӦͬʧ : " + e.getMessage());
				sapResultVO.setBillid(billid);
				sapResultVO.setIssuccess(SapConstants.FAIL_TRANS);
				sapResultVO.setMsg("쳣"+e.getMessage());
				rsInfo =JSONObject.toJSONString(sapResultVO);
			}finally {
				try {
					//־VO
					SapFinanceLogVO logVO = new SapFinanceLogVO();
					logVO.setPk_group(AppContext.getInstance().getPkGroup());
					logVO.setPk_org(pk_org);
					logVO.setBillid(billid);
					logVO.setBillno(billno);
					logVO.setPk_billtypeid(PK_BILLTYPEID);
					logVO.setPk_billtypecode(PK_BILLTYPECODE);
					logVO.setPk_transtypecode(PK_TRADETYPE);
					logVO.setPk_transtypeid(PK_TRADETYPEID);
					logVO.setSend_data_sn(billdata);
					logVO.setResultdata_sn(rsInfo);
					logVO.setMsg_sn(sapResultVO.getMsg());
					logVO.setIssuccess_sn(sapResultVO.getIssuccess());
					logVO.setDef1(ITFTYPE);
					WYTwxtUtil.getIWuYeTwxtLogService().insertLog_RequiresNew(logVO);
				}catch (Exception e) {
					Logger.debug("־ʧ : " + e.getMessage());
				}
			}
		return rsInfo;
	}
}
