package nc.bs.arap.util;

import nc.ui.pub.bill.BillStatus;
import nc.ui.pubapp.uif2app.actions.pflow.ApproveStatus;
import nc.vo.arap.pay.AggPayBillVO;
import nc.vo.arap.pay.PayBillItemVO;
import nc.vo.arap.pay.PayBillVO;
import nc.vo.arap.payable.AggPayableBillVO;
import nc.vo.gl.impservice.ErpPaybillConsts;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;

/** 
 * @author zhengyao3/֣
 * @date 2018-9-20 5:31:48
 * @Description:TODO
 *
 */
public class BillSetDefaultValueUtil {
	
	public static void setPayablebillVODefaultValue(AggPayableBillVO aggvo){
		
		
		
	}
	public static void setPaybillVODefaultValue(AggPayBillVO aggvo){
		PayBillVO payBillVO = aggvo.getHeadVO();
		payBillVO.setPk_busitype(ErpPaybillConsts.BUSITYPE);
		payBillVO.setPk_currtype(ErpPaybillConsts.CURRTYPE_RMB);
		payBillVO.setObjtype(1);
		payBillVO.setEffectstatus(0);
		payBillVO.setIsflowbill(UFBoolean.FALSE);
		payBillVO.setIsforce(UFBoolean.FALSE);
		payBillVO.setIsfromindependent(UFBoolean.FALSE);
		payBillVO.setIsinit(UFBoolean.FALSE);
		payBillVO.setIsmandatepay(UFBoolean.FALSE);
		payBillVO.setIsnetpayready(UFBoolean.FALSE);
		payBillVO.setIsonlinepay(UFBoolean.FALSE);
		payBillVO.setIsreded(UFBoolean.FALSE);
		payBillVO.setPk_billtype(ErpPaybillConsts.ERP_BILLTYPE_F3);
		payBillVO.setRate(UFDouble.ONE_DBL);
		payBillVO.setSddreversalflag(UFBoolean.FALSE);
		//payBillVO.setSett_org(ErpPaybillConsts.FHYX_PK_ORG);
		//payBillVO.setSett_org_v(ErpPaybillConsts.FHYX_PK_ORG_V);
		payBillVO.setSrc_syscode(1);
		payBillVO.setSyscode(1);
		payBillVO.setSettleflag(0);
		payBillVO.setCreationtime(new UFDateTime());
		payBillVO.setModifiedtime(new UFDateTime());
		payBillVO.setApprovestatus(ApproveStatus.FREE);
		payBillVO.setBillstatus(BillStatus.FREE);
		payBillVO.setAccessorynum(0);
		payBillVO.setBillclass("fk");
		
		PayBillItemVO[] billItemVOs = (PayBillItemVO[]) aggvo.getChildrenVO();
		for(PayBillItemVO billItemVO : billItemVOs){
			billItemVO.setBillclass("fk");
			billItemVO.setPk_balatype(payBillVO.getPk_balatype());
			billItemVO.setObjtype(1);
			billItemVO.setOccupationmny(billItemVO.getMoney_de());
			billItemVO.setLocal_money_bal(billItemVO.getMoney_de());
//			billItemVO.setLocal_notax_de();
//			billItemVO.setNotax_de();
//			billItemVO.setMoney_bal();
//			billItemVO.setLocal_tax_de();
			billItemVO.setPausetransact(UFBoolean.FALSE);
			billItemVO.setPk_billtype("F3");
			billItemVO.setPk_balatype(payBillVO.getPk_balatype());
			billItemVO.setPayaccount(payBillVO.getPayaccount());
			billItemVO.setRecaccount(payBillVO.getRecaccount());
			billItemVO.setPk_fiorg(payBillVO.getPk_fiorg());
			billItemVO.setPk_group(payBillVO.getPk_group());
			billItemVO.setPk_org(payBillVO.getPk_org());
			billItemVO.setPk_org_v(payBillVO.getPk_org_v());
			billItemVO.setPk_tradetype(payBillVO.getPk_tradetype());
			billItemVO.setPk_tradetypeid(payBillVO.getPk_tradetypeid());
			billItemVO.setPk_currtype(ErpPaybillConsts.CURRTYPE_RMB);
			billItemVO.setPrepay(0);
			billItemVO.setRate(UFDouble.ONE_DBL);
			billItemVO.setSett_org(payBillVO.getSett_org());
			billItemVO.setSett_org_v(payBillVO.getSett_org_v());
			
		}
		
	}

}
