package nc.bs.cmp.wybcsc.task;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.bs.pub.pa.PreAlertObject;
import nc.bs.pub.pa.PreAlertReturnType;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.bs.resa.sql.SqlUtil;
import nc.itf.arap.pay.IArapPayBillQueryService;
import nc.itf.cmp.settlement.ISettlementQueryService;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.util.mmf.framework.base.MMArrayUtil;
import nc.util.mmf.framework.base.MMValueCheck;
import nc.util.uap.wgpt.WuYeWgptUtil;
import nc.vo.arap.pay.AggPayBillVO;
import nc.vo.bd.bankaccount.BankAccSubVO;
import nc.vo.bd.bankdoc.BankdocVO;
import nc.vo.cmp.settlement.SettlementAggVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.tmpub.util.DateUtil;
import nc.vo.wgpt.log.WuYeWgptLogVO;
import ncc.pub.wywgpt.utils.WyWGPTUtils;
/**
 * ½̨࣬ҵɹѽδд̲̳ǵݻд̲̳
 * @author ҫ
 * @date 2020-9-22
 */
public class WYCGPaybillSettleWriteBackPlugin implements IBackgroundWorkPlugin {
//update by xuwb Ż
	@Override
	public PreAlertObject executeTask(BgWorkingContext context) throws BusinessException {
		String message ="";
		PreAlertObject msg = new PreAlertObject();
		msg.setReturnType(PreAlertReturnType.RETURNMESSAGE);
		StringBuilder sb=new StringBuilder();
		Map<String, Object> paraMap=context.getKeyMap();
		Object begindate=paraMap.get("begindate");
		Object billno=paraMap.get("billno");
		IArapPayBillQueryService queryService=NCLocator.getInstance().lookup(IArapPayBillQueryService.class);
		//wby 20210930 ˽Ϊɹpk_tradetype='F3-Cxx-D42'
		String conString="pk_tradetype='F3-Cxx-D42' and nvl(dr, 0) = 0  and (nvl(def41, '~') = '~' or nvl(def41,'N') ='N')  and  money >0 and substr(paydate, 0, 10) >'"+begindate+"' "+(MMValueCheck.isEmpty(billno)?" ":"  and "+SqlUtil.buildInSql("billno", billno.toString().split(","), true));
		AggPayBillVO[]  aggPayBillVOs= queryService.queryBillsByWhereSQL(conString);
		if(MMArrayUtil.isNotEmpty(aggPayBillVOs)) {
			int yftotal=0;//Ԥ
			int fktotal=0;//
			BaseDAO baseDAO=new BaseDAO();
			WuYeWgptLogVO logVO = null;

			JSONObject requestInfo=null;
			
			String esbResultinfoStr = null;
			Set<String> successSet=new HashSet<String>();
			for(int i=0;i<aggPayBillVOs.length;i++) {
				JSONArray billList=new JSONArray();//ӿ		
				List orderPayReqList=new ArrayList();//Ԥļ
				
				sb=new StringBuilder();
				logVO = new WuYeWgptLogVO();
				logVO.setItfcode("NC-WGPT-PU-003");
				logVO.setTranstypecode("F3");
				logVO.setItfname("ҵ㵥 /ȡ̨дϢ_HD");
				AggPayBillVO aggPayBillVO=aggPayBillVOs[i];
				
				logVO.setNc_id(aggPayBillVO.getHeadVO().getPrimaryKey());
				logVO.setBillno(aggPayBillVO.getHeadVO().getBillno());
				
				aggPayBillVO.getHeadVO().setDef49(UFBoolean.FALSE.toString());
//				aggPayBillVO.getHeadVO().setDef41(UFBoolean.FALSE.toString());

				requestInfo=new JSONObject();
				sb.append("Դ"+aggPayBillVO.getHeadVO().getSrc_syscode());
				if((aggPayBillVO.getHeadVO().getSrc_syscode()!=1 && aggPayBillVO.getHeadVO().getSrc_syscode()!=4)){
					continue;
				}
				String qrySql="select distinct bp.s_billid\n" +
						"  from arap_billmap bp\n" + 
						" where bp.t_billid = '"+aggPayBillVO.getHeadVO().getPk_paybill()+"'\n" + 
						"   and nvl(bp.dr, 0) = 0";


				List list=(List) baseDAO.executeQuery(qrySql, new ColumnListProcessor());
				sb.append("ѯչϵ"+list.size()+"##"+list.toString());
				UFBoolean isSendWGPT=new UFBoolean(aggPayBillVO.getHeadVO().getDef69());
				if(null==list || list.isEmpty()){
					list=new ArrayList();
					list.add(aggPayBillVO.getHeadVO().getPk_paybill());
				}

				JSONObject billdata=null;

				for(int j=0;j<list.size();j++){			
					Object P_billno="";
					int status=0;
					String sql=null;
					if(aggPayBillVO.getHeadVO().getSrc_syscode()==1){//ԴϵͳӦϵͳ=1  ӿ
						//vdef10	ƽ̨㵥
						//vdef14	Ƿƽ̨
						sql="select case  when  iv.vdef10 is null then 'none' else iv.vdef10  end ||'@'|| case when iv.vdef8 is null then  'N' else iv.vdef8 end wgpt \n" +
								"  from po_invoice iv\n" + 
								" where exists (select *\n" + 
								"          from ap_payableitem pii\n" + 
								"         where pii.top_billid = iv.pk_invoice\n" + 
								"           and pii.pk_payablebill in ('"+list.get(j)+"'))";
						P_billno =baseDAO.executeQuery(sql, new ColumnProcessor());
						sb.append("Ʊ"+P_billno);
						if("".equals(P_billno) || null ==P_billno){
							continue;
						}

						String[] wgpts =P_billno.toString().split("@");
						UFBoolean iswgpt=ValueUtils.getUFBoolean(wgpts[1]);
						if(!iswgpt.booleanValue()){//Ƿд̲
							continue;
						}else {	    
						billdata=new JSONObject();
						billdata.put("payAmount", aggPayBillVO.getHeadVO().getMoney().doubleValue());
						billdata.put("invoiceType", aggPayBillVO.getHeadVO().getEffectstatus()==10?"1":"0");
						billdata.put("paymentTime", DateUtil.getCurrTime().toStdString());
					    billdata.put("billNo", P_billno.toString().split("@")[0]);	
					    billdata.put("status", status);	
					    billList.add(billdata);
						}
					}
					else if(aggPayBillVO.getHeadVO().getSrc_syscode()==4){//Դϵͳ ɹϵͳ=4  Ԥӿ
						status=1;
						//ǲƽ̨ĵ
						sql="select case when vdef15 is null then 'none' else vdef15 end ||'@'|| case when vdef14 is null then 'N' else vdef14 end  wgpt \n" +
								"  from po_order od\n" + 
								" where exists (select *\n" + 
								"          from ap_payitem api\n" + 
								"         where od.pk_order = api.top_billid\n" + 
								"           and api.pk_paybill = '"+aggPayBillVO.getHeadVO().getPk_paybill()+"')";
						P_billno=baseDAO.executeQuery(sql,  new ColumnProcessor());
						sb.append("ɹ"+P_billno);
						if("".equals(P_billno) || null ==P_billno){
							continue;
						}

						String[] wgpts =P_billno.toString().split("@");
						UFBoolean iswgpt=ValueUtils.getUFBoolean(wgpts[1]);
						if(!iswgpt.booleanValue()){
							continue;
						}else {
						//װԤ
						JSONObject orderPayRequestJson=new JSONObject();
						orderPayRequestJson.put("method", "sendOrderPaymentMsg");	
						orderPayRequestJson.put("orderProviderNo", P_billno.toString().split("@")[0]);
						orderPayRequestJson.put("paymentState", aggPayBillVO.getHeadVO().getEffectstatus()==10?"1":"0");
						orderPayRequestJson.put("paymentOrderNo", aggPayBillVO.getHeadVO().getBillno());
						orderPayRequestJson.put("paymentPrice", aggPayBillVO.getHeadVO().getMoney().toString());
						Object pk_account =aggPayBillVO.getBodyVOs()[0].getPayaccount();
						if(MMValueCheck.isEmpty(pk_account)){
							ISettlementQueryService qryService=NCLocator.getInstance().lookup(ISettlementQueryService.class);
							SettlementAggVO settlementAggVO=qryService.querySettlementAggByPk_busibill(aggPayBillVO.getHeadVO().getPk_paybill());
							if(MMValueCheck.isNotEmpty(settlementAggVO.getChildrenVO()[0].getAttributeValue("pk_account"))){
								pk_account=settlementAggVO.getChildrenVO()[0].getAttributeValue("pk_account");
							}
						}
						if(MMValueCheck.isEmpty(pk_account)){
							ExceptionUtils.wrappBusinessException("˻Ϊգݺţ"+aggPayBillVO.getHeadVO().getBillno());
						}
						orderPayRequestJson.put("paymentSubject", pk_account==null?"":((BankAccSubVO)baseDAO.retrieveByPK(BankAccSubVO.class, pk_account.toString(), new String[] {"accname"})).getAccname());
						BankdocVO[] bankdocVOs=(BankdocVO[]) baseDAO.retrieveByClause(BankdocVO.class, "pk_bankdoc in (select distinct bas.pk_bankdoc from bd_bankaccsub sub inner join bd_bankaccbas bas on sub.pk_bankaccbas = bas.pk_bankaccbas where sub.pk_bankaccsub ='"+pk_account+"')", new String[] {"name"}).toArray(new BankdocVO[0]);
						orderPayRequestJson.put("paymentBank",bankdocVOs[0].getName());
						orderPayRequestJson.put("bankPrice", aggPayBillVO.getHeadVO().getMoney().toString());
						orderPayRequestJson.put("payTime", ValueUtils.getUFDate(aggPayBillVO.getHeadVO().getPaydate())==null?"":aggPayBillVO.getHeadVO().getPaydate().toString());
						orderPayRequestJson.put("flagCode", aggPayBillVO.getBodyVOs()[0].getBankrelated_code());
						orderPayReqList.add(orderPayRequestJson);
						}
					}				
				}
				if(orderPayReqList.size()>0) {
					yftotal=orderPayReqList.size();
					WuYeWgptLogVO sendOrderPaymentMsgLogVO=null;
					for(int a=0;a<orderPayReqList.size();a++) {
						sendOrderPaymentMsgLogVO=new WuYeWgptLogVO();
						sendOrderPaymentMsgLogVO.setIssuccess(UFBoolean.TRUE.toString());
						sendOrderPaymentMsgLogVO.setItfcode("NC-WGPT-PU-003==sendOrderPaymentMsg");
						sendOrderPaymentMsgLogVO.setItfname("дϢֶ==_HD");
						String sendJsonData =WyWGPTUtils.getSendToEsbData("NC-WGPT-PU-003"+DateUtil.getCurrTime().getMillis(), orderPayReqList.get(a));
						//
						try {
							sendOrderPaymentMsgLogVO.setBilldata(sendJsonData);
							//xug ޸ĵ÷ʽ
							JSONObject esbResultinfo = WyWGPTUtils.sendToESB_GX(sendJsonData,"NC-WGPT-PU-003");
							if(esbResultinfo!=null){
								esbResultinfoStr = esbResultinfo.toString();
								sendOrderPaymentMsgLogVO.setRsdata(esbResultinfoStr);
								Logger.error("дϢӿ==sendOrderPaymentMsg"+sendJsonData+"\r\nز"+esbResultinfoStr);
								JSONObject esbInfo = (JSONObject)esbResultinfo.get("esbInfo");
								aggPayBillVO.getHeadVO().setDef49(UFBoolean.TRUE.toString());
								if(esbInfo!=null){
									//ӿڷ״̬Sɹ/W棩/E
									String returnStatus = esbInfo.get("returnStatus")+"";
									returnStatus = "E".equals(returnStatus)?"":"";
									if("".equals(returnStatus)){
										aggPayBillVO.getHeadVO().setDef49(UFBoolean.FALSE.toString());
										String returnMsg = esbInfo.get("returnMsg")+"";
										ExceptionUtils.wrappBusinessException("ӿڴ"+returnMsg);
									}
								}
								JSONObject resultInfo = esbResultinfo.getJSONObject("resultInfo");
								Object success = resultInfo.get("success");
								if(!"true".equals(success+"")){
									aggPayBillVO.getHeadVO().setDef49(UFBoolean.FALSE.toString());
									Object result = resultInfo.get("result");
									ExceptionUtils.wrappBusinessException("ƽ̨ʾ:"+result);
								}
							}
							successSet.add(aggPayBillVO.getHeadVO().getPk_paybill());
						} catch (Exception e) {
							aggPayBillVO.getHeadVO().setDef49(UFBoolean.FALSE.toString());
							sendOrderPaymentMsgLogVO.setIssuccess(UFBoolean.FALSE.toString());
							sendOrderPaymentMsgLogVO.setMsg(e.getMessage()+"##"+WuYeWgptUtil.getExceptionDetail(e));
//							ExceptionUtils.wrappBusinessException("쳣\n"+e.getMessage()+"\nģ\n"+sendJsonData+"\nرģ\n"+esbResultinfoStr);//xug ע
						}finally{
							WuYeWgptUtil.getIWuYeWgptLogService().insertLog_RequiresNew(sendOrderPaymentMsgLogVO);
						}
					}
				}

				if(billList.size()>0){
					fktotal=billList.size();
					requestInfo.put("method", "getPaymentMsg");
					requestInfo.put("billList", billList);
					String sendJsonData =WyWGPTUtils.getSendToEsbData("NC-WGPT-PU-003"+DateUtil.getCurrTime().getMillis(), requestInfo);
					sb.append("ģ"+requestInfo);
					logVO.setBilldata(requestInfo.toString());
					//
					try {
						logVO.setIssuccess(UFBoolean.TRUE.toString());
						//xug ޸ĵ÷ʽ
						JSONObject esbResultinfo = WyWGPTUtils.sendToESB_GX(sendJsonData,"NC-WGPT-PU-003");
						aggPayBillVO.getHeadVO().setDef49(UFBoolean.TRUE.toString());
						if(esbResultinfo!=null){
							esbResultinfoStr = esbResultinfo.toString();
							sb.append("رģ"+esbResultinfoStr);
							logVO.setRsdata(esbResultinfoStr);
							Logger.error("дϢӿڡ"+sendJsonData+"\r\nز"+esbResultinfoStr);
							JSONObject esbInfo = (JSONObject)esbResultinfo.get("esbInfo");
							if(esbInfo!=null){
								//ӿڷ״̬Sɹ/W棩/E
								String returnStatus = esbInfo.get("returnStatus")+"";
								returnStatus = "E".equals(returnStatus)?"":"";
								if("".equals(returnStatus)){
									aggPayBillVO.getHeadVO().setDef49(UFBoolean.FALSE.toString());
									String returnMsg = esbInfo.get("returnMsg")+"";
									ExceptionUtils.wrappBusinessException("ӿڴ"+returnMsg);
								}
							}
							JSONObject resultInfo = esbResultinfo.getJSONObject("resultInfo");
							Object success = resultInfo.get("success");
							if(!"true".equals(success+"")){
								aggPayBillVO.getHeadVO().setDef49(UFBoolean.FALSE.toString());
								Object result = resultInfo.get("result");
								ExceptionUtils.wrappBusinessException("ƽ̨ʾ:"+result);
							}
						}else {
							logVO.setIssuccess(UFBoolean.FALSE.toString());
							sb.append("ӿڷesbInfo Ϊգ");
						}
						successSet.add(aggPayBillVO.getHeadVO().getPk_paybill());
					} catch (Exception e) {
						aggPayBillVO.getHeadVO().setDef49(UFBoolean.FALSE.toString());
						logVO.setIssuccess(UFBoolean.FALSE.toString());
						sb.append(e.getMessage()+"##"+WuYeWgptUtil.getExceptionDetail(e));
//						logVO.setMsg(e.getMessage()+"##"+WuYeWgptUtil.getExceptionDetail(e));
//						ExceptionUtils.wrappBusinessException("쳣\n"	+e.getMessage()+"\nģ\n"+sendJsonData+"\nرģ\n"+esbResultinfoStr);//xug ע
					}finally{
						logVO.setMsg(sb.toString());
						WuYeWgptUtil.getIWuYeWgptLogService().insertLog_RequiresNew(logVO);
					}
				}
				//xug  ͳɹд49
				if(UFBoolean.valueOf(aggPayBillVO.getHeadVO().getDef49()).booleanValue()) {
					WuYeWgptUtil.getIWuYeWgptLogService().updateSql_RequiresNew("update ap_paybill set def49='Y',def41='Y' where pk_paybill = '"+aggPayBillVO.getHeadVO().getPk_paybill()+"'");
				}
				if(orderPayReqList.size() == 0 && billList.size() == 0) {
					logVO.setIssuccess(UFBoolean.FALSE.toString());
					logVO.setMsg(sb.toString());
					WuYeWgptUtil.getIWuYeWgptLogService().insertLog_RequiresNew(logVO);
				}
			}
//			if(successSet.size()>0) {
//				baseDAO.executeUpdate("update  ap_paybill  set  def49='Y'  where "+SqlUtil.buildInSql("pk_paybill", successSet.toArray(new String[0]), true));
//			}
			int total=yftotal+fktotal;
			message="ִ̨гɹ"+total+"ɹ"+successSet.size()+"ʧ"+(total-successSet.size());
		}else {
			message="ûвϵݣ";
		}
		msg.setReturnObj(message);
		msg.setMsgTitle("NC-̲̳ǡҵɹд̲̳");
		context.setLogStr(message);
		return msg;
	}

}
