package nc.service.rest.api;

import java.util.List;
import nc.bs.dao.BaseDAO;
import nc.bs.sec.esapi.NCESAPI;
import nc.itf.gl.voucher.IVoucher;
import nc.itf.uap.IUAPQueryBS;
import nc.vo.gl.closeaccbook.CloseaccbookVO;
import nc.vo.gl.pubvoucher.VoucherVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pubapp.AppContext;
import nc.jdbc.framework.SQLParameter;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.service.rest.base.NcToNccBaseRestService;
import javax.servlet.http.HttpServletRequest;

import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nccloud.commons.lang.StringUtils;
import nccloud.pubitf.gl.lightgl.voucher.IVoucherWebService;

/**
 * ɾNCCƾ֤ӿڣ˽ӿֻɾNC͹ƾ֤
 * 2020-11-24
 * @version NCC2005
 */
@SuppressWarnings("restriction")
public class DeleteVoucherRestService extends NcToNccBaseRestService {

	private static final long serialVersionUID = 1L;
	private BaseDAO dao = new BaseDAO();
	private IVoucherWebService service = NCLocator.getInstance().lookup(IVoucherWebService.class);
	private IVoucher queryService = NCLocator.getInstance().lookup(IVoucher.class);

	@Override
	protected Object execute(JSONObject json) throws Exception {

		JSONArray data = json.getJSONArray("data");
		if (data == null || data.size() == 0) {
			throw new BusinessException("ݱΪգ޷ɾƾ֤");
		}
		// 1.ݵݺŲѯƾ֤
		String[] billCodes = data.toArray(new String[0]); // ݱ
		String[] pks = getVoucherKeys(billCodes); // ѯɾƾ֤
		if (pks.length > 0) {
			throw new BusinessException("NCCϵͳӦƾ֤δɾȡƵ");
			//return"NCCϵͳӦƾ֤ѱɾ";
		} /*
			 * else { // 2.ƾ֤ŲѯVO VoucherVO[] vos = queryService.queryByPks(pks); //
			 * ѯƾ֤VO if (pks.length != vos.length) { // throw new
			 * BusinessException("NCCϵͳӦƾ֤ѱɾ"); return"NCCϵͳӦƾ֤ѱɾ"; }else { //
			 * 3.У״̬ɾ String paraSql =
			 * "SELECT value FROM pub_sysinit WHERE initcode ='GL140' and nvl(dr,0)=0 ";
			 * String para = (String) dao.executeQuery(paraSql, new ColumnProcessor());
			 * if(null != para && para.equals("Y")) { for (VoucherVO vo : vos) { //УǷˡ
			 * String returnMsg = closeAccbook(vo.getPk_org(),vo.getPrepareddate());
			 * if(StringUtils.isEmpty(returnMsg)) { String pk_checked = vo.getPk_checked();
			 * //  String pk_manager = vo.getPk_manager(); //  UFBoolean signflag =
			 * vo.getSignflag(); // ǩֱ if (pk_checked != null && !"~".equals(pk_checked)
			 * && !"N".equals(pk_checked)) { throw new BusinessException("NCCƾ֤ˣɾ"); }
			 * if (pk_manager != null && !"~".equals(pk_manager) &&
			 * !"N/A".equals(pk_manager) && !"N".equals(pk_manager)) { throw new
			 * BusinessException("NCCƾ֤Ѽˣɾ"); } if (signflag.booleanValue()) { throw
			 * new BusinessException("NCCƾ֤ǩ֣ɾ"); }
			 * InvocationInfoProxy.getInstance().setUserId(vo.getPk_prepared()); //
			 * ƵΪǰûɾӿڱûȨ service.deleteVoucher4RestAPI(new String[] {
			 * vo.getPk_voucher() }); // ɾÿݵƵ˿ܲһ£ֻѭɾ }else { throw new
			 * BusinessException(returnMsg); } } }else { for (VoucherVO vo : vos) {
			 * //УǷˡ String returnMsg =
			 * closeAccbook(vo.getPk_org(),vo.getPrepareddate());
			 * if(StringUtils.isEmpty(returnMsg)) { //ƾ֤ȡ
			 * InvocationInfoProxy.getInstance().setUserId(vo.getPk_manager());
			 * service.tallyVoucher(new String[] {vo.getPk_voucher()},
			 * AppContext.getInstance().getBusiDate().toString(), false, true); //ƾ֤ȡ
			 * InvocationInfoProxy.getInstance().setUserId(vo.getPk_checked());
			 * service.checkVoucher(new String[] {vo.getPk_voucher()}, false, true); //ƾ֤ɾ
			 * InvocationInfoProxy.getInstance().setUserId(vo.getPk_prepared()); //
			 * ƵΪǰûɾӿڱûȨ service.deleteVoucher4RestAPI(new String[] {
			 * vo.getPk_voucher() }); // ɾÿݵƵ˿ܲһ£ֻѭɾ }else { throw new
			 * BusinessException(returnMsg); } } } return "ͨNCCӿڳɹɾ" + vos.length +
			 * "ƾ֤"; } }
			 */
		return "ɹ";
	}

	private String closeAccbook(String pk_org, UFDate prepareddate) throws BusinessException {
		String yearmth = prepareddate.toString().substring(0, 7);
		//У鵱¹ˡ
		String closeaccSql = "SELECT * FROM org_closeacc WHERE pk_org ='"+pk_org+"' AND pk_accperiodmonth in(SELECT pk_accperiodmonth  FROM bd_accperiodmonth WHERE yearmth='"+yearmth+"' AND nvl(dr,0)=0) AND moduleid='2002'AND nvl(dr,0)=0\r\n" ;
		List<CloseaccbookVO> accbookvoList = (List<CloseaccbookVO>)NCLocator.getInstance().lookup(IUAPQueryBS.class).executeQuery(closeaccSql,new BeanListProcessor(CloseaccbookVO.class));
		String flagSql = "SELECT isendacc FROM org_closeacc WHERE pk_org ='"+pk_org+"' AND pk_accperiodmonth in(SELECT pk_accperiodmonth  FROM bd_accperiodmonth WHERE yearmth='"+yearmth+"' AND nvl(dr,0)=0) AND moduleid='2002'AND nvl(dr,0)=0\r\n" ;
		String isendacc = (String)NCLocator.getInstance().lookup(IUAPQueryBS.class).executeQuery(flagSql,new ColumnProcessor());
		if((null != accbookvoList && accbookvoList.size() != 0)) {
			if(null != accbookvoList.get(0).getIsclose() && accbookvoList.get(0).getIsclose().booleanValue()) {
				return"NCCϵͳѹˣȷϺ";
			}else if(!StringUtils.isEmpty(isendacc) && "Y".equalsIgnoreCase(isendacc)){
				return"NCCϵͳѽˣȷϺ";
			}else if((null != accbookvoList.get(0).getIsclose() && accbookvoList.get(0).getIsclose().booleanValue()) && !StringUtils.isEmpty(isendacc) && "Y".equalsIgnoreCase(isendacc)) {
				return"NCCϵͳѹˡѽˣȷϺ";
			}
		}
		return null;
	}

	/**
	 * ͨݺŲѯɾƾ֤
	 * 
	 * @param billCodes
	 * @return
	 * @throws BusinessException
	 */
	@SuppressWarnings("unchecked")
	public String[] getVoucherKeys(String[] billCodes) throws BusinessException {
		if (billCodes == null || billCodes.length == 0) {
			return new String[0];
		}
		String sql = "select pk_voucher from gl_voucher where free3 in (" + createInSql(billCodes) + ") and nvl(dr,0)=0";
		List<String> result = (List<String>) this.dao.executeQuery(sql, new ColumnListProcessor());
		return result == null ? new String[0] : result.toArray(new String[0]);
	}

	@Override
	public void exeBoforeLog(HttpServletRequest request, JSONObject json) throws Exception {
		String logID = getLogID(json); // ݺ

		// 1.ɾǰ־ظ͵ĳ
		String deleteSql = "delete from push_voucher_log where billcode='" + NCESAPI.sqlEncode(logID) + "'";
		this.dao.executeUpdate(deleteSql);

		// 2. ־Ϣ
		String insertSql = "insert into push_voucher_log(billcode,description,status,json_data) values(?,?,?,?)";
		SQLParameter params = new SQLParameter();
		params = new SQLParameter();
		params.addParam(logID);
		params.addParam("NCCյɾƾ֤");
		params.addParam("processing"); // ״̬
		params.addParam(json.toJSONString()); // 
		this.dao.executeUpdate(insertSql, params);
	}

	@Override
	public void exeAfterLog(HttpServletRequest request, JSONObject json) throws Exception {
		String logID = getLogID(json); // ݺ
		String status = "success";
		String description = "NCCƾ֤ɾɹ";
		String sql = "update push_voucher_log set description='" + NCESAPI.sqlEncode(description) + "',status='"
				+ NCESAPI.sqlEncode(status) + "' where billcode='" + NCESAPI.sqlEncode(logID) + "'";
		this.dao.executeUpdate(sql);
	}

	@Override
	public void businessErrorLog(HttpServletRequest request, JSONObject json, String errorMsg) throws Exception {
		String logID = getLogID(json); // ݺ
		String status = "failure"; // ״̬ʧ
		String description = "NCCɾƾ֤ҵ쳣";
		String sql = "update push_voucher_log set description='" + NCESAPI.sqlEncode(description) + "',status='"
				+ NCESAPI.sqlEncode(status) + "',error_msg='" + NCESAPI.sqlEncode(errorMsg) + "' where billcode='"
				+ NCESAPI.sqlEncode(logID) + "'";
		this.dao.executeUpdate(sql);
	}

	/**
	 * ȡ־
	 * 
	 * @param json
	 * @return
	 */
	public String getLogID(JSONObject json) throws BusinessException {
		JSONArray data = json.getJSONArray("data");
		if (data == null || data.size() == 0) {
			return "D_~";
		}
		StringBuffer result = new StringBuffer("D_"); // ƾ֤Ŀ굥ݺţöŸDʾɾ
		for (int i = 0; i < data.size(); i++) {
			result.append((i == data.size() - 1) ? data.getString(i) : (data.getString(i) + ","));
		}
		return result.toString().trim();
	}

	/**
	 * ƴSQL IN
	 * 
	 * @param paramsSet
	 * @return
	 */
	public static String createInSql(String[] params) {
		if (params == null || params.length == 0) {
			return "''";
		}
		StringBuffer inSql = new StringBuffer();
		for (int i = 0; i < params.length; i++) {
			String param = params[i] == null ? "" : params[i];
			inSql.append(i == params.length - 1 ? ("'" + param + "'") : ("'" + param + "',"));
		}
		return inSql.toString();
	}

}
