package nc.bs.ic.m45.wgpt.rule;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.logging.Logger;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.ic.m45.entity.PurchaseInBodyVO;
import nc.vo.ic.m45.entity.PurchaseInHeadVO;
import nc.vo.ic.m45.entity.PurchaseInVO;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import ncc.pub.wywgpt.utils.WyWGPTUtils;

/**
 * @Description: ǩʱдϢƽ̨
 * 
 * @author л ̹԰-ҵ-ƽ̨ӿڡ
 * @date 2019-3-6
 * @version with NC V6.3
 */


public class WuYeWgptWriteBackBS {

	public void process(PurchaseInVO[] vos) {
		if(null ==vos){
			return;
		}
		String sendJsonData = null;
		String esbResultinfoStr = null;
		try {
			PurchaseInHeadVO hVO;
			PurchaseInBodyVO[] bodys;
			for(PurchaseInVO vo:vos){
				hVO = vo.getHead();
				if("Y".equals(hVO.getVdef14())){
					//Vdef26 ƽ̨
					if(hVO.getVdef16()==null){
						ExceptionUtils.wrappBusinessException("ƽ̨Ϊգ");
					}
					bodys = vo.getBodys();
					
					BaseDAO dao  = new BaseDAO();
					StringBuffer sqlstr = new StringBuffer("");
					sqlstr.append("select vdef15 from po_order where pk_order = '"+bodys[0].getCfirstbillhid()+"'"); 
					String orderNo = (String)dao.executeQuery(sqlstr.toString(), new ColumnProcessor());
					if(orderNo==null){
						ExceptionUtils.wrappBusinessException("ƽ̨Ϊգ");
					}
					
					JSONObject requestInfo = new JSONObject();
					JSONArray details = new JSONArray();
					JSONObject detail;
					for(PurchaseInBodyVO body:bodys){
						detail = new JSONObject();
						//ƽ̨Ʒ
						detail.put("sku", body.getVfirstrowno());
						//ʵ
						detail.put("num", body.getNnum().abs());
						details.add(detail);
					}
					//method ӿڷ
					requestInfo.put("method", "orderDetail");
					//dealTime ջʱ
					requestInfo.put("dealTime",new UFDateTime().toString());
					//dealUser ջ
					requestInfo.put("dealUser","");
					//dealUserId ջ˱ʶ
					requestInfo.put("dealUserId","");
					//interfaceType ӿ 1:֤ 2ջ 3˻
					requestInfo.put("interfaceType", hVO.getFreplenishflag().booleanValue()?"3":"2");
					//orderNo ƽ̨
					requestInfo.put("orderNo",orderNo);
					//reason 
					requestInfo.put("reason", "");
					//sendOrderNo 
					//Vdef25ƽ̨ 
					requestInfo.put("sendOrderNo",hVO.getVdef16());//Vdef25
					//sku Ʒ sku
					//num Ʒ
					requestInfo.put("details",details);
					
					String instId = "D91S008-WYOSP-1903-011-"+System.currentTimeMillis();
					sendJsonData = WyWGPTUtils.getSendToEsbData(instId, requestInfo);
					//
					JSONObject esbResultinfo = WyWGPTUtils.sendToESB(sendJsonData,"NC-WGPT-PU-001");
					if(esbResultinfo!=null){
						esbResultinfoStr = esbResultinfo.toString();
						Logger.error("ʱ֤ϢǷƽ̨һ¡"+sendJsonData+"\r\nز"+esbResultinfoStr);
						JSONObject esbInfo = (JSONObject)esbResultinfo.get("esbInfo");
						if(esbInfo!=null){
							//ӿڷ״̬Sɹ/W棩/E
							String returnStatus = esbInfo.get("returnStatus")+"";
							returnStatus = "E".equals(returnStatus)?"":"";
							if("".equals(returnStatus)){
								String returnMsg = esbInfo.get("returnMsg")+"";
								ExceptionUtils.wrappBusinessException("ӿڴ"+returnMsg);
							}
						}
						JSONObject resultInfo = esbResultinfo.getJSONObject("resultInfo");
						Object success = resultInfo.get("success");
						if(!"true".equals(success+"")){
							Object result = resultInfo.get("result");
							ExceptionUtils.wrappBusinessException("ƽ̨ʾ:"+result);
						}
					}
				}
			}
		} catch (Exception e) {
			Logger.error(e);
			e.printStackTrace();
			ExceptionUtils.wrappBusinessException("쳣\n"+e.getMessage()+"\nģ\n"+sendJsonData+"\nرģ\n"+esbResultinfoStr);
		}
	}
	
}
