/*
 * @(#)N_36K2_SAVEBASE.java 2012-3-9
 * Copyright 2010 UFIDA Software CO.LTD. All rights reserved.
 */
package nc.bs.pub.action;

import java.util.Hashtable;

import nc.bs.framework.common.NCLocator;
import nc.bs.logging.Logger;
import nc.bs.sf.allocate.AllocateBR;
import nc.bs.sf.allocate.AllocateBRNCC;
import nc.bs.sf.allocate.AllocateBankAccBR;
import nc.bs.sf.allocate.AllocateInnerAccBR;
import nc.bs.sf.allocate.busilog.AllocateEditBusiLog;
import nc.bs.sf.allocate.util.AllocateUtil;
import nc.bs.sf.delivery.util.GXDeliveryEventDispatcher;
import nc.bs.sf.pub.tbb.Sf4TbbControlBR;
import nc.itf.sf.allocate.IAllocateManageService;
import nc.itf.sf.pub.tbb.ISF4TbbConst;
import nc.pubitf.tmpub.util.SagasBizPubUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.compiler.PfParameterVO;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.pf.IPfRetCheckInfo;
import nc.vo.sf.allocate.AggAllocateVO;
import nc.vo.sf.allocate.AllocateBVO;
import nc.vo.sf.allocate.AllocateEncryptVO;
import nc.vo.sf.allocate.AllocateVO;
import nc.vo.sf.allocate.IAllocateConst;
import nc.vo.sf.allocate.util.AllocatePubUtil;
import nc.vo.sf.allocate.util.AllocateVOUtil;
import nc.vo.tmpub.proxy.TMPubServiceProxy;
import nc.vo.tmpub.util.ArrayUtil;
import nc.vo.tmpub.util.DateUtil;
import nc.vo.tmpub.util.StringUtil;
import nc.vo.tmpub.util.TMBillOrgVUtils;
import nc.vo.uap.pf.PFBusinessException;
import nccloud.pubitf.sf.allocate.AllocateSagaInfoAdapter;

/**
 * ²
 *
 * @author  chengfei
 * @version 1.0 2012-3-9
 * @since   NC6.1
 */
public class N_36K2_SAVEBASE extends AllocateDiffVOActionBase {
	private final java.util.Hashtable m_methodReturnHas = new java.util.Hashtable();
	private Hashtable m_keyHas = null;

	/**
	 * N_36K2_SAVEBASE ע⡣
	 */
	public N_36K2_SAVEBASE() {
		super();
	}

	/*
	 * עƽ̨д ӿִ
	 */
	@Override
	public AggAllocateVO runComClassImpl(PfParameterVO vo)
			throws BusinessException {

		try {
			super.m_tmpVo = vo;

			AggAllocateVO aggAllocateVO = (AggAllocateVO) this.getVo();	
			AggAllocateVO dbAggAllocateVO =  new AllocateBR().findAllocate(aggAllocateVO);
			//begin yangjn ӵݶУ
			if(aggAllocateVO.getHead().getPk_allocate_h() != null){
				//Ϊnull ˵ʱΪ޸״̬
				AllocateSagaInfoAdapter adapter = new AllocateSagaInfoAdapter();
				SagasBizPubUtil.checkFrozen(adapter, aggAllocateVO.getHead().getPk_allocate_h());
				
			}	
			//end
			this.setVo(aggAllocateVO);
			new Sf4TbbControlBR<AggAllocateVO>().writeTbbReadyData(
					dbAggAllocateVO,
					ISF4TbbConst.Direction_Negative,
					IAllocateConst.BillType_ALLOCATE);

			// ύҪԼ״̬Ϊύ̬У
			AllocateVO allocateVO = (AllocateVO) (aggAllocateVO).getParentVO();
			AllocateBVO[] allocateBVOs = (AllocateBVO[]) (aggAllocateVO).getChildrenVO();
			//ӱеֶ֯νиֵ  hanlua 2013-07-02
			for (AllocateBVO allocateBVO : allocateBVOs) {
				allocateBVO.setPk_org(allocateVO.getPk_org());
				allocateBVO.setPk_group(allocateVO.getPk_group());
			}
			int stroke = 0;
			for (AllocateBVO allocateBVO : allocateBVOs) {
				if (allocateBVO.getStatus() != VOStatus.DELETED) {
					stroke = stroke + 1;
				}
			}
			allocateVO.setStroke(stroke);
			
			allocateVO.setVbillstatus(IPfRetCheckInfo.NOSTATE);
			allocateVO.setBillstatus(IAllocateConst.BILLSTATUS_WAITCOMMIT);
		
			// ݿǰд׼²

			if (StringUtil.isNotNull(allocateVO.getDecideuser())) {
				AllocatePubUtil.setBillDateTimeByBusiDate(aggAllocateVO,
						AllocateVO.DECIDEDATE,
						new String[] { AllocateVO.DECIDETIME,
								AllocateVO.MODIFIEDTIME });
			}
			if (allocateVO.getSrcbusitype() != null
					&& allocateVO.getSrcbusitype().equals(
							IAllocateConst.SrcBusiType_Apply)) {
				new AllocateBR().writeAllocateAmount2AgreeBill(aggAllocateVO,
						true);
			}
			// ֯汾ƵΪҵ
			TMBillOrgVUtils.setOrgV(aggAllocateVO, allocateVO.getDbilldate());

			if (aggAllocateVO.getParentVO().getStatus() != VOStatus.NEW) {
				//xug ޸ǰ
				GXDeliveryEventDispatcher.getInstantiation("aa76ec14-f065-4394-885c-43f34f0c83c6").fireEvent("1003",aggAllocateVO);
				if (StringUtil.isNull(allocateVO.getDecideuser())) {
//					AllocatePubUtil.setBillDateTimeByBusiDate(aggAllocateVO,AllocateVO.ACCEPTDATE, new String[] { AllocateVO.DBILLTIME,AllocateVO.MODIFIEDTIME });
					String[] vls = new String[] {AllocateVO.DBILLTIME,AllocateVO.MODIFIEDTIME };
					if (!ArrayUtil.isNull(vls)) {
						UFDateTime currentTime = DateUtil.getCurrTime();
						for (String timeField : vls) {
							aggAllocateVO.getHead().setAttributeValue(timeField, currentTime);
						}
					}
				}

				allocateVO.setStatus(VOStatus.UPDATED);
				AllocateVOUtil.deleteEbankWrite(aggAllocateVO,dbAggAllocateVO);
				// Ƚ֤ǩ
				TMPubServiceProxy.getCaLogRecordService()
						.checkPerOperationCASignatureByVO(
								dbAggAllocateVO,
								AllocateEncryptVO.class);

				aggAllocateVO = getAllocateManageService()
						.addAllocateCaSignRecord(aggAllocateVO);

				// ö
				AllocateUtil.setBankCodeAndCheckSingleForEdit(aggAllocateVO);
				if(vo.isCloudEntry()) {
					aggAllocateVO = new AllocateBRNCC().saveAllocate(aggAllocateVO);
				}else {
					aggAllocateVO = new AllocateBR().saveAllocate(aggAllocateVO);
				}
				
				//Ǽ޸ҵ־
				new AllocateEditBusiLog().writeBusiLog(aggAllocateVO);
				//xug ޸ĺ
				GXDeliveryEventDispatcher.getInstantiation("aa76ec14-f065-4394-885c-43f34f0c83c6").fireEvent("1004",aggAllocateVO);
			} else {
				//xug ǰ
				GXDeliveryEventDispatcher.getInstantiation("aa76ec14-f065-4394-885c-43f34f0c83c6").fireEvent("1001",aggAllocateVO);			
//				AllocatePubUtil.setBillDateTimeByBusiDate(aggAllocateVO,AllocateVO.ACCEPTDATE, new String[] { AllocateVO.DBILLTIME,AllocateVO.CREATIONTIME });
				String[] vls = new String[] { AllocateVO.DBILLTIME,AllocateVO.CREATIONTIME };
				if (!ArrayUtil.isNull(vls)) {
					UFDateTime currentTime = DateUtil.getCurrTime();
					for (String timeField : vls) {
						aggAllocateVO.getHead().setAttributeValue(timeField, currentTime);
					}
				}
				if(vo.isCloudEntry()) {
					aggAllocateVO = getAllocateManageService().addAggAllocateVONCC(aggAllocateVO);
				}else {
					aggAllocateVO = getAllocateManageService().addAggAllocateVO(aggAllocateVO);
				}
				//xug 
				GXDeliveryEventDispatcher.getInstantiation("aa76ec14-f065-4394-885c-43f34f0c83c6").fireEvent("1002",aggAllocateVO);
			}
			// ֹ¼Ľڲ˻˴\
			new AllocateInnerAccBR()
					.writeInnerAccRealTimeBalance(dbAggAllocateVO,aggAllocateVO,-1);
			new AllocateBankAccBR().writeBankAccRealTimeBalance(dbAggAllocateVO,aggAllocateVO);
			new Sf4TbbControlBR<AggAllocateVO>().writeTbbReadyData(
					aggAllocateVO, ISF4TbbConst.Direction_Plus,
					IAllocateConst.BillType_ALLOCATE);
			

			return aggAllocateVO;
		} catch (Exception ex) {
			if (ex instanceof BusinessException)
				throw (BusinessException) ex;
			else
				throw new PFBusinessException(ex.getMessage(), ex);
		}
	}

	/**
	 * õʵֶ
	 * 
	 * @return
	 */
	public IAllocateManageService getAllocateManageService() {
		try {
			return (IAllocateManageService) NCLocator.getInstance().lookup(
					IAllocateManageService.class.getName());
		} catch (Exception ex) {
			Logger.error(ex);
			return null;
		}
	}

	/*
	 * עƽ̨дԭʼű
	 */
	@Override
	public String getCodeRemark() {
		return "	\n";
	}

	/*
	 * עýűHAS
	 */
	private void setParameter(String key, Object val) {
		if (m_keyHas == null) {
			m_keyHas = new Hashtable();
		}
		if (val != null) {
			m_keyHas.put(key, val);
		}
	}

}
