package nc.bs.pub.action;

import java.util.Hashtable;

import nc.bs.pub.compiler.AbstractCompiler2;
import nc.bs.sf.delivery.DeliveryBR;
import nc.bs.sf.delivery.DeliveryBankAccBookBR;
import nc.bs.sf.delivery.DeliveryInnerAccBookBR;
import nc.bs.sf.delivery.busilog.DeliveryEditBusiLog;
import nc.bs.sf.delivery.util.DeliveryUtil;
import nc.bs.sf.delivery.util.GXDeliveryEventDispatcher;
import nc.itf.sf.delivery.proxy.DeliveryServiceProxy;
import nc.pubitf.tmpub.util.SagasBizPubUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.compiler.PfParameterVO;
import nc.vo.pub.pf.IPfRetCheckInfo;
import nc.vo.sf.delivery.AggDeliveryVO;
import nc.vo.sf.delivery.DeliveryBVO;
import nc.vo.sf.delivery.DeliveryEncryptVO;
import nc.vo.sf.delivery.DeliveryVO;
import nc.vo.sf.delivery.IDeliveryConst;
import nc.vo.sf.delivery.util.DeliveryVOUtil;
import nc.vo.tmpub.proxy.TMPubServiceProxy;
import nc.vo.uap.pf.PFBusinessException;
import nccloud.pubitf.sf.delivery.DeliverySagaInfoAdapter;


/**
 * עյSAVE ݶִеĶִ̬Ķִ̬ࡣ
 *
 * ڣ(2011-2-23)
 *
 * @author ƽ̨ű
 */
public class N_36K4_SAVE extends AbstractCompiler2 {
	private final java.util.Hashtable m_methodReturnHas = new java.util.Hashtable();
	private Hashtable m_keyHas = null;

	/**
	 * N_36K4_SAVE ע⡣
	 */
	public N_36K4_SAVE() {
		super();
	}

	/*
	 * עƽ̨д ӿִ
	 */
	@Override
	public Object runComClass(PfParameterVO vo) throws BusinessException {
		try {
			super.m_tmpVo = vo;
			AggDeliveryVO aggvo = (AggDeliveryVO) this.getVo();			
			// ύҪԼ״̬Ϊύ̬У
			DeliveryVO deliveryVO = (DeliveryVO) (aggvo).getParentVO();
			// begin tm yangjn ݶУ
			if(deliveryVO.getPk_delivery_h() != null){
				DeliverySagaInfoAdapter adapter = new DeliverySagaInfoAdapter();
				SagasBizPubUtil.checkFrozen(adapter, deliveryVO.getPk_delivery_h());
			}
			//end
			deliveryVO.setVbillstatus(IPfRetCheckInfo.COMMIT);
			// õ״̬Ϊ
			deliveryVO
					.setBillstatus(IDeliveryConst.BILLSTATUS_WAITAPPROVE);
			//ӱֶ֯νиֵ   hanlua  2013-07-02
			DeliveryBVO[] deliveryBVOS = (aggvo).getItem();
			for(DeliveryBVO deliveryBVO :deliveryBVOS){
				deliveryBVO.setPk_org(deliveryVO.getPk_org());
				deliveryBVO.setPk_group(deliveryVO.getPk_group());
			}

			DeliveryBR br = new DeliveryBR();
			br.beforeSave(aggvo);
			if (aggvo.getParentVO().getStatus() != VOStatus.NEW) {
				//xug ޸ǰ ʽ 74d29f86-4334-4fc9-a7d3-085cf5dd7845
				GXDeliveryEventDispatcher.getInstantiation("74d29f86-4334-4fc9-a7d3-085cf5dd7845").fireEvent("1003",aggvo);
				
				DeliveryVOUtil.deleteEbankWrite(aggvo);
				new DeliveryInnerAccBookBR().deleteInnerAccRealBalance(aggvo);
				new DeliveryBankAccBookBR().deleteRecRealBankAcc(aggvo);
				// ʱȽ֤ǩ
				TMPubServiceProxy
						.getCaLogRecordService()
						.checkPerOperationCASignatureByVO(
								br.findDelivery(aggvo), DeliveryEncryptVO.class);

				// ǩ
				aggvo = br.addBillCaSignRecord(aggvo);
				DeliveryUtil.setBankCodeAndCheckSingleForEdit(aggvo);
				aggvo = new DeliveryBR().saveDelivery(aggvo);
				//¼޸ĵ־
				new DeliveryEditBusiLog().writeBusiLog(aggvo);
				//xug ޸ĺ
				GXDeliveryEventDispatcher.getInstantiation("74d29f86-4334-4fc9-a7d3-085cf5dd7845").fireEvent("1004",aggvo);

			} else {
				//xug ǰ
				GXDeliveryEventDispatcher.getInstantiation("74d29f86-4334-4fc9-a7d3-085cf5dd7845").fireEvent("1001",aggvo);
				aggvo = DeliveryServiceProxy.getDeliveryManageService().addAggDeliveryVO(aggvo);
				//xug 
				GXDeliveryEventDispatcher.getInstantiation("74d29f86-4334-4fc9-a7d3-085cf5dd7845").fireEvent("1002",aggvo);
			}
			// ҵҪڲ˻
			new DeliveryInnerAccBookBR().writeInnerRealBalance(aggvo);
			// ҵҪԤռ˺ʵʱ
			new DeliveryBankAccBookBR().writeRecBankAccRealBalance(aggvo, true);
			// ǳҵҪԤռλʵʱ
			// new DeliveryBankAccBookBR().writePayBankAccRealBalance(aggvo,
			// true);

			// ####ű뺬зֵ,DLGPNLзֵ####
			return aggvo;
		} catch (Exception ex) {
			if (ex instanceof BusinessException)
				throw (BusinessException) ex;
			else
				throw new PFBusinessException(ex.getMessage(), ex);
		}
	}

	/*
	 * עƽ̨дԭʼű
	 */
	@Override
	public String getCodeRemark() {
		return nc.vo.ml.NCLangRes4VoTransl.getNCLangRes().getStrByID("3632delivery_0","03632delivery-0115")/*@res "	//####ű뺬зֵ,DLGPNLзֵ####\n	Object retObj=null;\n"*/;
	}

	/*
	 * עýűHAS
	 */
	private void setParameter(String key, Object val) {
		if (m_keyHas == null) {
			m_keyHas = new Hashtable();
		}
		if (val != null) {
			m_keyHas.put(key, val);
		}
	}
}