package nc.net.uapbd.activity;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.regex.Pattern;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.parser.Feature;

public class ReceiveUtils {

	public static JSONArray convert2Array(JSONArray array) {
		List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
		List<JSONObject> objects = JSONArray.toJavaObject(array, ArrayList.class);
		objects.stream().map(
				x -> x.getJSONObject("CODEVALUE").getJSONArray("SPECIALITY").getJSONObject(0).getJSONArray("PROPERTY"))
				.forEach(x -> {
					Map<String, Object> every = new HashMap<String, Object>();
					x.forEach(y -> {
						JSONObject jsonObj = JSONObject.parseObject(y.toString());
						every.put(jsonObj.getString("PROPERTYCODE"), jsonObj.get("PROPERTYVALUE"));
					});
					list.add(every);

				});
		return Optional.ofNullable(list).map(x -> JSONObject.parseArray(JSONObject.toJSONString(x)))
				.orElseGet(JSONArray::new);
	}
	
	public static Map<String,Map<String,Object>> convert2MapExcludePsn(JSONArray array){
		
		Map<String, Map<String, Object>> map = new HashMap<String, Map<String, Object>>();
		List<JSONObject> objects = JSONArray.toJavaObject(array, ArrayList.class);
//		objects.stream().map(
//				x -> )
//				.forEach(x -> {
//					Map<String, Object> every = new HashMap<String, Object>();
//					x.forEach(y -> {
//						JSONObject jsonObj = JSONObject.parseObject(y.toString());
//						every.put(jsonObj.getString("PROPERTYCODE"), jsonObj.get("PROPERTYVALUE"));
//					});
//					list.add(every);
//				});
		objects.stream()
			.map(x -> new Object[] { x.getString("CODE"), x.getString("UUID"),
					x.getJSONObject("CODEVALUE").getJSONArray("SPECIALITY").getJSONObject(0).getJSONArray("PROPERTY")})
			.forEach(x->{
				Map<String, Object> every = new HashMap<String, Object>();
//				List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
				JSONArray foreach = (JSONArray) x[2];
				foreach.forEach(y -> {
					JSONObject jsonObj = JSONObject.parseObject(y.toString());
					every.put(jsonObj.getString("PROPERTYCODE"), jsonObj.get("PROPERTYVALUE"));
				});
//				list.add(every);
				JSONObject obj = new JSONObject();
				obj.put("code", x[0]);
				obj.put("uuid", x[1]);
				map.put(obj.toString(), every);
			});
		return map;
	}

//	public static JSONArray convert2Array(JSONArray array) {
	public static Map<String, Map<String, Object>> convert2Map(JSONArray array) {
		List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
		Map<String, Map<String, Object>> map = new HashMap<String, Map<String, Object>>();
//		Map<String,Object> map  = new HashMap<String,Object>();
//		 array.stream().forEach(x->{
//			JSONObject jsonObj = JSONObject.parseObject(x.toString());
//			map.put(jsonObj.getString("PROPERTYCODE"), jsonObj.get("PROPERTYVALUE"));
//		});
//		 list.add(map);

		// x->((JSONObject)(x.get(0))).getJSONObject("CODEVALUE").getJSONArray("SPECIALITY").getJSONObject(0).getJSONArray("PROPERTY")
		// 
//		 Stream.of(array).map(x->((JSONObject)(x.get(0))).getJSONObject("CODEVALUE").getJSONArray("SPECIALITY").getJSONObject(0).getJSONArray("PROPERTY"))
//		 .forEach(x->{
//			 Map<String,Object> every  = new HashMap<String,Object>();
//			 x.forEach(y->{
//				 JSONObject jsonObj = JSONObject.parseObject(x.toString());
//				 every.put(jsonObj.getString("PROPERTYCODE"), jsonObj.get("PROPERTYVALUE"));
//				 list.add(every);
//			 });		
//		 });
		List<JSONObject> objects = JSONArray.toJavaObject(array, ArrayList.class);
//		List list1 = objects.stream().map(x->x.getJSONObject("CODEVALUE").getJSONArray("SPECIALITY").getJSONObject(0).getJSONArray("PROPERTY")).collect(Collectors.toList());
//		List<JSONObject> objects1 = JSONArray.toJavaObject((JSONArray)list1.get(0), ArrayList.class);
//		for(JSONObject obj : objects1) {
//			
//		}
//		List<String[]> unique = objects.stream().map(x->new String[] {x.getString("CODE"),x.getString("UUID")}).collect(Collectors.toList());
		objects.stream().map(
				x -> x.getJSONObject("CODEVALUE").getJSONArray("SPECIALITY").getJSONObject(0).getJSONArray("PROPERTY"))
				.forEach(x -> {
					Map<String, Object> every = new HashMap<String, Object>();
					x.forEach(y -> {
						JSONObject jsonObj = JSONObject.parseObject(y.toString());
						every.put(jsonObj.getString("PROPERTYCODE"), jsonObj.get("PROPERTYVALUE"));
					});
					list.add(every);

				});

		objects.stream()
				.map(x -> new Object[] { x.getString("CODE"), x.getString("UUID"),
						x.getJSONObject("CODEVALUE").getJSONArray("SPECIALITY").getJSONObject(0)
								.getJSONArray("PROPERTY"),
						x.getJSONObject("MULTICODE").getJSONArray("VALUELIST") })
				.forEach(x -> {
					Map<String, Object> every = new HashMap<String, Object>();
					Map<String, Object> everyStation = new HashMap<String, Object>();
					List<Object> listStation = new ArrayList<Object>();
					Map<String, Object> psnAndstation = new HashMap<String, Object>();
					JSONArray foreach = (JSONArray) x[2];
					foreach.forEach(y -> {
						JSONObject jsonObj = JSONObject.parseObject(y.toString());
						every.put(jsonObj.getString("PROPERTYCODE"), jsonObj.get("PROPERTYVALUE"));
					});
					JSONArray stations = (JSONArray) x[3];
					stations.forEach(z -> {
						JSONObject jsonObj = JSONObject.parseObject(z.toString());
						Map<String, String> key = new HashMap<String, String>();
						key.put("LISTCODE", jsonObj.getString("LISTCODE"));
						key.put("SPECIALITYCODE", jsonObj.getString("SPECIALITYCODE"));
						everyStation.put(key.toString(), jsonObj);
						listStation.add(jsonObj);
					});
					psnAndstation.put("psn", every);
					psnAndstation.put("station", listStation);
					list.add(every);
					JSONObject obj = new JSONObject();
					obj.put("code", x[0]);
					obj.put("uuid", x[1]);
					map.put(obj.toString(), psnAndstation);

				});

		return map;

//		return Optional.ofNullable(list).map(x->JSONObject.parseArray(JSONObject.toJSONString(x))).orElseGet(JSONArray::new);

	}

	public static String responseMsg(String ifSuccess, String desc, String puuid, Map<String, Object> outlook) {

		String responseMsg = "{\r\n" + "	\"ESB\": {\r\n" + "		\"RESULT\": \"" + ifSuccess + "\",\r\n"
				+ "		\"DESC\": \"" + desc + "\",\r\n" + "		\"DATA\": {\r\n"
				+ "			\"DATAINFOS\": {\r\n" + "				\"PUUID\": \"" + puuid + "\",\r\n" +
//				"				\"DATAINFO\": [\r\n" + 
//				"					{\r\n" + 
//				"						\"CODE\": \""+code+"\",\r\n" + 
//				"						\"UUID\": \""+uuid+"\",\r\n" + 
//				"						\"SYNSTATUS\": \""+status+"\",\r\n" + 
//				"						\"SYNRESULT\": \""+result+"\",\r\n" + 
//				"						\"VERSION\":\""+version+"\"\r\n" + 
//				"					},\r\n" + 
//				"				]\r\n" + 
				"			}\r\n" + "		}\r\n" + "	}\r\n" + "}";

		JSONObject obj = JSONObject.parseObject(responseMsg, Feature.OrderedField);
		JSONArray array = new JSONArray();
		outlook.forEach((x, y) -> {
			if (x == null) {
				JSONObject every = new JSONObject();
				if (Pattern.matches(".*ɹ.*", (String) y) || "success".equals(y)) {
					every.put("SYNSTATUS", "0");
				} else {
					every.put("SYNSTATUS", "1");
				}
				every.put("CODE", null);
				every.put("SYNRESULT", y);
				every.put("UUID", null);
				array.add(every);
			} else {
				JSONObject contain = JSONObject.parseObject(x);
				JSONObject every = new JSONObject();
				if (Pattern.matches(".*ɹ.*", (String) y) || "success".equals(y)) {
					every.put("SYNSTATUS", "0");
				} else {
					every.put("SYNSTATUS", "1");
				}
				every.put("CODE", contain.getString("code"));
				every.put("SYNRESULT", y);
				every.put("UUID", contain.getString("uuid"));
				array.add(every);
			}
		});
		obj.getJSONObject("ESB").getJSONObject("DATA").getJSONObject("DATAINFOS").put("DATAINFO", array);

		return obj.toJSONString();
	}

}
